1993-05-30  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* Version 19.10 released.

1993-05-29  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): If we changed buffers during
	read_char, go to replay_sequence.

	* frame.c (Ficonify_frame, Fmake_frame_invisible): 
	Select some other frame.  Move minibuffer off this frame.

	* frame.c (Fhandle_switch_frame): Don't call Ffocus_frame.
	(Fredirect_frame_focus): Call Ffocus_frame here.

	* xterm.c (x_bitmap_icon): Don't free icon_bitmap;
	create it if it hasn't been created before.

	* xterm.c (XTread_socket): For UnmapNotify, if frame was visible,
	mark it now as iconified.
	(x_make_frame_invisible): If async_iconic, work does need to be done.
	Don't let this frame stay highlighted.
	(x_iconify_frame): Don't let this frame stay highlighted.

	* s/usg5-4-2.h (sigsetmask): #undef this.

	* sysdep.c (sys_signal): Use 0, not NULL, to set sa_flags.

1993-05-29  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* linux.h (C_OPTIMIZE_SWITCH): Set this to the empty string;
	configure guesses just fine.

	* tekXD88.h: New file, from Kaveh Ghazi.

	* systty.h (CDISABLE): #undef it before re-#defining it.

	* sysdep.c (sys_siglist): Comment out #endif trailer.
	* xmenu.c (TRUE, FALSE): Same.
	* xterm.c (dumprectangle): Same.

	* emacs.c: Don't include termios.h directly--let systty.h do it.

1993-05-29  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfaces.c [HPUX]: Include time.h and define __TIMEVAL__.

	* emacs.c (shut_down_emacs): Maybe close X connection.  New arg NO_X.
	(Fkill_emacs): Don't close it here.  Pass new arg.
	(fatal_error_signal): Pass new arg.
	* xterm.c (x_connection_closed): Pass new arg.

	* xdisp.c (syms_of_xdisp): Make highlight-nonselected-windows Lisp var.
	(display_text_line): Obey it.
	(display_text_line): Really check for just the selected window.

	* s/usg5-4-2.h: New file.

	* keyboard.c (menu_bar_items): Save Vinhibit_quit by hand
	instead of using specbind.
	(menu_bar_items): Call Fnreverse before restoring Vinhibit_quit.

	* s/hpux8.h (OLDXMENU_OPTIONS): Add quotations.

	* m/ibmrt.h (C_SWITCH_MACHINE): Define only if not __GNUC__.
	(HAVE_FTIME): Defined.
	(EMACS_BITMAP_FILES): Defined.

	* xfns.c (Fx_close_current_connection): Clear x_current_display.
	* xterm.c (XTring_bell): Do nothing if x_current_connection is 0.

	* buffer.c (reset_buffer): Clear mark_active field here.
	(reset_buffer_local_variables): Not here.
	(Fswitch_to_buffer, Fpop_to_buffer): Return the buffer.
	(Fmove_overlay): Fix data types in last change.

	* sysdep.c (gettimeofday): Don't store in *tzp if tzp is 0.

	* process.c (MAXDESC): Get it from FD_SETSIZE if that exists.

	* s/sco4.h (PTY_ITERATION, PTY_NAME_SPRINTF, PTY_TTY_NAME_SPRINTF): 
	Redefined.
	(SIGNALS_VIA_CHARACTERS): Defined.
	[HAVE_SOCKETS] (HAVE_GETTIMEOFDAY): Defined.
	(MAIL_PROGRAM_NAME): Defined (two alternate definitions).

	* xfns.c (Fx_list_fonts): Use CHECK_LIVE_FRAME on the frame arg.

1993-05-28  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/hpux8.h (LIBX11_SYSTEM): Defined.

	* ymakefile: Replace config.h as dep with $(config_h).
	(really-oldXMenu): Use two make vars to pass values
	of C_SWITCH_... within doublequotes.

	* xfns.c (x_figure_window_size): Never set PPosition or PSize.

	* keymap.c (syms_of_keymap): Create global_map 256 slots long.
	* cmds.c (keys_of_cmds): Predefined 0240-0376 as self-insert.

	* xterm.c (XTread_socket, case KeyPress) [HPUX]:
	Recognize the extended function keys.

	* buffer.c (Fgenerate_new_buffer_name): New arg IGNORE.
	(Frename_buffer): Pass new arg.

1993-05-28  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* keyboard.c (menu_bar_items): Bind Qinhibit_quit to Qt while we
	call the keymap accessors; this gets called during redisplay.

	* ymakefile (alloca.o): Call $(CC), not cc.

	* s/linux.h (SIGNALS_VIA_CHARACTERS): Try this out for a bit.

	* buffer.c (Fmove_overlay): If the overlay is changing buffers,
	do a thorough redisplay.

	* xfns.c (x_set_frame_parameters): Use the first
	position/size parameter we find, not the last.

	* s/hpux8.h: Don't define HAVE_RANDOM.

	* config.h.in (UNEXEC_SRC): New macro, set by the configure
	script.
	* ymakefile (UNEXEC_SRC): Give it a default value here, and make
	UNEXEC depend on it.

	* ymakefile (lispdir): Set this in terms of ${srcdir}.

1993-05-27  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* dispnew.c (Fsleep_for): Don't return without waiting when SEC is 0.

	* emacs.c (syms_of_emacs) [CANNOT_DUMP]: Don't defsubr Sdump_emacs*.

	* alloc.c (mark_object): Add debugging code to check for ptr clobbered.

1993-05-27  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* Version 19.9 released.

1993-05-27  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_char): Correct previous change.

1993-05-27  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* systty.h: Always terminate comments, to avoid confusion.

	* xfns.c: Make resource manager work correctly even when
	Vinvocation_name has periods and asterisks in it.
	(Vxrdb_name): New variable.
	(Fx_get_resource): Use it instead of Vinvocation_name.
	(Fx_open_connection): Initialize it to a copy of Vinvocation_name,
	with the dots and stars replaced by hyphens.
	(syms_of_xfns): staticpro it here.

	* xfns.c (Fx_get_resource): Use the proper format string when the
	attribute has been specified.

1993-05-27  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (x_get_resource_string): New function.

	* ymakefile (ALL_CFLAGS): Put CFLAGS last.

1993-05-26  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* s/sol2.h: (SOLARIS_BROKEN_ACCESS): Don't define this.

	* s/aix3-2.h (C_SWITCH_SYSTEM): Don't define this to be "-ma" if
	we're using GCC - that's an XLC switch.

	* s/aix3-2.h (LIBS_SYSTEM): Put -LIM -Liconv here.

	* systty.h (HAVE_LTCHARS, HAVE_TCHARS): New macros; define them if
	we have those structures, but *don't* define them if we have
	TERMIOS, whose functions take care of those parameters; that
	screws up AIX.
	(struct emacs_tty): Test those symbols, instead of the ioctl
	commands.
	* sysdep.c (emacs_get_tty, emacs_set_tty, new_ltchars, new_tchars,
	init_sys_modes): Same.

	* config.h.in (HAVE_RENAME): Include an #undef for this, so
	configure will have something to edit.

1993-05-26  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* window.c (window_loop, case GET_LRU_WINDOW):
	Get frame's width properly.

	* xselect.c (x_get_local_selection): If no conversion function
	exists for the requested type, just return nil.

	* s/linux.h (HAVE_TCATTR): Defined.

	* sysdep.c [HAVE_SOCKETS]: Include socket.h, netdb.h.
	(get_system_name) [HAVE_SOCKETS]: Use gethostbyname.

1993-05-26  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* s/hpux8.h (LIB_X11_LIB, C_SWITCH_SYSTEM, LD_SWITCH_SYSTEM,
	LD_SWITCH_SYSTEM, OLDXMENU_OPTIONS): Add X11R5 directories to the
	search paths in these lists; they shouldn't do any harm if they
	don't have X11R5.

	* s/aix3-2.h (C_SWITCH_SYSTEM): Don't #define this if we're using
	GCC.

1993-05-26  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xrdb.c (magic_searchpath_decoder): Fix typos.

	* xdisp.c (display_text_line): Don't call compute_char_face
	for a non-X frame.

	* xfns.c (Fx_rebind_key, Fx_rebind_keys): X10 definitions deleted.
	(syms_of_xfns): Install them only if X11.

	* ralloc.c (r_alloc_sbrk): Declare already_available as long, not SIZE.

	* xfns.c (x_set_cursor_type): If arg not recognized, use box cursor.

	* s/hpux8.h (LD_SWITCH_SYSTEM) [__GNUC__]: Pass -a archive to ld.
	(HAVE_RANDOM): Defined.

	* s/hpux.h (rand, srand): Definitions deleted.

	* keyboard.c (Fcurrent_input_mode): Fix the call to Flist.
	(make_lispy_event): Fix off-by-1 error with hpos in menu bar.

	* s/sunos4-1-3.h: New file.

	* ymakefile (XOBJ) [!HAVE_X_MENU]: Add xfaces.o.

	* s/irix4-0.h (SIGNALS_VIA_CHARACTERS): Defined.

	* xterm.c (x_wm_set_size_hint): Don't set hints for max size.

1993-05-25  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* m/ibmrs6000.h (LIBS_MACHINE): Add -lIM and -liconv.
	(HAVE_GETTIMEOFDAY): Deleted.

	* sysdep.c (wait_for_termination): Don't use the BSD alternative
	for LINUX.  Use the UNIPLUS alternative.

	* keyboard.c (read_char): If kbd_buffer_get_event returns nil,
	redisplay and retry.
	(kbd_buffer_get_event): If event is handled here, return nil.
	(swallow_events): New function.
	* process.c (wait_reading_process_input): Call that.

	* ralloc.c (POINTER): Always use char *.

	* s/sol2.h (C_SWITCH_X_SYSTEM): Deleted.
	(LD_SWITCH_SYSTEM): Delete the -L option, leave just -R.

	* m/symmetry.h (PTY_TTY_NAME_SPRINTF, PTY_NAME_SPRINTF):
	Use pty_name, not ptyname.

	* syntax.c (Fforward_comment): Arg is a Lisp_Object.
	Convert it to an int.

	* ymakefile (alloca.o): Get alloca.c and alloca.s from ${srcdir}.

	* floatfns.c (logb): Don't declare if hpux.

	* syntax.c (Fforward_comment): Always set point.

	* s/dgux.h, s/hpux.h, s/esix.h (HAVE_GETTIMEOFDAY): Deleted.

	* s/irix4-0.h (C_ALLOCA, alloca): Definitions deleted.
	[!NOT_C_CODE]: Include alloca.h.
	(NEED_SIOCTL): #undef this.

	* xterm.h (PIXEL_TO_CHAR_COL, PIXEL_TO_CHAR_ROW):
	Fix mismatch in arg names.

	* xfns.c (Fx_open_connection): Set xrm_option correctly.

1993-05-25  David J. MacKenzie  (djm@wiki.eng.umd.edu)

	* xfns.c (x_figure_window_size): Make the default frame coords (0,0).

1993-05-25  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* Version 19.8 released.

1993-05-25  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xfns.c: Clear out the old face stuff.
	(x_face_table, n_faces, x_set_face, x_set_glyph, Fx_set_face_font,
	Fx_set_face, Fx_get_face): Removed.
	(syms_of_xfns): Remove defsubr for Fx_set_face.

	Arrange for font names to get fully resolved - no wildcards.
	* xfns.c (x_set_frame_parameters): Store the value in the frame
	parameter alist before we call the setter function, so the setter
	function can touch up the value if it chooses.
	(x_set_foreground_color, x_set_background_color): Call
	recompute_basic_faces, so their GC's will reflect the changes.
	(x_new_font): Add extern declaration - this returns a Lisp_Object
	now, the fully resolved font name.
	(x_set_font): Accept the fully resolved name from x_new_font, and
	put it in the frame's parameter alist.  Call recompute_basic_faces.
	* xterm.c (x_new_font): Return the fully resolved font name, Qnil
	(if no match), or Qt (match, but unacceptable metrics).
	* xterm.c (x_new_font): Don't call init_frame_faces.

	* xterm.h: New section for declarations for xfaces.c.
	(init_frame_faces, free_frame_faces, intern_face,
	face_name_id_number, same_size_fonts, recompute_basic_faces,
	compute_char_face, compute_glyph_face): Declare these here.
	* xfaces.c (same_size_fonts): We can now remove this extern
	declaration.
	* xfns.c (face_name_id_number): Likewise.
	* xterm.c (intern_face): Likewise.

	* xterm.c (dumpglyphs): Remember that the default faces can have
	null fonts, too.

	* xfns.c (Fx_list_fonts): Remember that FACE may not have a font
	specified.  Don't specify 30000 as the maximum limit on the number
	of fontns returned  - 2000 is more reasonable. 

	* xfaces.c (build_face, unload_font, free_frame_faces): Don't
	forget to block input while making X calls.

	Treat faces as structures specifying modifications to the frame's
	parameters, rather than things which need to specify a complete
	set of parameters by themselves.
	* xfaces.c (init_frame_faces): Don't set up the two frame display
	faces by querying the GC - just leave all their fields blank, and
	call recompute_basic_faces, letting build_face do the work of
	consulting the frame when necessary.
	(recompute_basic_faces): New function.
	(compute_base_faces): New function for obtaining the "identity"
	for compute_char_face and compute_glyph_face.
	(compute_char_face, compute_glyph_face): Call it, instead of copying
	FRAME_DEFAULT_FACE.
	* xfns.c (x_make_gc): No need to call init_frame_faces here.

	* xfaces.c (intern_frame_face): This can be static.

	* dispextern.h (struct face): New field - `copy', to help us with
	resource allocation.
	* xfaces.c (free_frame_faces): Do free the first two faces; don't
	free anything from a face that's a copy.
	(intern_frame_face): Mark every face we intern as a copy; its
	resources are actually a combination of the real faces.
	(Fset_face_attribute_internal): No need to check if we're trying
	to free one of the frame's GC's; they never enter into the
	picture.

	* casetab.c: Fix formatting, so as not to confuse etags.

	* xfns.c (Fx_list_fonts): New function.
	(face_name_id_number): Add extern declaration for this.
	* xfaces.c (face_name_id_number): Make this externally visible,
	and make the FRAME argument a FRAME_PTR, not a Lisp_Object.
	(compute_char_face): Call face_name_id_number properly.

	* xfaces.c (unload_color): Don't free the pixel for now.

	* xfaces.c (merge_faces): You can't tell if a font is a
	character-cell font or not by testing whether or not it has a
	per_char table.  They all do.
	* xterm.c (x_new_font): Same deal.
	* xfns.c (Fx_list_fonts): Same deal.

	* m/iris4d.h: Dyke out the section which specifies how to get the
	load average.

	* paths.h (PATH_INFO): New path, to edited by the configuration
	process.
	* callproc.c (Vconfigure_info_directory): New variable, used
	internally by build process.
	(syms_of_callproc): DEFVAR it and initialize it.

	* keyboard.c (Fcurrent_input_mode): Use XFASTINT to build the last
	element of the return value, not XSETINT.

1993-05-24  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	Changes for OSF/1:
	* mem-limits.h [__osf__ && (__mips || mips)]: #include
	<sys/time.h> and <sys/resource.h>.
	(get_lim_data): OSF wants a definition like BSD4_2's.
	* s/osf1.h: #include "bsd4-3.h", not "s-bsd4-3.h".

	* ymakefile (LIBX): Put LD_SWITCH_X_SITE before the libraries, so
	it actually has an effect.

	Some makes can't handle form feed characters in their makefiles.
	* s/usg5-3.h: Remove form feed.
	* s/template.h, m/template.h: Remove form feeds.

	* xfns.c (select_visual): Include the screen number in the
	template of things XGetVisualInfo must match.

1993-05-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/dgux.h (NO_GET_LOAD_AVG): Test _M88KBCS_TARGET, not __GNUC__.

	* xterm.c (XTread_socket, ConfigureNotify case):
	Convert from parent window, not Emacs window.
	(XTread_socket): Handle ReparentNotify events.

	* m/i860.h: New file.

	* keyboard.c (lispy_function_keys): Add kp-numlock.  Fix kp-backspace.

1993-05-24  Thorsten Ohl  (ohl@chico.harvard.edu)

	* m/next.h (C_SWITCH_MACHINE): Definition deleted.

	* lread.c: Don't #undef NULL.

1993-05-24  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* buffer.c (Fmake_overlay): Put beg and end in the
	right order.
	(Fmove_overlay): If beg and end are markers, make sure they're in
	the right buffer.

1993-05-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (modify_event_symbol): If a name_table elt is null,
	generate a name to use.  Don't crash.

	* fileio.c (Fread_file_name): If input is empty, do return the default
	even if !insert_default_directory.

	* xterm.c (XTread_socket): For ConfigureNotify event,
	translate coordinates if send_event field is false
	provided the x-coord value is not large.

1993-05-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/irix4-0.h (NO_MATHERR): Defined.
	* floatfns.c [NO_MATHERR]: Undef HAVE_MATHERR.

1993-05-24  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* fileio.c (Ffile_writable_p): Pass XSTRING (foo)->data to
	ro_fsys, not XSTRING (foo).

	* xterm.c (x_new_font): Reject fonts with varying spacing.  We
	don't support them yet.
	* xfns.c (x_set_font): Report the error message properly.

	* xfns.c (Fx_parse_geometry): No need to call check_x here; it
	doesn't interact with the server at all, and we need it in order
	to create our first frame.

1993-05-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/linux.h (HAVE_SETSID): Defined.
	(HAVE_SOCKETS): Defined.

	* process.c (create_process): Ignore retval from TIOCSTTY.
	(sys_siglist) [LINUX]: Don't even declare it.

1993-05-24  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* syssignal.h (sys_signal): Declare the second argument to have
	type signal_handler_t.  We're told this is necessary for Linux.

1993-05-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/dgux.h (NO_GET_LOAD_AVG): Define, if __GNUC__.

1993-05-23  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* s/hpux8.h (NO_SIOCTL_H): Defined.

1993-05-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/linux.h (HAVE_DUP2, HAVE_ALLOCA_H): Deleted.

1993-05-23  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* syssignal.h: Don't #include <signal.h>
	* alloc.c: #include <signal.h>, but before "config.h".

1993-05-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfaces.c (Fset_face_attribute_internal): Don't call unload_font
	for the frame's own font.

	* xfns.c (check_x): New function.
	Call it in almost every Lisp function in this file.
	(x_set_menu_bar_lines_1): Pass both args in recursive call.

1993-05-23  Paul Eggert  (eggert@twinsun.com)

	* editfns.c (Fcurrent_time_zone): Make `am' an int, not long.

1993-05-23  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	Changes for SGI from Matthew J Brown <mjb@doc.ic.ac.uk>.
	* m/iris4d.h, m/iris5d.h: Don't use the --cckr CC switch if we're
	using GCC.
	* m/iris4d.h (NEED_SIOCTL): Move this to...
	* s/irix3-3.h (NEED_SIOCTL): ... here; apparently it's not
	necessary in irix4-0.h.
	* s/irix4-0.h: Remove declaration of getpty; apparently Irix 4.0
	already declares this elsewhere.
	(PTY_TTY_NAME_SPRINTF): #undef this before re-#defining it.
	* m/ibmps2-aix.h, m/pfa50.h, s/hpux.h, s/isc2-2.h, s/linux.h,
	s/sco4.h, s/usg5-4.h: Remove HAVE_RENAME; configure guesses that now.

	* config.h.in (LD_SWITCH_X_SITE, C_SWITCH_X_SITE): Change the
	#defines to #undef's, so ../configure knows it should tweak them.

	* xterm.c (x_scroll_bar_report_motion): Set *TIME whether or not
	the mouse is over a scroll bar.

	* xfaces.c (Fset_face_attribute_internal): Don't free the frame's
	normal_gc or reverse_gc.

        * keyboard.c (make_lispy_movement): Deal properly with mouse
	motion outside of all windows.

	* lisp.h (GLYPH_FACE): Remember that the face portion of a glyph
	can be 24 bits, not just eight.

1993-05-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xterm.c: Move signal.h and stdio.h before config.h.

	* editfns.c (Fcurrent_time_zone): Assign gmt, instead of init.

1993-05-22  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

        * Version 19.7 released.

	* Makefile.in (SUBMAKEFLAGS): Add CFLAGS to the list.

	* puresize.h [not HAVE_X_WINDOWS] (PURESIZE): Make this 185k,
	not 196k.  We're actually using ~180k.

	* editfns.c: #include <sys/types.h>, to get time_t for Eggert's
	changes.

1993-05-22  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (FRAME_SUPPORT): Add mouse.elc, select.elc, scroll-bar.elc.

	* xdisp.c (display_text_line): Highlight in any frame's sel window.

	* keyboard.c (modifier_names): Update to match *_modifier in termhooks.

1993-05-22  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* xterm.c (x_scroll_bar_handle_click): Never grab the scroll bar;
	that feature requires more support to work correctly.

	* keyboard.c (make_ctrl_char): New function.
	(read_char): Call it.
	(kbd_buffer_store_event): Call it to see if the new character is
	the quit or stop character.
	(make_lispy_event): Call it.

1993-05-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (x_window_to_frame): Use XGCTYPE.

1993-05-21  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* process.c (Fopen_network_stream): Deal with older systems, which
	only have the h_addr field in their struct hostent.

	* systty.h [SYSV_PTYS]: #include <sys/types.h>.  Francesco
	Potorti` <pot@fly.CNUCE.CNR.IT> says it's necessary on his
	machine, and it should be harmless.

1993-05-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* sysdep.c (wait_for_termination): Copy code from 18.59
	(but sans BSD4_1 alternatives).

1993-05-21  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* ymakefile (alloca.o): #define malloc and free to be xmalloc and
	xfree on the command line of this compilation.

	* s/sco4.h: (TIME_WITH_SYS_TIME): This is no longer needed.

	* s/linux.h: Remove copyright notices by Michael K. Johnson and
	Rik Faith.  They have both sent in papers now which make their
	changes public domain.

	* sysdep.c (sys_suspend): Set synch_process_alive, so that
	wait_for_termination has something to wait for.

1993-05-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c (display_text_line): Highlight only in selected window.

	* xfns.c (syms_of_xfns): Don't make Lisp vars
	x-mode-pointer-shape and x-nontext-pointer-shape.

1993-05-20  Ian Lance Taylor  (ian@cygnus.com)

	* s/sco4.h (SCO): Don't define (no longer needed).
	(HAVE_SYS_TIME_H): Don't define (set by configure).
	(TIME_WITH_SYS_TIME): Define.

1993-05-20  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* dispnew.c (preserve_other_columns): Remember to multiply the
	size argument to bcopy by the size of a glyph.

1993-05-20  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): Reexamine this_command
	after pre-command-hook runs.

	* xterm.c (x_find_modifier_meanings): If some keys are meta and alt,
	make them just meta, not alt.

1993-05-19  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	Some time-handling patches from Paul Eggert:
	* editfns.c (Fcurrent_time_zone): Take an optional argument specifying
	what (absolute) time should be used to determine the current time zone.
	Yield just offset and name of time zone, including DST correction.
	Yield time zone offset in seconds, not minutes.
	(lisp_time_argument, difftm): New functions.
	(Fcurrent_time_string): Use lisp_time_argument.
	* systime.h (EMACS_CURRENT_TIME_ZONE, EMACS_GET_TZ_OFFSET,
	EMACS_GET_TZ_NAMES): Remove.
	* config.h.in: Add HAVE_TM_ZONE.

	Some more changes from Michael K. Johnson for Linux.
	* s/template.h: Mention that you should #define HAVE_TERMIO or
	HAVE_TERMIOS, but not both, and that HAVE_TERMIOS is preferred.
	* systty.h (EMACS_SET_TTY_PGRP): Don't assign the return value of
	tcsetpgrp to *pgid; it's just a status value.
	* config.h.in (HAVE_RANDOM): This shouldn't be defined on Linux
	systems using XFree386, and perhaps is inappropriate in general.
	* m/intel386.h: #undefine the integer size macros, since the Linux
	<values.h> file #defines them itself.
	* mem-limits.h (get_lim_data): Linux has the ulimit call; if it
	fails, fall back on ULIMIT_BREAK_VALUE.
	* process.c: Linux needs the WAITTYPE, etc. definitions.
	* unexec.c (hdr, ohdr): Linux has the ordinary `struct exec' type;
	no need to use SYSV names.
	* s/linux.h: New file.

	Some changes from Michael K. Johnson for Linux.
	* sysdep.c (sys_siglist): Don't define this if HAVE_SYS_SIGLIST is
	#defined.  That lets the system provide it, if it has it.
	* syssignal.h (sigmask): Only define this if <signal.h> hasn't
	given us a definition already.
	* syssignal.h (sys_sigpause): Fix argument in prototype.
	* sysdep.c (init_signals): The masks are called empty_mask and
	full_mask, not signal_empty_mask and signal_full_mask.
	(signal_handler_t): Moved ....
	* syssignal.h: ... to here.
	* systty.h (EMACS_SET_TTY_PGRP): Call tcsetpgrp with the correct
	arguments.
	* emacs.c (main): Don't try to establish signal handlers for
	SIGBUS and SIGSYS unless they're actually #defined.

	* systty.h [HAVE_TERMIO, __DGUX]: #include <sys/ioctl.h>.

	* xdisp.c (redisplay_window): Compute the scrollbar start and end
	properly.

1993-05-19  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Fcurrent_input_mode): Return META as 3-way flag.

1993-05-19  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* fileio.c (Ffind_file_name_handler): Check that FILENAME is a
	string.

	* process.c (wait_reading_process_input): Undo change of April
	29th, since that re-introduces the race condition the comments are
	warning about.  Call clear_waiting_for_input before calling
	status_notify, though.

	* process.c (wait_reading_process_input): Don't forget to call
	clear_waiting_for_input when we exit the loop because process
	input has arrived.

        Changes for Silicon Graphics Iris 5D.
	* unexelfsgi.c: New file; like unexelf.c, but tolerates program
	segments above BSS. 
	* m/iris5d.h: New file.
	* s/irix5-0.h: New file.
	* process.c [__sgi] (allocate_pty): Give up immediately if pty is
	inaccessible.

1993-05-19  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (follow_key): Check char in range before UPPERCASEP.

1993-05-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (x_set_menu_bar_lines): Fix typo in last change.

	* keyboard.c (make_lispy_event): Controlify lower case letters too.

1993-05-18  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xdisp.c (display_text_line): If the newline (or C-m, in
	selective-display) has a non-default face, apply that face to the
	remainder of the line, so that the fill occupies the entire line.

	* xterm.c (x_new_font): Tell the frame display faces about the
	newly chosen font.

	Make sure that all the display faces use fonts of the
	same dimensions as the default face, so as not to confuse the rest
	of the redisplay code.
	* xfaces.c (same_size_fonts): New function.
	(merge_faces): Only merge in a new font from the FROM face if it
	is the same size as the font in the TO face.

	* xfns.c (x_set_menu_bar_lines): Minibuffer-only frames can't have
	menu bars.

	* keyboard.c (read_key_sequence): Don't lay down an unwind_protect
	to restore the original buffer until we actually get a mouse click.

	* window.c (window-dedicated-p): Doc fix.

1993-05-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xterm.c (XTread_socket): Turn off ControlMask for XLookupString.
	* keyboard.c (make_lispy_event): Controlify here.

1993-05-17  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xdisp.c (redisplay_window): Make the scrollbar reflect the
	extent of the visible region, not the whole buffer.

	* xfaces.c (free_frame_faces): Don't free the resources from the
	first two faces.

	* lisp.h (malloc, realloc): Declare these to return void *, to
	avoid conflicts with ANSI header files.

	* sysdep.c (reset_sys_modes): Test the return value of
	EMACS_SET_TTY properly.
	* systty.h (EMACS_GET_TTY, EMACS_SET_TTY): Document the return
	values.

1993-05-16  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* config.h.in (STDC_HEADERS, TIME_WITH_SYS_TIME,
	CRAY_STACKSEG_END, STACK_DIRECTION): Add #undef clauses for these,
	since otherwise the autoconf tests in configure.in won't do us
	much good.

1993-05-16  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* buffer.c (overlays_at): New arg EXTEND.
	(Foverlays_at, Fnext_overlay_change): Pass 1.
	* xfaces.c (compute_char_face): Pass 0.
	Try first with small overlay_vec, then use a big enough one.

	* lread.c (syms_of_lread): Make Vcurrent_load_list ordinary Lisp var.
	Set up Qcurrent_load_list.
	(readevalloop): Specbind Qcurrent_load_list instead of ad-hoc saving.
	(build_load_history): Do nothing when loading pure files.

	* xterm.c (dumpglyphs): Create a temporary merged gc
	when cursor falls on char with non-default face.

	* xterm.h (x_display): New field cursor_foreground_pixel.
	* xfns.c (x_set_cursor_color): Set cursor_foreground_pixel.

	* casefiddle.c (casify_region): Remove mistaken arg to record_change.

1993-05-15  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* xfaces.c (Fset_face_attribute_internal): Jolt redisplay, so it
	knows something has changed.

	* xfaces.c (unload_color): Don't try to unload the standard black
	or white pixel.

	More changes from David Mackenzie.
	* ymakefile (emacs): No need to edit srcdir into a lisp file and
	then load it; we can just take advantage of the PATH_DUMPLOADSEARCH.
	(crt0.o): Remember that crt0.c is in ${srcdir}.

        Install David Mackenzie's patches to make ${srcdir} work.
	* Makefile.in (srcdir, VPATH): Get this value from the top-level
	Makefile.
	(xmakefile): Use ${srcdir} to find the files from which we produce
	xmakefile.  Edit the values for srcdir and VPATH into xmakefile.
	* ymakefile (srcdir, VPATH): New definitions for the Makefile
	to edit.
	(ALL_CFLAGS): Remove `-Is' and `-Im'; add `-I${srcdir}', and
	`-I.'.
	(emacs): Adjust dumping commands to deal with a separate source
	directory.
	(${etc}DOC): Pass `-d ${srcdir}' to make-docfile, to tell it where
	to find the source files.
	(prefix-args): Find the source code in ${srcdir}.

	* process.c (wait_reading_process_input): If we're running
	Solaris, it's not necessary to check if we should redeliver SIGIO,
	according to David Mackenzie.
	* s/sol2.h: #include "usg5-4.h", and #define const.

	* systime.h: Borrow CPP sequence from getdate.y to include the
	proper combination of <time.h> and <sys/time.h>.

1993-05-15  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* window.h (struct window): New slot region_showing.
	* xdisp.c (mark_window_display_accurate): Set region_showing fields.
	(redisplay_window): Update region_showing field.
	(display_text_line): Set region_showing to t if will show one.

	* xselect.c (Fx_selection_exists_p): Handle nil, t as SELECTION arg.
	Don't die if SELECTION is not recognized.

	* dispnew.c (direct_output_forward_char): Just give up
	if region is being highlighted.

	* xdisp.c (redisplay, redisplay_window): Don't use the cursor-motion
	special-case code if the region is or was highlighted.
	
	* xfaces.c (compute_char_face): New args REGION_BEG, REGION_END.
	Don't sort if noverlays is 0 or 1.

	* dispnew.c (direct_output_for_insert): Pass those args.
	* xdisp.c (display_text_line): Pass those args,
	describing the region if the mark is transient and active.

1993-05-14  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* buffer.c (Fmove_overlay): If the overlay is in no buffer and the
	BUFFER argument has been omitted, put it in the current buffer,
	for symmetry with move-marker.

	* buffer.c (Fdelete_overlay): Make the overlay's markers point
	nowhere, not at 1.  Do this after calling redisplay_region, so
	that code knows what section has changed.

1993-05-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c (display_menu_bar): Update FRAME_MENU_BAR_ITEMS here.
	* keyboard.c (command_loop_1): Don't do it here.

	* keymap.c (access_keymap): Handle any length vector.
	(store_in_keymap): Likewise.
	(Fcopy_keymap): Likewise.

1993-05-14  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* buffer.c (Foverlay_start, Foverlay_end, Foverlay_buffer,
	Foverlay_properties): Functions moved here from subr.el.

1993-05-13  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xfaces.c (compute_char_face): When merging the overlays,
	traverse sortvec, not overlay_vec; the latter isn't the one we
	sorted.

	* xterm.c (dumpglyphs): Give the cursor higher priority than the
	face specified by the glyph under it.

	* xterm.c (dumpglyphs): Move the underline up a row.  I dislike
	the way X addresses pixels.  Quickdraw is much nicer.

	* xfaces.c (intern_face): If the face has a GC, but it's not the
	default or modeline face, abort.  Nothing but those two faces
	should have a GC *and* be passed to intern_face.
	(compute_char_face, compute_glyph_face): After copying
	the frame's default face into face, to use as a base case for
	calculation, set the `gc' member to zero; that way we don't have
	things lying around that look like display faces but aren't.

	* xfaces.c (intern_frame_face): When copying the new face into the
	frame's face array, remember that the number of bytes to copy is
	sizeof (*new_face), not sizeof (new_face).

	* xfaces.c (compute_char_face): Assume that W is displaying the
	current buffer.  Abort if it isn't.

	* lisp.h (Lisp_Overlay): New tag.
	(OVERLAYP): New predicate.
	(CHECK_OVERLAY): New type-checker.
	(Qoverlayp): New extern declaration.
	* buffer.c (Foverlayp): New function.
	(Qoverlayp): New atom.
	(overlays_at, recenter_overlay_lists): Abort if we encounter an
	invalid overlay.
	(syms_of_buffer): defsubr Soverlayp; initialize Qoverlayp.
	(Fdelete_overlay): Set the overlay's markers to point nowhere.
	Use CHECK_OVERLAY instead of signalling a special error.
	(Fmove_overlay, Foverlay_put): Use CHECK_OVERLAY instead of
	signalling a special error.
	(Foverlay_get): Use CHECK_OVERLAY.
	* fns.c (internal_equal): Define this for overlays.
	* buffer.h (OVERLAY_VALID): Define in terms of OVERLAYP.
	* print.c (print): Give overlays their own print syntax.
	* alloc.c (mark_object): Treat overlays like conses.

	* lisp.h (FLOATP): Define this appropriately when LISP_FLOAT_TYPE
	is not defined.

	* buffer.c (Foverlay_get): Return Qnil if the requested property
	is missing from the property list.

        The text property routines can now modify buffers other
	than the current one.
	* insdel.c (modify_region): New argument BUFFER.  Select that
	buffer while we prepare for the modification, and switch back when
	we're done.
	* textprop.c (add_properties, remove_properties): Pass
	the buffer being modified as the first argument to modify_region.
	* editfns.c (Fsubst_char_in_region, Ftranslate_region): Pass the
	current_buffer as the first argument to modify_region.
	* casefiddle.c (casify_region): Same.

	* dispnew.c (direct_output_for_insert): Compute the face of the
	character we're inserting properly.

	* xterm.c (dumpglyphs): Pass the proper arguments to intern_face.

	* xterm.c (dumpglyphs): Don't increment left twice.

	* intervals.c (set_point): Check for point out of bounds before
	checking for an empty interval tree. 

	* cmds.c (Fforward_char): Check proposed new position, and then
	set point, instead of setting point to a potentially invalid
	position.

	* lread.c, data.c: If STDC_HEADERS is #defined, include <stdlib.h>
	to get the extern declarations for atof.  That's where it is in
	POSIX.

1993-05-12  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

        * ymakefile (xfaces.o): Add window.h to the dependencies.

	* xfaces.c (intern_frame_face): Exchange order of arguments, to
	make callers correct.

	* xfaces.c (compute_char_face): Notice the next property change
	location correctly.

	* xfaces.c (face_name_id_number): Return 0 (the default face) if
	the name is undefined.

	* xfaces.c (Fset_face_attribute_internal): Do nothing unless FRAME
	is an X frame.

	* xdisp.c (copy_rope, copy_part_of_rope): Add face argument.
	(display_text_line): Initialize current_face to zero.   Apply it
	to characters as we write them to the display matrix.
	(display_string): Pass the new argument to copy_rope.

	* xdisp.c (display_text_line): Handle the locations of face
	changes properly.

	* textprop.c (Fnext_single_property_change,
	Fprevious_single_property_change): Pass arguments to textget in
	the right order.

	* ymakefile (xfns.o): Remove duplication of buffer.h in dependencies.

	* ymakefile ($(OLDXMENU)): Remove extraneous call to `rm'.

1993-05-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keymap.c (Faccessible_keymaps): Use whatever size the vector has.
	(Fwhere_is_internal): Likewise.
	(describe_vector): Likewise.
	(current_minor_maps): Call Findirect_function, so symbols
	can be used in place of actual maps.

	* xdisp.c (display_text_line): Use break; to exit loop at eol.
	Duplicate the short MAKE_GLYPH loop after the main loop.
	If no display table, do obey selective_display_ellipses.
	(copy_part_of_rope): Arg FROM is now Lisp_Object *.

	* xfaces.c: Do include window.h.
	(compute_char_face): Supply third arg of Fget_text_property.

	* keyboard.c (make_lispy_event): Don't set shift modifier for C-^.

	* callproc.c (child_setup): Omit duplicates from new env array.

1993-05-10  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

        * fileio.c (ro_fsys) [SOLARIS_BROKEN_ACCESS]: Check for the
        filesystem being ro, since Solaris 2.1 doesn't.
        (file-writable-p): Call ro_fsys.
	* s/sol2.h (SOLARIS_BROKEN_ACCESS): Define this.

	* systime.h: Use the strategy from getdate.y to include the proper
	combination of <time.h> and <sys/time.h>.

	* xfns.c (Fx_create_frame): Use an XLFD name for the default font,
	instead of "9x15" or whatever it was.

	* xdisp.c (display_text_line): Make face-handling code conditional
	on HAVE_X_WINDOWS macro.  Perhaps this isn't the best approach,
	but it'll do for now.

	* xdisp.c (display_text_line): We can't use the FRAME_DEFAULT_FACE
	macro here; that's x-specific.  Just don't pass the second
	argument.
	* xfaces.c (compute_glyph_face): Remove the BASIC_FACE argument;
	use F's default face.

1993-05-09  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xfaces.c (Fmake_face_internal): Do nothing for non-X frames.

	* dispextern.h (struct face): Add cached_index member.
	* xfaces.c (get_cached_face): Use it to avoid unnecessary
	searches of face_vector.

	* xfaces.c (intern_face): Renamed from get_display_face.

	* xfns.c (x_make_gc): After building the GC's for the frame, call
	init_frame_faces to set up the first two faces.
	* xfaces.c (init_frame_faces): Don't just try to copy the default
	and mode line faces from some other random frame; instead, consult
	the normal_gc and reverse_gc members of the frame, and build the
	faces based on their parameters.

	Adjust the face computation functions to return frame face ID's,
	not pointers to display faces; since we call these functions
	during display construction, we don't want the display faces yet.
	* xfaces.c (intern_frame_face): New function.
	(compute_char_face, compute_glyph_face): Apply intern_frame_face
	to the computed face, and return the frame face's ID, instead of
	calling intern_face and returning a pointer to a display frame.

	* xfaces.c: Describe the facial data structures.  It took me a
	while to figure them out; perhaps this will save someone else the
	trouble.

	Arrange to tell redisplay about changes in overlays.
	* xdisp.c (redisplay_region): New function.
	* buffer.c (Fmove_overlay): Call redisplay_region on the areas the
	overlay has enclosed or left.
	(Fdelete_overlay): Call redisplay_region on the area the overlay
	used to occupy.
	(Foverlay_put): Call redisplay_region on the area the overlay now
	occupies; we may have put a face property on it.

	* buffer.c (Fmove_overlay): Doc fix.

	* xdisp.c (redisplay): If we're doing a thorough redisplay (all
	windows on all frames involved), go ahead and flush the GC cache -
	call clear_face_vector.

	* xdisp.c (display_text_line): Apply faces to characters
	according to overlays and text properties; use
	compute_char_face and compute_glyph_face to figure out what
	face to use, and where a new face starts.
	* xterm.c (dumpglyphs): Use the upper bits of the glyphs to decide
	which frame face to use.  Call GLYPH_FOLLOW_ALIASES to make sure
	we're implementing the glyph table properly.  If we're not using
	the default or mode line face, call intern_face to find a display
	face for the frame face selected by the glyph code.  Implement
	underlining.  Remove the `font' argument; we have to derive this
	from the frame and face anyway.  Change all callers.
	* disptab.h (GLYPH_FOLLOW_ALIASES): New macro.

	* xterm.c (x_destroy_window): Call free_frame_faces.

	The GNU coding standards specify that CFLAGS should be left for
	users to set.
	* ymakefile (ALL_CFLAGS): Set this to the long string of
	compilation switches, not CFLAGS.  Changed all uses.
	(CFLAGS): Make this default to just -g.
	(.c.o): Define new default rule, to make sure that the right flags
	get to the compilations.

1993-05-09  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_char): Exit kbd macro if Vexecuting_macro is t.

	* pwd.h: File deleted.

1993-05-08  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* s/sunos4shr.h: Apply changes from David J. Mackenzie; this isn't
	used by any configuration right now, but he's trying to make it
	work.
	#include "sunos4-1.h" instead of "bsd4-2.h".
	(O_NDELAY): Don't define this.
	(SYSTEM_MALLOC): Don't define this, either.
	(LD_SWITCH_SYSTEM): Remove the definition for this.

	* Makefile.in (DEFS): Remove this; we have configure build a
	config.h file directly, instead of having lots of -D flags.

	* Makefile.in (CFLAGS): Don't make this carry DEFS from the
	configure script; the coding standards say that CFLAGS should be
	left for the user to tweak.

1993-05-08  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (do_mouse_tracking): Now static.

	* xmenu.c (Fx_popup_menu): Add a vector of prefix keys for the panes.
	(keymap_panes): Allocate that vector.
	(single_keymap_panes): Fill in that vector.
	(xmenu_show): Return a list of events, not just one event.

	* keyboard.c (read_char_menu_prompt): Expect Fx_popup_menu
	to return a list of events.  Don't lose any of them.

	* xfns.c (Fx_get_mouse_event, Fx_mouse_events): Code deleted.
	* window.c (Vmouse_event): Var deleted.
	(syms_of_window): Don't make it a Lisp var.

        * keyboard.c (read_avail_input, Fset_input_mode): Make
        meta_key a three-value variable to support 8-bit input.

1993-05-07  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile [__GNUC__ && __GNUC__ > 1] (LIB_GCC): Set this even if
	LINKER is #defined.

	* ymakefile ($(OLDXMENU)): Remove the link before we re-create it;
	not all versions of ln have the `-f' flag.  Use the LN_S variable,
	inherited from src/Makefile.

	* Makefile.in (LN_S): New variable, edited by top Makefile.
	(SUBMAKEFILE): New variable, containing all flags to pass to
	recursive makes.

	* config.h.in: Adjust this for use by autoconf's AC_CONFIG_HEADER,
	instead of AC_OUTPUT.

	* xfaces.c (get_display_face): Use face_eql instead of writing it out.

1993-05-06  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keymap.c (Fwhere_is_internal): If FIRSTONLY is non-nil, avoid
	returning a non-ascii key sequence unless FIRSTONLY is the symbol
	`non-ascii'.

	* config.h.in: Remove mention of GLYPH datatype; that shouldn't be
	a user option.
	* lisp.h (GLYPH, MAKE_GLYPH, GLYPH_CHAR, GLYPH_FACE): New macros.

1993-05-06  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (x_get_arg): Call Fintern, not intern.

	* systime.h [SCO]: Include time.h.
	* s/sco4.h: New file.

	* ymakefile (LIBXMENU): Delete -loldX.

	* emacs.c (main): Handle -display like -d.

1993-05-05  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* s/template.h: Explain the relative significance of the SIGIO and
	INTERRUPT_INPUT macros.

	* ymakefile (buffer.o, insdel.o): Note that these files also
	depend on blockinput.h.

	* blockinput.h (UNBLOCK_INPUT): We cannot assume that SIGIO is
	defined everywhere this file is #included; merge the two
	definitions for defined (SIGIO) and ! defined (SIGIO) into one,
	which calls reinvoke_input_signal if interrupt_input_pending is
	set.
	* keyboard.c (reinvoke_input_signal): New function.

1993-05-04  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* window.c (Fdisplay_buffer): Add space to prompt.

1993-05-04  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* keyboard.c (syms_of_keyboard): Doc fix for
	extra-keyboard-modifiers.

	* lisp.h (CHAR_ALT, CHAR_SUPER, CHAR_HYPER, CHAR_SHIFT, CHAR_CTL,
	CHAR_META): Shift these all up one bit, back to where they were.

1993-05-02  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keymap.c (Fdefine_prefix_command): Doc fix.

	* ymakefile (C_DEBUG_SWITCH): Undo April 10 change.

1993-05-01  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Fsuspend_emacs): Doc fix.

1993-04-30  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* data.c (Ffset): Refuse to set the function value of t or nil.

1993-04-29  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

        Implement extra_keyboard_modifiers properly.
	* keyboard.c (syms_of_keyboard): Doc fix for
	extra-keyboard-modifiers; use the same modifier bits as we do for
	characters.
	(read_char): Apply all the modifiers in extra_keyboard_modifiers
	to the input characters, so you can get hyper, super, and the rest
	of the gang.
	* xterm.c (x_emacs_to_x_modifiers): New function.
	(x_convert_modifiers): Renamed to x_x_to_emacs_modifiers, for
	consistency.  Callers changed.
	(XTread_socket): Apply x_emacs_to_x_modifiers to
	extra_keyboard_modifiers before setting the state member of the
	event; this will get all the modifiers on ASCII characters.

	* xterm.c (x_text_icon): Don't call XSetIconName; it should be
	unnecessary, and perhaps it's killing the icon pixmap.

	* lisp.h (CHAR_ALT, CHAR_SUPER, CHAR_HYPER): New constants, in
	case we need them.
	* termhooks.h (alt_modifier, super_modifier, hyper_modifier,
	shift_modifier, ctrl_modifier, meta_modifier): Define these in
	terms of the CHAR_mumble macros, to avoid having the same thing
	defined in two places.

	* keyboard.c (kbd_buffer_get_event): Don't generate switch-frame
	events if they'd only switch to the frame already selected.  This
	avoids lots of extra switch-frame events when using a separate
	minibuffer.

1993-04-29  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Fthis_command_keys): Doc fix.

	* process.c (wait_reading_process_input): Move the status_notify
	call before the set_waiting_for_input call.

	* fileio.c (Fexpand_file_name): Undo last change--too risky for now.

	* data.c (Fdefine_function): New function (same code as Fdefalias).

1993-04-28  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* eval.c (do_autoload): Fixed the bug in the autoload-saving code.

1993-04-28  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (Fcurrent_input_mode): New function.

1993-04-27  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* eval.c (un_autoload): Don't try to save old autoload forms when
	we load something in.  Something about the code now conditioned
	out by UNLOAD was screwing up ordinary autoloads, notably of
	picture.el.  When I figure out what, I'll fix and re-enable this
	code.

1993-04-27  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* buffer.c (syms_of_buffer): Doc fix for buffer-display-table.

	* systime.h: Doc fix.
	(EMACS_SET_USECS): Remember that a `usec' is a microsecond, not a
	millisecond.  What's three orders of magnitude between friends?
	* dispnew.c (Fsit_for, Fsleep_for): Remember to multiply the
	`milliseconds' argument by 1000 to get microseconds.

1993-04-26  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* fileio.c (Fexpand_file_name):
	Don't remove trailing / from NEWDIR if just "/".

1993-04-26  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* m/ibmps2-aix.h, m/ibmrs6000.h, m/ibmrt-aix.h, m/mips.h,
	m/sps7.h, s/hpux.h, s/usg5-4.h (HAVE_DUP2): Removed; derived by
	configure script.
	* s/hpux.h, s/irix3-3.h, s/aix3-1.h (HAVE_GETHOSTNAME): Removed;
	derived by configure script.

	Arrange for Fy_or_n_p to put off switch-frame events.
	* lread.c (read_filtered_char): New function, which contains the
	code which used to be in Fread_char, Fread_event, and
	Fread_char_exclusive; there was a lot of common code.
	(Fread_char, Fread_event, Fread_char_exclusive): Rewrite in terms
	of read_filtered_char.
	* lisp.h (read_filtered_char): Declare this extern here.
	* fns.c (Fy_or_n_p): Call read_filtered_char, arranging to delay
	switch-frame events.

	* keyboard.c (read_key_sequence): Let the `modifiers' variable in
	the code which deals with KEY being unbound be an int, not a
	Lisp_Object.

	* config.h.in (getenv): Don't test THIS_IS_YMAKEFILE to see if we
	should exclude the getenv declaration; instead, test NOT_C_CODE.
	Per suggestion from Francesco Potorti`.
	* ymakefile (NOT_C_CODE): Define this; it's true, and useful.

	* dispnew.c (Fsleep_for, Fsit_for): Allow SECONDS to be a
	floating point value.

1993-04-26  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* sysdep.c (read_pending_input):
	Fix the garbaged-modifiers bug under System Vs previous
	to r4.

1993-04-25  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* systty.h (EMACS_GET_TTY, EMACS_SET_TTY): Move these into
	functions in sysdep.c.
	* sysdep.c (emacs_get_tty, emacs_set_tty): Here they are.

	* sysdep.c (emacs_set_tty): Call tcsetattr over and over again
	until it does all of what we ask it to, or returns an error.

	* search.c (Freplace_match): Arrange for markers sitting at the
	beginning or end of the original text to float to the
	corresponding position in the replacement text.

1993-04-25  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* window.c (Fset-window-buffer):
	Set horizontal-scrolling on a window to zero when
	we connect it to a new buffer.

	* buffer.c: Doc fix.

1993-04-24  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	Make the modifier manipulation functions more robust.  The old way
	caused a bug once, and probably would again.
	* termhooks.h (alt_modifier, super_modifier, hyper_modifier,
	shift_modifier, ctrl_modifier, meta_modifier): Shift these all
	down one bit in value, to avoid sign extension problems.
	* lisp.h (CHAR_META, CHAR_CTL, CHAR_SHIFT): Fix these definitions too.
	* keyboard.c (lispy_modifier_list): Ignore modifier bits beyond
	what our table of modifier names can handle.
	(apply_modifiers): Don't abort if you see extra modifier bits,
	just remove them.

1993-04-23  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* data.c (Fdefine_function):
	Changed name back to Fdefalias, so we get things
	in a known-good state.

	* buffer.h (BUF_NARROWED, NARROWED):
	New macros to test whether a region
	restriction has narrowed the buffer.

1993-04-17  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* systime.h: Comment fixes.

	* data.c (Fdefine_function): New function.

	* lisp.h (LOADHIST_ATTACH): New macro.
	(Vcurrent_load_list, Vload_history): Vars declared.

	* eval.c: (defun, defmacro, defvar, defconst):
	Attach symbol argument to the list of globals for the input source.
	(do_autoload): Save the old autoloads, in case we ever unload.

	* fns.c (provide, require): Put appropriately-marked
	conses in the current-globals list.

	* lread.c (readevalloop):
	New argument is the source file name (or nil if none).
	All calls changed.  Do the two-step
	necessary to call build_load_history with the correct current-globals
	list for the current recursion.
	(build_load_history): New function.
	(eval_region, eval_buffer): Call readevalloop with new arg.
	(load_history): New variable.

1993-04-16  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* lread.c (readevalloop): New argument is the source file name (or
	nil if none).  All calls changed.  Do the two-step
	necessary to call build_load_history with the correct current-globals
	list for the current recursion.
	(build_load_history): New function.
	(Feval_region, Feval_buffer): Call readevalloop with new arg.
	(Vload_history): New variable.

	* fns.c (Fprovide, Frequire): Put appropriately-marked
	conses in the current-globals list.

	* eval.c (Fdefun, Fdefmacro, Fdefvar, Fdefconst):
	Attach symbol argument to the list of globals for the input source.
	(do_autoload): Save the old autoloads, in case we ever unload.

	* data.c (Fdefine_function): New function.

1993-04-16  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* fileio.c (Fmake_symbolic_link): If a file already exists under
	the link's filename, delete the file which the link
	would replace, not the file the link would point at.

	* config.h.in (volatile): Don't define this to be the empty string
	if some file has #defined HAVE_VOLATILE.

	* emacs.c (SEPCHAR): Instead of defining this to be ',' on VMS and
	':' elsewhere, just have it default to ':' if not #defined, and
	#define it to be ',' in s/vms.h; OS/2 will need it to be ';'.
	* s/vms.h (SEPCHAR): #define this to be ','.
	* s/template.h (SEPCHAR): Mention this.

1993-04-13  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* s/vms.h (xfree): #define this to emacs_xfree, to avoid case
	conflict with XFree; on VMS, external symbols are case-insensitive.

	* s/usg5-4.h (HAVE_GETTIMEOFDAY): Deleted; ../configure figures
	that out now.

	Changes for Emacs 19 from Thorsten Ohl <ohl@chico.harvard.edu>:
	* s/mach2.h: copied from the Emacs 18.59 distribution.
	Don't define NO_REMAP, define START_FILES as
	`pre-crt0.o' instead.  Define LIB_MATH as `-lm', to override the
	default `-lm -lc' (there is no libc on the NeXT).
	* ymakefile (STARTFILES): Allow config.h to set this value even if
	ORDINARY_LINK is defined.
	* unexnext.c: Fix subdirectories for the machine dependent include
	files for NeXTStep 3.0; #include <mach/mach.h> and
	<mach-o/loader.h> instead of <mach.h> and <sys/loader.h>.
	(getsectbyname): Remove prototype for this; the system #include
	files take care of that.
	(malloc_cookie): New variable.
	(unexec_doit): Set malloc_cookie to the result returned by
	malloc_freezedry.
	* emacs.c (main): Declare malloc_cookie to be extern, so that we can
	get the value set when we dumped and pass it to malloc_jumpstart.
	* systime.h: The NeXT has a timezone function.

1993-04-12  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile ($(OLDXMENU)): Remove $(OLDXMENU) before trying to
	link in a new version.

	* lisp.h (Qrange_error, Qdomain_error, Qsingularity_error,
	Qoverflow_error, Qunderflow_error): Add extern to these declarations.

1993-04-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfaces.c: Don't include Xmu/Drawing.h.

1993-04-10  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* Makefile.in (xmakefile): Recognize the -O option with a numeric
	optimization level.

	* ymakefile (C_DEBUG_SWITCH): If we're using version 2 of GCC or
	higher, use -O99 instead of plain -O.

1993-04-09  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (command_loop_1): Rebuild menu bar if
	update_mode_lines is set.

        long_to_cons and cons_to_long are generally useful things; they're
	needed whether or not X is defined.
	* xselect.c (long_to_cons, cons_to_long): Moved from here...
	* data.c    (long_to_cons, cons_to_long): ... to here.
	* lisp.h    (long_to_cons, cons_to_long): Add extern declaration.

	* xmenu.c (Qmenu_enable): Definition moved...
	(syms_of_xmenu): ... along with initialization ...
	* keyboard.c (Qmenu_enable): ... to here ...
	(syms_of_keyboard): ... and here.

	* keyboard.c (kbd_buffer_get_event): If we get a selection clear
	or selection request event, but we were compiled without the
	window-system-specific code to handle it, abort.  Don't try to
	call a function which doesn't exist.

	* keyboard.c (make_lispy_event): In the code which processes mouse
	clicks, declare f to be a FRAME_PTR, not a struct frame *; this
	works when MULTI_FRAME is not #defined.

	* xfaces.c (sort_overlays): Define this to be static, as declared.

	* callproc.c (relocate_fd): Make messages string literals, not
	initialized arrays.

	* alloc.c (__malloc_hook, __realloc_hook, __free_hook): Declare
	these extern, not static.  (!)

	* alloc.c (__malloc_hook, old_malloc_hook, __realloc_hook,
	old_realloc_hook): Declare that the functions these point to return
	void *, not void.

        Adjust for autoconf merger.
	* config.h.in: Add extra line to top, in case autoconf gets fixed
	and decides not to add Makefile-style comments to the top of the
	files it generates which we are forced to lop off.
	Indicate that the boolean macros here get their definitions via
	the DEFS Makefile variable.
	Adjust the operating system and machine #includes to use
	autoload's @cookies@.
	(RETSIGTYPE): Give this a default value.
	(SIGTYPE): Set this from RETSIGTYPE.
	(LD_SWITCH_X_SITE, C_SWITCH_X_SITE): Get values via @cookies@.
	* Makefile.in (DEFS): Renamed from CONFIG_CFLAGS.
	(xmakefile): Pass CFLAGS to ${CPP}.

	* buffer.c (Fmake_overlay, Fmove_overlay): New optional BUFFER
	arguments.
	(recenter_overlay_lists): New argument BUF, to use instead of the
	current buffer.
	(Foverlay_recenter): Pass the appropriate arguments to
	recenter_overlay_lists.

	* buffer.c (Fdelete_overlay): Don't assume that overlay is in the
	current buffer.  Don't forget to declare the argument a Lisp_Object.

	* dispnew.c (getenv): Extern declaration deleted; this is done in
	config.h.

	* Makefile.in (tagsfiles): Remove external-lisp from this list of
	files; we're not distributing it, so the normal build process
	shouldn't depend on it.

	* dispnew.c (init_display): Compare the return value of getenv to
	zero before setting display_arg, instead of just using the pointer
	as a truth value.

1993-04-08  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c (message, message1): If noninteractive and
	cursor_in_echo_area, don't print a newline at end of message.

	* fns.c (Fy_or_n_p): Echo the answer just once, at exit.

	* keyboard.c (echo_dash): Do nothing if echoptr is 0.

	* buffer.c (Fkill_all_local_variables): Store each var's current value
	in the buffer's alist entry, before reverting to the default value.

1993-04-07  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* keyboard.c (apply_modifiers): Fix typo in sanity check.

	* keyboard.c (interrupt_input_blocked, interrupt_input_pending):
	Remove `extern' keywords - these are the definitions.

1993-04-07  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* blockinput.h (UNBLOCK_INPUT): Fix typo.
	(interrupt_input_blocked): Make this signed int.

	* search.c (search_buffer): Fix typo in previous change.

	* insdel.c, buffer.c: Include blockinput.h.

	* xterm.c: Fix typo in comment delimiter.

1993-04-07  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* m/imbrs6000.h: If we're using GCC, define ORDINARY_LINK instead
	of defining LINKER to use cc.
	* s/aix3-1.h (LINKER): Don't use cc for linking command if we're
	using GCC.
	* s/aix3-2.h (SYSTEM_MALLOC): Undefine this.

	* xterm.c (updating_frame): Declare this extern instead of static,
	so it's the same variable as the updating_frame in term.c.
	(XTupdate_begin, XTupdate_end): Don't bother to set
	updating_frame; the term.c functions take care of that for us.

1993-04-05  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* s/vms.h (EXEC_SUFFIXES): Add definition for this.

1993-03-31  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* xfaces.c: Doc fixes.

	Put interrupt input blocking in a separate file from xterm.h.
	This isn't specific to X, and it allows us to avoid #including
	xterm.h in files that don't really have anything to do with X.
	* blockinput.h: New file.
	* xterm.h (BLOCK_INPUT, UNBLOCK_INPUT, TOTALLY_UNBLOCK_INPUT,
	UNBLOCK_INPUT_RESIGNAL): These are now in blockinput.h.
	(x_input_blocked, x_pending_input): Deleted; there are analogs
	in blockinput.h called interrupt_input_blocked and
	interrupt_input_pending.
	* keyboard.c (interrupt_input_blocked, interrupt_input_pending):
	New variables, used by the macros in blockinput.h.
	* xterm.c: #include blockinput.h.
	(x_input_blocked, x_pending_input): Deleted.
	(XTread_socket): Test and set interrupt_input_blocked and
	interrupt_input_pending instead of the old variables.
	* alloc.c, xfaces.c, xfns.c, xmenu.c, xselect.c, keymap.c:
	#include blockinput.h.
	* eval.c: #include blockinput.h instead of xterm.h.
	* keyboard.c: #include blockinput.h.
	(input_poll_signal): Just test
	interrupt_input_blocked, instead of testing HAVE_X_WINDOWS and
	x_input_blocked.

	Block the processing of interrupt input while we're manipulating the
	malloc heap.
	* alloc.c: (xfree): New function, to make it easy to free things
	safely.
	(xmalloc, xrealloc): Block X input while doing the deed.
	(VALIDATE_LISP_STORAGE, gc_sweep, compact_strings): Use xfree
	instead of free.
	(uninterrupt_malloc): New function, to install input-blocking
	hooks into the GNU malloc routines.
	* emacs.c [not SYSTEM_MALLOC] (main): Call uninterrupt_malloc
	on startup.
	* alloc.c: (make_interval, make_float, Fcons, Fmake_vector,
	Fmake_symbol, Fmake_marker, make_uninit_string, Fgarbage_collect):
	Use xmalloc instead of malloc; don't bother to check if out of
	memory here.
	(Fgarbage_collect): Call xrealloc instead of realloc.
	* buffer.c: Use xmalloc and xfree instead of malloc and free;
	don't bother to check if out of memory here.
	(Fget_buffer_create): Put BLOCK_INPUT/UNBLOCK_INPUT pair around
	calls to ralloc routines.
	* insdel.c: Same.
	* lisp.h (xfree): New extern declaration.
	* xfaces.c (xfree): Don't #define this to be free; use the
	definition in alloc.c.
	* dispnew.c, doc.c, doprnt.c, fileio.c, lread.c, term.c, xfns.c,
	xmenu.c, xterm.c: Use xfree instead of free.
	* hftctl.c: Use xfree and xmalloc instead of free and malloc.
	* keymap.c (current_minor_maps): BLOCK_INPUT while calling realloc
	and malloc.
	* search.c: Since the regexp routines can malloc, BLOCK_INPUT
	while runing them.  #include blockinput.h.
	* sysdep.c: #include blockinput.h.  Call xfree and xmalloc instead
	of free and malloc.  BLOCK_INPUT around routines which we know
	will call malloc.
	
	ymakefile (keyboard.o, keymap.o, search.o, sysdep.o, xfaces.o,
	xfns.o, xmenu.o, xterm.o, xselect.o, alloc.o, eval.o): Note that
	these depend on blockinput.h.

	* keyboard.c (parse_modifiers, apply_modifiers): Make sure we're
	not trying to create modifier masks using integers which are
	unrepresentable as lisp values.

1993-03-30  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	New macros NULL_DEVICE and EXEC_SUFFIXES, to give the name of the
	equivalent of /dev/null, and the suffixes used by executable
	files.  This is simple, and helps people porting Emacs to other
	operating systems.
	* process.h (NULL_DEVICE): Give this a default value.
	* process.c (Fstart_process): Pass EXEC_SUFFIXES to openp.
	(Fprocess_send_eof): Use NULL_DEVICE instead of "/dev/null".
	* callproc.c (Fcall_process): Pass EXEC_SUFFIXES to openp.
	Use NULL_DEVICE instead of "/dev/null".
	* s/vms.h (NULL_DEVICE): #define this.

	Rename int-to-string to number-to-string, since it can handle
	floating-point as well as integer arguments.  subr.el defines the
	former as an alias for the latter.
	* data.c (Fnumber_to_string): Renamed from Fint_to_string.
	(wrong_type_argument): Adjust caller.
	(syms_of_data): Adjust defsubr.
	* fns.c (concat): Adjust caller.
	* lisp.h (Fnumber_to_string): Adjust extern declaration.
	* mocklisp.c (Finsert_string): Adjust caller.
	* process.c (status_message): Adjust caller.

1993-03-28  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* systty.h [NO_PTY_H]: Don't include pty.h.

	* m/delta88k.h [USG5_4]: Alternate defining of LIBS_SYSTEM,
	LIBX11_SYSTEM, HAVE_RANDOM, BSTRING.
	(NO_PTY_H): Defined.

	* fileio.c (Fwrite_region): Don't fail to set visit_file.

	* keyboard.c (command_loop_1): Clear force_start of selected_window
	after reading each key sequence.
	(read_char): Clear Vquit_flag when we return C-g for it.

	* fileio.c (Fexpand_file_name): Default DEFALT at beginning,
	before expanding it.  But avoid unneeded or infinite recursive expand.

1993-03-26  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* editfns.c (Fchar_equal): Don't ignore high bits of character.

	* fileio.c (Fwrite_region): Set visit_file after expanding file arg.
	Also expand VISIT arg if specified.

	* frame.c (make_frame): Init face_alist field.

1993-03-25  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* xselect.c (SELECTION_QUANTUM): Don't use XMaxRequestSize on R3;
	access the display structure directly.

1993-03-25  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* ymakefile (xfns.o): Depend on buffer.h.

	* buffer.h (struct buffer): Field `fieldlist' deleted.

	* search.c (Freplace_match): Clean up criterion about converting case.
	If old text has any capitalized words, capitalize new text.

	* xfaces.c: New file.

	* ymakefile (XOBJ): Add xfaces.o.
	(xfaces.o): New target.
	* emacs.c (main): Call syms_of_xfaces.

	* buffer.h (OVERLAY_START, OVERLAY_END, OVERLAY_VALID): New macros.
	(OVERLAY_POSITION): Likewise.
	(searchbuf): Decl deleted--doesn't belong here.
	Delete include of regex.h for VMS.
	* dired.c (searchbuf): Declare here.

	* frame.h (struct frame): New field face_alist.
	* alloc.c (mark_object): Mark face_alist of a frame.

	* ymakefile (xselect.o): Depend on dispextern.h.

	* xterm.h (FRAME_FACES, FRAME_N_FACES, FRAME_DEFAULT_FACE)
	(FRAME_MODE_LINE_FACE): New macros.
	(struct x_display): New fields faces, n_faces.

	* dispextern.h (struct face): New fields pixmap_h, pixmap_w.
	Field `font' is now a pointer.

	* fns.c (Fy_or_n_p): Ensure cursor_in_echo_area = 0 when quit.

1993-03-24  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* dispnew.c (getenv): Add extern declaration.

	* ymakefile (really-oldXMenu): Pass C_SWITCH_SITE and
	C_SWITCH_SYSTEM to the inferior make as separate flags, instead of
	passing just C_SWITCH_SITE as CFLAGS.

	* keymap.c (Fkeymapp): Doc fix.

	* xterm.h (x_focus_frame): Add extern keyword to declaration.

	* xterm.c [VMS]: Don't #include <sys/termio.h> and <string.h>.
	* xfns.c [VMS]: Get the gray_bits from [.bitmaps]gray.xbm.
	* process.c [VMS] (DCL_PROMPT): Remove hack.
	(WIFSTOPPED, WIFSIGNALED, WIFEXITED, XRETCODE, WSTOPSIG,
	WCOREDUMP, WTERMSIG): New dummy definitions.
	(deactivate_process): Add missing semicolon.
	* dispnew.c (init_display): Get display name from environment
	properly on VMS as well as Unix.

1993-03-24  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* buffer.c (init_buffer_once, reset_buffer):
	Delete last vestige of fieldlist slot.
	(Fregion_fields): Finally deleted.

	* keymap.c (push_key_description): Ignore bits above meta_modifier.

1993-03-23  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* buffer.c (overlays_at, recenter_overlay_lists): New functions.
	(Fmake_overlay, Fdelete_overlay, Foverlay_get, Foverlay_put): Likewise.
	(Fmove_overlay, Foverlays_at, Fnext_overlay_change): Likewise.
	(Foverlay_lists, Foverlay_recenter): Likewise.

	* buffer.h (struct buffer): New fields overlay_center,
	overlays_before, overlays_after.

1993-03-23  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* config.h.in (HAVE_XFREE386): New flag, set by configure script.
	If it's set, #define LIBX11_SYSTEM and HAVE_RANDOM as appropriate
	for XFree386.
	* sysdep.c (random, srandom): Don't define these if HAVE_RANDOM is
	#defined.

	* config.h.in (C_SWITCH_X_SITE, LD_SWITCH_X_SITE): New flags.
	* ymakefile (C_SWITCH_X_SITE, LD_SWITCH_X_SITE): Provide default
	values.  Include C_SWITCH_X_SITE in CFLAGS, include
	LD_SWITCH_X_SITE in LIBX, and pass C_SWITCH_X_SITE to the make
	which builds the X Menu library.

1993-03-22  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* xfns.c (Fx_parse_geometry): Renamed from Fx_geometry.
	(Fx_color_defined_p): Renamed from Fx_defined_color.
	(syms_of_xfns): Adjusted.

1993-03-22  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* indent.c (current_column, Findent_to, position_indentation): 
	(Fmove_to_column, compute_motion): Allow tab_width up to 1000.

	* xdisp.c (display_string, display_text_line):
	Allow tab_width up to 1000.

	* keyboard.c (Fsuspend_emacs):
	Change suspend-hooks back to suspend-hook and make it a normal hook.

	* s/dgux.h: Decide automatically whether to use COFF or ELF.

1993-03-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fns.c (Fy_or_n_p): Handle `recenter' response type.

	* s/dgux.h (HAVE_TERMIO, SIGNALS_VIA_CHARACTERS): Defined.

1993-03-21  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* frame.c (Fhandle_switch_frame): Renamed from Fselect_frame.
	Doc changed in anticipation of new purpose.
	(Fselect_frame): Just call Fhandle_switch_frame for now.

1993-03-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c (decode_mode_spec): Handle `%l'.
	(display_count_lines): New function.
	(redisplay_window): Update base_line_number and base_line_pos fields.
	Always update mode line if it's an integer.
	* window.h (struct window):
	New fields base_line_number and base_line_pos.

	* window.c (Fselect_window): Use Fhandle_switch_frame.
	(Fset_window_configuration): Likewise.

1993-03-20  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	Use the `visiblity' parameter to determine the initial state of
	the frame, instead of the `iconic-startup' and
	`suppress-initial-map' parameters.
	* xfns.c (x_icon): Test the Qvisibility parameter against Qicon,
	instead of the Qiconic_startup against Qt.
	(x_create_frame): Test Qvisibility against Qnil and
	Qicon, instead of testing Qsuppress_initial_map and Qvisibility.
	(Qicon): New symbol.
	(Qiconic_startup, Qsuppress_initial_map): Removed.
	(syms_of_xfns): Adjusted appropriately.

	* xfns.c (x_set_visibility): Instead of interpreting only Qt as
	`make the frame visible' and everything else as `iconify the
	frame', interpret Qicon as `iconify the frame' and everything else
	as `make the frame visible.'

	* xfns.c (x_get_arg): When the type of the resource is `symbol',
	return `true' and `on' as Qt, and `false' and `off' as Qnil.

1993-03-20  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* emacs.c (init_cmdargs): Fix simple bug in previous change.

1993-03-20  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* dispnew.c (Fsleep_for): Make this take two arguments SECONDS and
	MILLISECONDS, which add, rather than a second argument which says
	"treat the first argument as milliseconds."
	(Fsit_for): Same thing.
	(Fsleep_for_milliseconds): Deleted; this can be done with Fsleep_for.

	* process.c (wait_reading_process_input): Doc fix.

	* systime.h (EMACS_HAS_USECS): #define this if HAVE_TIMEVAL is
	#defined.

	* dispnew.c (sit_for): Doc fix.

	* sysdep.c (reset_sys_modes): Fix usage of EMACS_SET_TTY.

	* callproc.c (child_setup): Make sure that in, out, and err are
	not less than three.
	(relocate_fd): New function.

	* xterm.c (x_term_init): If the X connection is already in file
	descriptor zero, don't dup it and close the old one.

	* s/hpux8.h, s/sunos4-1.h (OLDXMENU_OPTIONS): Define this, as in
	Emacs 18.

	* xfns.c (Fx_open_connection): If we have X11R5, use
	XrmSetDatabase to set the display's database.  In older versions,
	just store the value into x_current_display->db.
	* xterm.h (HAVE_X11R5): Define this where appropriate.

	* frame.c (Fraise_frame, Flower_frame): Renamed from
	Fframe_to_front and Fframe_to_back.
	(syms_of_frame): Adjusted appropriately.

	* fileio.c (HAVE_FSYNC): Define, if appropriate.
	(Fwrite_region): Use HAVE_FSYNC.
	* s-aix3-2.h (HAVE_FSYNC): Define.

	* emacs.c (Finvocation_name): New function.
	(Vinvocation_name): New variable.
	(init_cmdargs): Set it.
	(syms_of_emacs): defsubr Finvocation_name, staticpro and
	initialize Vinvocation_name.
	* lisp.h (Vinvocation_name): New extern declaration.
	* xterm.c (invocation_name): Variable deleted; use
	Vinvocation_name now.
	(x_text_icon, x_term_init): Use Vinvocation_name now instead of
	invocation_name.
	(x_term_init): Don't initialize invocation_name.
	(syms_of_xterm): Don't initialize or staticpro invocation_name.
	* xfns.c (invocation_name): Remove extern declaration for this.
	[HAVE_X11] (Fx_get_resource): Use Vinvocation_name now instead of
	invocation_name.
	[not HAVE_X11] (Fx_get_default): Same.

1993-03-20  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* xfns.c (Fx_display_color_p): Renamed from Fx_color_display_p.
	(syms_of_xfns): Use new name in defsubr.

1993-03-19  Eric S. Raymond  (eric@geech.gnu.ai.mit.edu)

	* Makefile.in (unlock, relock): New productions to assist with
	version control.

1993-03-19  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* fileio.c (Fvisited_file_modtime): New function.
	(Fset_visited_file_modtime): Accept an argument specifying time value.
	If arg is nil, really use the filename handler.

	* xselect.c (cons_to_long, long_to_cons): No longer static.

1993-03-18  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* frame.h (FOR_EACH_FRAME): Change the definition so that
	FRAME_VAR is a lisp object. 
	* dispnew.c (WINDOW_CHANGE_SIGNAL, do_pending_window_change):
	Adjusted appropriately.
	* xdisp.c (redisplay): Adjusted appropriately.

	* dispnew.c (Fredraw_frame): Give this appropriate definitions for
	MULTI_FRAME and non-MULTI_FRAME configurations.
	(Fredraw_display): Give this a non-MULTI_FRAME-dependent definition.

1993-03-18  Richard Stallman  (rms@geech.gnu.ai.mit.edu)

	* lisp.h (CHECK_LIVE_WINDOW): Use Qlive_window_p.

	* xfns.c (x_screen): Make this var file scope.
	(Fx_server_version): Use Fcons, not list3.

1993-03-17  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* xterm.c (term_get_fkeys): Less klugey version of the last fix.

	* Makefile.in (versionclean): New production nukes binaries and
	DOC files, forcing a re-load, re-dump and re-makedoc.

1993-03-17  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c: Doc fix.

1993-03-17  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xterm.c (x_display_box_cursor, x_display_bar_cursor): Don't
	display the cursor on garbaged frames.

1993-03-17  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* term.c (term_get_fkeys) Supply second args for all tgetstr calls.

1993-03-17  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* process.c (Fprocess_send_eof): Make sure proc is running.

	* s/irix4-0.h (_getpty): Declare this, not _get_pty.

1993-03-16  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (Fx_server_vendor, Fx_server_version, Fx_display_pixel_width)
	(Fx_display_pixel_height, Fx_display_mm_width, Fx_display_mm_height)
	(Fx_display_screens, Fx_display_planes, Fx_display_color_cells)
	(Fx_display_visual_class, Fx_display_backing_store)
	(Fx_display_save_under): New functions.
	(x_screen_count, Vx_vendor, x_release, x_screen_height_mm)
	(x_screen_width_mm, Vx_backing_store, x_save_under, Vx_screen_visual)
	(x_visual_strings): Vars deleted.
	(Fx_open_connection): Don't init those vars.
	(syms_of_xfns): Set up new functions.
	Don't set up those vars as Lisp vars.
	Nor x-screen-width and x-screen-height.

1993-03-16  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

        * cmds.c (overwrite_binary_mode): Deleted; this implements the
	wrong feature.
	(Qoverwrite_mode_binary): New variable.
	(internal_self_insert): If current_buffer->overwrite_mode is
	`overwrite-mode-binary', do as overwrite_binary_mode used to.
	(syms_of_cmds): Remove defvar of overwrite_binary_mode; initialize
	Qoverwrite_mode_binary.
	* buffer.c (syms_of_buffer): Doc fix for overwrite_mode.
	* buffer.h (struct buffer): Doc fix.

	Rename `live-window-p' to `window-live-p', for consistency with
	`frame-live-p'.
	* window.c (Fwindow_live_p): Renamed from Flive_window_p.
	* lisp.h (CHECK_LIVE_WINDOW): Change to use Qwindow_live_p.
	(Qwindow_live_p): Extern declaration renamed fom Qlive_window_p.

1993-03-16  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xmenu.c (xmenu_show): Do BLOCK_INPUT; unblock just before returning.

	* xterm.h [SIGIO] (UNBLOCK_INPUT): Resignal if x_pending_input.

1993-03-15  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* frame.c (Fframe_height, Fframe_width): Fix doc strings to match
	those of the multi-frame versions in frame.el.  Accept an optional
	argument FRAME, also for consistency.

	* floatfns.c (logb): Add extern declaration for this.

	* floatfns.c (Flogb): Under SYSV, implement this using frexp.

1993-03-15  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (dispnew.o): Depend on termhooks.h.

	* xmenu.c (list_of_items): Allow strings among the alist items;
	they make nonselectable lines.

1993-03-14  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* dired.c (Fdirectory_files): Recompile MATCH (if specified) after
	expanding the file name and all; those might compile regexp of
	their own, and change searchbuf.

	* keyboard.h (internal_last_event_frame): This should be extern,
	dummy.

	* fns.c (Fy_or_n_p): Display the answer.

	Some VMS changes from Richard Levitte <levitte@e.kth.se>:
	* [VMS] systime.h: Include vmstime.h.  VMS has the timezone
	variable and the tzname array.
	* s/vms.h: VMS does have select.
	mth$dmod is the same as Unix's drem.
	Use the time functions in vmstime.c.
	No need to rename the malloc routines if we're using GNU malloc.
	PURESIZE needs to be 330000.
	* vmstime.c, vmstime.h: New files.
	* systty.h: Don't try to initialize extern declarations under VAX C.
	* vmspaths.h (PATH_LOADSEARCH): Include EMACS_LIBRARY:[LOCAL-LISP]
	in PATH_LOADSEARCH.
	(PATH_EXEC): Use EMACS_LIBRARY:[LIB-SRC] instead of [ETC].
	* sysdep.c [VMS] (init_sys_modes): Don't allocate process_ef.
	[VMS] (queue_kbd_input): Build events structure correctly.
	[VMS] (gethostname): New function.
	[VMS] (getwd): Don't get the PATH environment variable; that's
	dumb.  Call getcwd.

1993-03-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c (display_menu_bar): Assume FRAME_MENU_BAR_ITEMS already set.
	Fill out line with spaces.
	Put explicit spaces between items.
	* keyboard.c (command_loop_1): Set FRAME_MENU_BAR_ITEMS here.

	* window.c (Fdelete_other_windows): Handle FRAME_MENU_BAR_LINES.

	* keyboard.c (menu_bar_items): Reverse the list when done.

	* xmenu.c (single_keymap_panes): When storing in ENABLES,
	check def before enabled.

	* ymakefile (really-oldXMenu): Renamed from ${oldXMenudir}$(OLDXMENU).
	Add @true.
	($(OLDXMENU)): Depend on really-oldXMenu.
	The idea is to make sure libXMenu11.a is always updated if nec.

	* keyboard.c (command_loop_1): Typo calling Qrecompute_lucid_menubar.
	(read_key_sequence): Likewise.  Also fix call to Vrun_hooks.

1993-03-13  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* ymakefile (YMF_PASS_LDFLAGS): Doc fix.

1993-03-13  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* print.c (PRINTPREPARE): Handle marker that points nowhere.

	* apollo.h (NO_X_DESTROY_DATABASE): Defined.

	* undo.c (record_property_change, record_delete, record_insert):
	Don't make boundary or touch last_undo_buffer if cur buf has no undo.

	* ymakefile [__GNUC__ > 1]: Delete the conditional for GCC 2.4.
	[__GNUC__ > 1] (LIB_GCC): Use -print-libgcc-file-name to find libgcc.a.
	(YMF_FIND_LIBGCC_A): Definitions and uses deleted.

1993-03-13  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* s/usg5-4.h: Remove extraneous text after #undef LIB_X11_LIB.

1993-03-13  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xterm.c (Xatom_wm_change_state): Define here.
	* xfns.c (Xatom_wm_change_state): Just declare.
	(Xatom_emacs_selection, Xatom_clipboard, Xatom_clipboard_selection):
	(Xatom_wm_change_state, Xatom_incremental, Xatom_multiple):
	(Xatom_targets, Xatom_timestamp, Xatom_delete, Xatom_insert_selection):
	(Xatom_pair, Xatom_insert_property, Xatom_text): Decls deleted.
	(x_begin_selection_own): Decls deleted.
	(Fx_open_connection): Set up only the wm atoms here.
	Call Xatoms_of_xselect.

	* dispnew.c: Include termhooks.h.

	* frame.h (FRAMEP): Macro deleted.

	* xselect.c: Total rewrite, derived from Lucid's version.

	* keyboard.c (kbd_buffer_get_event): Handle selection_clear_event
	and selection_request_event events.

	* xterm.c (XTread_socket): Handle NEW_SELECTIONS alternative:
	queue events for SelectionRequest and SelectionClear;
	call functions for SelectionNotify and PropertyNotify.

	* termhooks.h (selection_request_event, selection_clear_event):
	New event kinds.

	* xterm.h (SELECTION_EVENT_DISPLAY): New macro.
	(SELECTION_EVENT_REQUESTOR, SELECTION_EVENT_SELECTION)
	(SELECTION_EVENT_TARGET, SELECTION_EVENT_PROPERTY)
	(SELECTION_EVENT_TIME): New macros.
	(struct selection_input_event): New structure.

	* process.c (wait_reading_process_input): New option to wait
	till a given cons cell has a non-nil car.
	Delete vipc conditionals.

1993-03-12  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile (YMF_FIND_LIBGCC_A): New macro, to help GCC find
	libgcc.a even when -nostdlib is in effect.  Define it to be the
	empty string if nobody else establishes a value for it.
	(temacs): Include it in the list of flags passed to the linker.

	* ymakefile (LINKER): If we have GCC 2.4 or later, use the
	-nostartfiles option instead of -nostdlib.
	(LIBGCC): Under GCC 2.4 or later, define this to be the empty string.

1993-03-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xmenu.c (xmenu_show): New arg enable_list.
	(keymap_panes): New arg enables
	(single_keymap_panes): New arg enables.  Fill in its contents.
	(list_of_panes, list_of_items): New arg enables.  Fill in contents.
	(Fx_popup_menu): Pass enable and enable_list args.
	(single_keymap_panes): Set enable flag to -1 if cmd definition is nil.

	* lisp.h (INTEGERP, SYMBOLP, MARKERP, STRINGP, VECTORP): New macros.
	(COMPILEDP, BUFFERP, SUBRP, PROCESSP, FRAMEP, WINDOWP): New macros.
	(WINDOW_CONFIGURATIONP, FLOATP): New macros.

1993-03-12  Paul Eggert  (eggert@twinsun.com)

	* cmd.c (internal_self_insert): Check that tab_width does not
	exceed 20, to be consistent with indent.c and xdisp.c.

1993-03-12  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* term.c (CONDITIONAL_REASSIGN): fixed reference to tigetstr.
	This should have been tgetstr, but I typoed and tigetstr happens
	to link and even do the right thing if you're on a System V box.

1993-03-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): Support Vcurrent_menubar
	and Qactivate_menubar_hook.  Call Qrecompute_lucid_menubar.
	(syms_of_keyboard): Set up Vcurrent_menubar, Vprevious_lucid_menubar,
	Qactivate_menubar_hook, and Qrecompute_lucid_menubar.

	* xmenu.c (Fx_popup_menu): Allow a frame instead of a window, in arg.
	Use Fcar, Fcdr when extracting from event, to check data types.

1993-03-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* frame.h (FRAME_MENU_BAR_ITEMS): New macro (two versions).
	(struct frame): New field menu_bar_items.
	* alloc.c (mark_object): Mark the menu_bar_items field.

	* xdisp.c (display_menu_bar): New function.
	(redisplay_window): Call display_menu_bar.

	* term.c (tigetstr): Add dummy definition to make Emacs link again.

	* keyboard.c (syms_of_keyboard): Set up Qmenu_bar.
	(menu_bar_items): New function.
	(menu_bar_one_keymap, menu_bar_item): New functions.
	(make_lispy_event): Handle menu bar events.
	(read_key_sequence): Make dummy prefix `menu-bar' for menu bar events.

1993-03-11  Eric S. Raymond  (eric@mole.gnu.ai.mit.edu)

	* term.c (fkey_table): Added many more keycap cookies to the
	fkey_table; it now supports the full intersection of the set of X
	keysyms and terminfo capabilities.  See my lisp directory
	ChangeLog entry for this date, and lisp/term/README, for details.

1993-03-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* floatfns.c (Flogb): Fix use of IN_FLOAT.
	Fix arg names.  Don't confuse Lisp_Object with integer.

1993-03-11  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c (process_send_signal): In the TERMIOS code for sending
	control characters to processes, don't try to return Qnil; just
	return.

1993-03-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* dispnew.c (change_frame_size): Handle FRAME_MENU_BAR_LINES.

	* frame.c (Fframe_parameters): Report menu-bar-lines parm.
	(syms_of_frame): Set up Qmenu_bar_lines.

	* frame.h (FRAME_MENU_BAR_LINES): New macro.
	(struct frame): New field menu_bar_lines.

	* xfns.c (x_frame_parms): Add elts for visibility and menu-bar-lines.
	(enum x_frame_parm): Likewise.
	(x_set_menu_bar_lines, x_set_menu_bar_lines_1): New functions.
	(x_set_visibility): New function.
	(Fx_create_frame): Handle menu-bar-lines parm.
	(x_report_frame_params): Report Qvisibility.
	(syms_of_xfns): Set up Qvisibility.

	* keyboard.c (command_loop_1): Typo in last change.

	* xmenu.c (syms_of_xmenu): Set up Qmenu_enable.
	(single_keymap_panes): Test menu-enable property of symbol
	to decide whether to include it in the menu.

1993-03-10  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keyboard.c (command_loop_1): Adjust to the fact that display
	tables are now vectors of vectors, not vectors of strings.

1993-03-10  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* floatfns.c (Flogb): Undo the change of Feb 22.

	* ymakefile (OLDXMENU): Don't assume that we have symbolic links
	available; use `ln -f' instead of `ln -s'.

	* xterm.c (x_find_modifier_meanings): XDisplayKeycodes only
	appeared in X11R4; for earlier versions, just access the members
	of the Display directly.

	* xrdb.c (get_user_db): Since xrdb.c doesn't #include xterm.h,
	we can't test HAVE_X11R4 to see how we should get the resource
	manager string; cheat.

	* unexec.c (copy_text_and_data): Error message tweaked.

	* systime.h (timezone): Add an explicit declaration for this
	variable under USG 5-4.

	* sysdep.c (read_input_waiting): Set e.frame_or_window, not
	e.frame; the latter doesn't exist anymore.

	* sysdep.c (start_of_data): If ORDINARY_LINK is #defined, we don't
	have the data_start symbol defined, so we'll just use the address
	of environ.

	* s/usg5-4.h: Changes from Eric Raymond:
	If we're doing ordinary linking, define LIB_STANDARD appropriately.
	Give LIBS_DEBUG a null definition; usg5-4 has no -lg.
	#define LIBS_STANDARD as "-lc"; usg5-4 has no -lPW.
	#define NSIG, if it's not already defined.
	#define HAVE_TERMIOS instead of HAVE_TCATTR.
	Provide our own definition of LIB_X11_LIB.

	* s/usg5-3.h (LIBX11_SYSTEM): Eric Raymond says the libraries here
	were slightly wrong.

	* m/intel386.h (LIB_STANDARD): If USG5_4 is #defined, there's no
	need to include `-lPW'; that has been merged with `-lc'.

	* emacs.c (__do_global_ctors, __do_global_ctors_aux,
	__do_global_dtors, __CTOR_LIST__, __DTOR_LIST__, __main): Don't
	define these if ORDINARY_LINK is #defined; in that case, the
	standard linking procedure will find definitions for these.

	* syssignal.h (sigunblock): Add definition which works under SYSVr4.
	* emacs.c (fatal_error_signal): Unblock the signal which we're
	handling using sigunblock.

1993-03-09  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xfns.c (x_make_gc): Don't forget to block X input around the
	X calls in this function.

	* xfns.c [not HAVE_X11R4] (select_visual): It's v->visualid, not
	x->visualid.  x isn't defined.

	* m/template.h, s/template.h: Mention that `etc/MACHINES' and
	`configure' should be updated whenever support for a configuration
	is added or improved.

	* process.c [! subprocesses] (wait_reading_process_input):
	Remember to re-enable polling for input.

	* keyboard.c [POLL_FOR_INPUT] (quit_throw_to_read_char): If
	we're polling for input, abort; input polling should always be
	suppressed while we're waiting for input.

	* keyboard.c (interrupt_signal): Remove extern declaration of
	Vwindow_system; this is no longer used.

1993-03-09  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* editfns.c (Fcurrent_time_string): Optional arg specifies time.

	* keymap.c (Fdefine_key): Use proper meta-bit to clear.

	* intervals.c (set_point): Check invisibility of following character,
	not previous character.

	* floatfns.c (FLOAT_CHECK_ERRNO): Define unless NO_FLOAT_CHECK_ERRNO.

	* floatfns.c: Changes from Lucid.
	(HAVE_MATHERR, FLOAT_CHECK_ERRNO, FLOAT_CATCH_SIGILL): New parm macros.
	(FLOAT_CHECK_DOMAIN, HAVE_RINT): New parm macros.
	(HAVE_INVERSE_HYPERBOLIC, HAVE_CBRT): New parm macros.
	[!HAVE_RINT]: Define rint as macro.
	(IN_FLOAT): Major rewrite; several alternate versions.
	(IN_FLOAT2): New macro.
	(arith_error, range_error, domain_error, domain_error2): New macros.
	(Facos, Fasin, Fatan, Fcos, Fsin, Ftan, Fexp, Fexpt, Flog): Changed.
	(Flog10, Fsqrt, Fabs, Ffloat, Flogb): Changed.
	(Ffloor, Fceiling, Fround, Ftruncate): Changed.
	(Fcube_root): Renamed from Fcbrt.
	(matherr): New function.
	(float_error): Only if FLOAT_CATCH_SIGILL.

	* fns.c (Fy_or_n_p): Use query-replace-map.

	* keymap.c (access_keymap): Handle ints beyond the ASCII range.
	(store_in_keymap): Likewise.
	(Faccessible_keymaps): Use meta_modifier.
	Use vectors for the key sequences.
	(Fwhere_is_internal): Use meta_modifier.
	(append_key): Always return a vector.

	* lisp.h (Qrange_error, Qdomain_error, Qsingularity_error):
	(Qoverflow_error, Qunderflow_error): New vars.

	* data.c (syms_of_data) [LISP_FLOAT_TYPE]: Define new error conditions:
	Qarith_error, Qrange_error, Qdomain_error,
	Qsingularity_error, Qoverflow_error, Qunderflow_error.

1993-03-08  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* systty.h: Define HAVE_TCATTR based on HAVE_TERMIOS earlier.
	(struct emacs_tty): Separate the struct decl
	from the EMACS_..._TTY... macro definitions.
	Use HAVE_TCATTR to decide whether to use `struct termios'.

	* xfns.c (Fx_pixel_width, Fx_pixel_height): Fns deleted.
	(syms_of_xfns): Don't install them.
	(x_user_set_name): Function deleted.
	(x_char_height, x_char_width): New functions.

	* frame.c (Fframe_char_height, Fframe_char_width):
	(Fframe_pixel_height, Fframe_pixel_width):
	New functions, two versions of each.
	[MULTI_FRAME] (syms_of_frame): Make them Lisp functions.
	[!MULTI_FRAME] (syms_of_frame): Likewise.  Also Fselected_frame.

	* xterm.c (XTread_socket):
	Don't reverse the chars that XLookupString returns.  Use all of them.
	Save last 100 chars and keysyms in temp_buffer.

1993-03-07  Roland McGrath  (roland@churchy.gnu.ai.mit.edu)

	* buffer.c (syms_of_buffer): Make erase-buffer a disabled command.

1993-03-07  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (keyboard.o): Depend on intervals.h.
	(keymap.o): Depend on termhooks.h.

	* keyboard.c: Include intervals.h.
	(read_key_sequence): Use get_local_map.

	* textprop.c (Fget_text_property): Use textget.
	(Fnext_single_property_change): Likewise.
	(Fprevious_single_property_change): Likewise.

	* intervals.c (textget): Handle categories.
	(get_local_map): New function.
	(verify_interval_modification): Call textget correctly.

	* textprop.c (syms_of_textprop): Set up Qcategory, Qlocal_map.
	* intervals.h: Declare those vars.  Declare textget, get_local_map.

	* keymap.c: Include termhooks.h.
	(push_key_description): Handle all modifiers.
	Handle large character codes.
	(Fkey_description): Move the meta bit, if arg is string.
	(Fsingle_key_description): Don't alter integer value.
	Make tem long enough.

	* keyboard.c (read_key_sequence):
	Use meta_modifier for meta keys when handling function_key_map.

	* lread.c (syms_of_lread): Set up Qascii_character.
	(Fread_char, Fread_char_exclusive): Use that property
	to convert symbols like tab, return, M-return,... to ASCII.

	* keyboard.c (follow_key): Downcase shift_modifier as well as ASCII.
	(command_loop_1): Run pre-command-hook and post-command-hook.
	Set this_command before running pre-command-hook.
	(syms_of_keyboard): Set up vars for those hooks.

	* buffer.c (reset_buffer_local_variables): Reset mark_active.
	(syms_of_buffer): New buffer-local var `mark-active'.
	(init_buffer_once): Initialize mechanism for it.

1993-03-06  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* dispnew.c (init_display): Initialize Vwindow_system.

	* ymakefile (SHELL): No need to set this twice; remove one.

	* emacs.c (main): SIGIOT isn't defined on all systems; don't set
	its signal handler unless it is.

	* sysdep.c (init_baud_rate): Use input_fd, instead of fd; the
	latter is undefined.

	* dired.c (NAMLEN): Never use d_nameln to get the length of the
	directory entry's name; it is used inconsistently.  Always call
	strlen instead.

1993-03-06  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (syms_of_keyboard): Handle gaps in modifier_names.
	(modifier_names): Reorder to match termhooks.h.

	* keyboard.c (parse_modifiers_uncached): Detect `s-', not `super-'.
	(apply_modifiers_uncached): Make `s-', not `super-'.

	* lread.c: Include termhooks.h.
	(read_escape): Handle \H, \A, \s.  Use ..._modifier.
	* ymakefile (lread.o): Depend on termhooks.h.

	* termhooks.h (alt_modifier, super_modifier, hyper_modifier):
	(shift_modifier, ctrl_modifier, meta_modifier):
	Renumber the bits.
	* keyboard.c (make_lispy_event): For ASCII event, the ..._modifier
	bits are the right bits to return.

	* keyboard.c (lispy_function_keys): Add codes starting at 0xff00
	and running through 0xffff.

	* xterm.c (x_alt_mod_mask, x_super_mod_mask, x_hyper_mod_mask):
	New variables.
	(x_find_modifier_meanings): Set them.
	(x_convert_modifiers): Check for them.
	(XTread_socket): Handle BackSpace, etc, function keys.

	* keyboard.c (read_char): Move metabit when fetching from string macro.

	* callint.c (check_mark): Error if mark is not active.

	* editfns.c (save_excursion_save): Save mark_active of buffer.
	(save_excursion_restore): Restore mark_active of buffer.
	Run activate-mark-hook if it's on, or deactivate-mark-hook
	if it turns off.
	(region_limit): Error if mark inactive, if transient-mark-mode.

	* insdel.c (prepare_to_modify_buffer): Set Vdeactivate_mark.

	* keyboard.c (command_loop_1): Clear Vdeactivate_mark before cmd.
	Clear mark_active if command set Vdeactivate_mark.
	Run deactivate-mark-hook at that time, or activate-mark-hook.
	(syms_of_keyboard): Define variable deactivate-mark.

	* buffer.c (syms_of_buffer): New buffer-local var `mark-active'.
	(init_buffer_once): Initialize mechanism for it.

	* buffer.h (struct buffer): New field mark_active.

	* intervals.c (verify_interval_modification): Handle insertions
	specially.  For non-insertions, check only the chars being changed.
	`modification-hooks' property is now a list of functions.
	(set_point): Ignore chars outside current restriction.

	* textprop.c (Qmodification_hooks): Renamed from Qmodification.
	(syms_of_textprop): Changed accordingly.

	* keyboard.c (syms_of_keyboard): New lisp var unread-command-char.
	(Finput_pending_p): Test unread_command_char.
	(Fdiscard_input, quit_throw_to_read_char, init_keyboard): Set it.
	(read_char): Fetch from it.

1993-03-05  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* textprop.c (Fadd_text_properties): Initialize the modified flag.
	Use a "for (;;)" loop at the end of the function, to indicate that
	all exiting is taken care of inside the loop.
	(Fremove_text_properties): Same.

1993-03-05  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (LIB_MATH): Delete -lc, since duplicates LIB_STANDARD.

	* buffer.c (check_protected_fields): Variable deleted.
	(syms_of_buffer): Delete vars buffer-field-list
	and check-protected-fields.
	* insdel.c (check_protected_fields): Delete decl.

	* disptab.h (DISP_INVIS_VECTOR): Renamed from DISP_INVIS_ROPE.
	(DISP_CHAR_VECTOR): Renamed from DISP_CHAR_ROPE.
	All callers changed. 

	* xdisp.c (copy_rope): Expect FROM to be a vector.
	(copy_part_of_rope): New function.
	(display_string): Expect display table elts to be vectors.
	* indent.c (current_column, Fmove_to_column, compute_motion):
	Expect display table elts to be vectors.

	* alloc.c: (Fmake_rope, Frope_elt): Fns deleted.

	* lisp.h (CHAR_META, CHAR_SHIFT, CHAR_CTL): New macros.

	* lread.c (read_escape): Handle M-, C- and S- for new convention.
	(read1): Move the meta bit to the right place for a string.

	* keyboard.c (Fthis_command_keys, Fread_key_sequence):
	Fix calls to make_event_array.

	* macros.c (Fend_kbd_macro): Fix call to make_event_array.

	* alloc.c (make_event_array): Renamed from make_array.
	Chars that fit in a string are 0...127 and their meta variants.

	* keyboard.c (make_lispy_event): Put meta and shift modifiers
	into an integer.
	(read_avail_input): Set the modifiers field in the events read.
	(kbd_buffer_get_event): Pass thru integer event untruncated.
	(read_char): Likewise.
	(read_key_sequence, read_char): Only -1 means EOF.
	(kbd_buffer_store_event): Don't ignore 0200 bit in quit char.
	(follow_key): Use new meta bit flag.

	* xterm.c (XTread_socket): Set bufp->modifiers for all kinds of keys.

	* keymap.c (Flookup_key): Use 0x800000 as meta-bit if from vector.
	(Fdefine_key): Likewise.

1993-03-04  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* dgux.h (ELF): Handle this parameter.
	[! COFF] (UNEXEC, USG_SHARED_LIBRARIES): New definitions.
	(_BSD_TTY_FLAVOR): Don't define if already defined.
	(C_COMPILER, LINKER, MAKE_COMMAND): New definitions.

1993-03-04  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (Fsuspend_emacs): Remember that `suspend-hooks' isn't
	necessarily bound.

1993-03-04  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* Makefile.in (xmakefile): Add missing quote.

1992-03-03  Wilson H. Tien  (wtien at urbana.mcd.mot.com)

	* unexelf.c (unexec): Move data2 section header up so all section
	headers will be in ascending order.  This will prevent the unexeced
	emacs that being processed by other applications (such as strip) 
	to fail.

1993-03-02  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/isc2-2.h (S_IFLNK): Add #undef.
	(C_SWITCH_SYSTEM): Add conditional definition.
	(NO_ASM, USE_UTIME, NO_X_DESTROY_DATABASE): Defined.
	(LIB_STANDARD): Alternate definition if __GNUC__.
	(SIGTSTP): #undef deleted.
	(LIBS_SYSTEM): Define only if HAVE_X_WINDOWS.
	* s/isc3-0.h: New file.

	* unexelf.c: Handle rounding of section boundaries.
	(round_up): New function.

1993-03-02  Karl Berry  (karl@cs.umb.edu)

        * s/isc2-2.h (USG_SHARED_LIBRARIES, CLASH_DETECTION, NO_FCHMOD):
        Define.
        (HAVE_TIMEVAL): Do not define.
        (NO_ASM): Only define once.

1993-03-02  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* print.c (float_to_string): Define buf to be an unsigned char, to
	match the data field of strings.

	* keyboard.c (kbd_buffer_get_event): Protect assignment to
	Vlast_event_frame in a "#ifdef MULTI_FRAME" clause.

	* syntax.c (describe_syntax_1): Delete excess arg to describe_vector.
	(check_syntax_table): Delete excess arg to wrong_type_argument.

1993-03-01  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* buffer.c (buffer-undo-list): Doc fix.

	* xdisp.c (redisplay): Protect calls to request_sigio and
	unrequest_sigio in "#ifdef SIGIO" clauses; these are not defined 

	* cmds.c (Fnewline): Doc fix.

1993-03-01  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* insdel.c (del_range): Update point before offset_intervals.

	* intervals.h: Don't include dispextern.h more than once.
	(INTERVAL_VISIBLE_P): NILP test was backwards.

	* intervals.c (intervals_equal): Handle one arg null and other not.
	(set_point): Considerable rewrite.  Handle intervals both
	before and after the old and new point values.
	Redo handling of invisible intervals, and of motion hooks.
	(textget): New function.

	* textprop.c (Fadd_text_properties, Fremove_text_properties):
	Add len>0 as condition for main loop.
	Abort if reach a null interval.
	(Fset_text_properties): Abort if reach a null interval.
	(Ftext_properties_at, Fget_text_property):
	Return nil if POS is end of OBJECT.
	(add_properties): Use NILP to test result of Fequal.
	No longer inline.
	(remove_properties): No longer inline.
	(set_properties): Total rewrite as function.
	(validate_interval_range): Don't alter *begin at end of buffer.
	But do search for a position just before the end.
	Return null for an empty string.

1993-02-28  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* Makefile.in (emacs, temacs): Add @true to prevent Make confusion.

	* lread.c (read1--strings with properties case):
	Detect end of list, and invalid syntax, using recursive read1 calls.

	* intervals.c (graft_intervals_into_buffer):
	create_root_interval needs Lisp object arg.
	Set tree to new root interval.
	Don't test TREE_LENGTH if buffer has no intervals.
	Rearrange code to copy properties so that it really
	does merge the inserted ones into the inherited ones.
	(traverse_intervals): Pass `arg' on recursive calls.
	(split_interval_left): Use new_length as basis for length of new.

	* print.c (print--string case):
	Any non-null interval means print intervals.
	Get rid of var obj1; just use obj.

	* textprop.c (validate_interval_range): Allow 0 as position in string.
	Add 1 to specified string positions.
	(Fprevious_single_property_change): Subtract 1 if object is string.
	(Fnext_single_property_change): Likewise.
	(Fprevious_property_change, Fnext_property_change): Likewise.

	* xterm.c (x_do_pending_expose, XTframe_rehighlight):
	(x_window_to_scrollbar): Use XGCTYPE.

1993-02-28  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	Use the term `scroll bar', instead of `scrollbar'.
	* alloc.c, frame.c, frame.h, indent.c, keyboard.c, keyboard.h,
	lisp.h, term.c, termhooks.h, window.c, window.h, xdisp.c, xfns.c,
	xterm.c, xterm.h: Terminology changed.

        Don't generate switch-frame events by checking Vlast_event_frame;
	use a separate variable for that bookkeeping.  In order to
	generate them properly, we may need to fiddle with it.
	* keyboard.c (internal_last_event_frame): New variable.
	(command_loop_1): Check internal_last_event_frame, not
	Vlast_event_frame.
	(read_char, kbd_buffer_store_event): Set both Vlast_event_frame and
	internal_last_event_frame.
	(kbd_buffer_get_event): Check internal_last_event_frame to decide
	whether to generate a switch-frame event.  Set Vlast_event_frame
	after each event.
	(init_keyboard): Initialize both Vlast_event_frame and
	internal_last_event_frame.
	* keyboard.h (internal_last_event_frame): Add extern declaration
	for this.
	* frame.c (Vlast_event_frame): Remove external declaration for
	this.
	(Fselect_frame): Set internal_last_event_frame to Qnil to force a
	switch-frame event, not Vlast_event_frame; the latter is supposed
	to convey information to the user.

	* keyboard.c (syms_of_keyboard): Doc fix for unread_command_events.

1993-02-26  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (syms_of_keyboard): Doc fix.

1993-02-26  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile (LIBES): Exchange the order of LIB_MATH and
	LIB_STANDARD, to avoid duplicated symbols under SunOS.

	* buffer.c (syms_of_buffer): Add the extra argument to the
	commented-out DEFVAR_PER_BUFFER for `mode-line-format', so
	make-docfile will find the docstring properly.

1993-02-25  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (intervals.o): Dep on intervals.c, not textprop.c.

	* textprop.c (remove_properties): Call modify_buffer.
	(add_properties): Likewise.

	* undo.c (record_property_change): Typo in last change.

	* cmds.c (syms_of_cmds): Typo in last change.

	* print.c (print): Never declare OBJ arg as `register'.
	Special handling for strings with intervals.
	(print_intervals): New function.
	* lread.c (read1): Handle reading strings with properties.

	* intervals.c (traverse_intervals): New arg ARG.
	* alloc.c (mark_interval): Add ignored arg.
	(mark_interval_tree): Pass new arg to traverse_intervals.

1993-02-24  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xterm.c (x_window_to_scrollbar, x_scrollbar_expose,
	x_scrollbar_handle_click, x_scrollbar_note_movement): Remember
	that these can be called during GC; we have to ignore mark bits.
	* lisp.h (GC_NILP, GC_EQ): New macros to help with that.

	* print.c (float_to_string): Define buf to be an unsigned char, to
	match the data field of strings.

	* lisp.h (RETURN_UNGCPRO): Remove "do ... while (0)" wrapper
	around macro.

	* data.c (Fstring_to_number): Declare p to be an unsigned char, to
	match the data field of strings.

	* data.c (Fstring_to_number): Just skip tabs and spaces; don't use
	the <ctype.h> macros.  The <ctype.h> stuff apparently varies from
	locale to locale more than we'd like.  Don't include <ctype.h>.

1993-02-24  Roland McGrath  (roland@churchy.gnu.ai.mit.edu)

	* buffer.c (Ferase_buffer): Added interactive spec.

1993-02-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* undo.c (Fprimitive_undo): Handle property-change undo entry.
	(record_property_change): New function.

	* textprop.c (Fadd_text_properties): Pass new arg to add_properties.
	(Fremove_text_properties): Likewise.
	(add_properties, remove_properties): New arg OBJECT.  Record undo info.
	(Fput_text_property): New function.

	* buffer.c (syms_of_buffer): Doc fix.

	* cmds.c (syms_of_cmds): New var `overwrite-binary-mode'.
	(internal_self_insert): Handle that var.

1993-02-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_avail_input): Args to `kill' were backwards.

1993-02-23  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* alloc.c (make_pure_float): Assure that PUREBEG + pureptr is
	aligned, not pureptr itself.

	* emacs.c (fatal_error_signal): Unblock the signal before we try
	to deliver it to ourselves. #include "syssignal.h" to get the
	right definitions.

	* abbrev.c (Fexpand_abbrev): Only copy the text we're going to
	expand - from wordstart to wordend, not from wordstart to point -
	into the buffer.  There might be non-word text between wordend and
	point.

1993-02-23  Richard Stallman  (rms@geech.gnu.ai.mit.edu)

	* unexec.c (adjust_lnnoptrs): Handle symentry.n_type == 0x2400.
	(make_hdr) [USG_SHARED_LIBRARIES]: Set bias using bss_start.

1993-02-22  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c: Make sure we don't miss processes exiting, by having
	the sigchld handler clear *input_available_clear_time.
	(wait_reading_process_input): Check for process activity after
	setting the timeout and calling set_waiting_for_input.
	(sigchld_handler): If the process which has exited is one we care
	about, clear *input_available_clear_time.

	* frame.c (Fselect_frame): Set Vlast_event_frame to Qnil after
	switching frames, to make sure we'll get a switch-frame event.
	(Vlast_event_frame): Add external declaration for this here.

	* alloc.c (make_pure_float): Align pureptr according to __alignof,
	if it's available, or sizeof (struct Lisp_Float) if it's not.

	* .gdbinit (xprocess): New command.

	* floatfns.c (Flogb): Always implement this by calling Flog, even
	on non-USG systems, which supposedly have a logb function.
	(Fround): Always implement this by calling floor, even on systems
	that have rint.

	* process.c (process_send_signal): Use TERMIOS functions in
	preference to BSD ioctls.  Some systems attempt to provide the BSD
	functions for backward compatibility, and get it wrong.

	* data.c (Fstring_to_number): Skip initial spaces, to make Emacs
	lisp parse consistently on different operating systems.
	#include <ctype.h> to help with this.

	* data.c (Fstring_to_int): Rename this to Fstring_to_number, since
	it parses floats as well as integers.  Fix docstring.
	(syms_of_data): Fix defsubr.
	(wrong_type_argument): Change use.
	(Fint_to_string): Doc fix.
	* lisp.h (Fstring_to_int): Change extern declaration.

1993-02-22  Charles Hannum  (mycroft@hal.gnu.ai.mit.edu)

	* ibmrs6000.h (C_ALLOCA, STACK_DIRECTION): Only define if HAVE_ALLOCA
	is not defined.
	(X_DEFAULT_FONT): Change to `fixed', as `Rom14.500' only works on the
	console.

	* aix3-1.h: Changes from 18.58.
	(HAVE_TERMIOS): Changed from HAVE_TERMIO.
	(unix): Define.

	* sysdep.c (child_setup_tty): Recognize HAVE_TERMIOS as well as
	HAVE_TERMIO.

	* xrdb.c (getuid): Remove declaration.

	* systty.h [HAVE_TERMIOS]: Include fcntl.h.

	* systime.h [_AIX]: Move test outside of previous #if.
	(EMACS_GET_TZ_OFFSET) [USG]: Don't declare twice.  Prefer tzset.

	* keyboard.c (init_keyboard): Recognize HAVE_TERMIOS as well as
	HAVE_TERMIO.

	* aix3-2.h: New file.  Specifies difference between AIX 3.1 and 3.2.

1993-02-20  Richard Stallman  (rms@wookumz.gnu.ai.mit.edu)

	* keyboard.c (Fsuspend_emacs): Make tem not register.

	* syntax.c (Fforward_comment): New function.

	* search.c (Fskip_syntax_backward): New function.
	(Fskip_syntax_forward): Likewise.
	(skip_chars): New argument syntaxp.

	* alloc.c (Fmemory_limit): Doc fix.

1993-02-19  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Fsuspend_emacs): Rename suspend-hook to suspend-hooks
	and run it manually.

	* keymap.c (describe_map): Call Fkey_description before build_string.

1993-02-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Fopen_dribble_file): Doc fix.

	* lread.c (syms_of_lread): Doc fix.

1993-02-18  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* textprop.c (Fget_text_property): Fix typo in function's declaration.

	* floatfns.c (IN_FLOAT): Make this work properly when SIGTYPE is void.

	* alloc.c: Add description lines to the top of each page.

	* alloc.c (mark_interval_tree): Remove spurious & in front of
	function name.

	* alloc.c (UNMARK_BALANCE_INTERVALS): Fix to accomodate compilers
	other than GCC, which do not allow casts on the LHS of an
	assignment.

	* config.h.in: #define USE_TEXT_PROPERTIES by default.

	* alloc.c (mark_object, mark_buffer): Remove some unused
	variables.

	* buffer.c (Fswitch_to_buffer): Pass the correct number of
	arguments to Fnext_window.

	* buffer.c (Fbury_buffer): Pass the correct number of arguments to
	Fother_buffer.

	* bytecode.c (Fbyte_code): Pass the correct number of arguments to
	temp_output_buffer_show.

	* callint.c (Fcall_interactively): Pass the correct number of
	arguments to wrong_type_argument.
	* casefiddle.c (caseify_object): Same.
	* casetab.c (check_case_table): Same.
	* search.c (Fstore_match_data): Same.
	* syntax.c (check_syntax_table): Same.

	* callproc.c (delete_temp_file): Declare this to return
	Lisp_Object, to smooth type-checking.

	* data.c (wrong_type_argument): Pass the correct number of
	arguments to Fstring_to_int.

	* data.c (arithcompare): Add a default case which aborts, just to
	make me happy.

	* dispnew.c (sit_for): Pass the correct number of arguments to
	gobble_input.

	* editfns.c (Fmessage): Don't forget to return a value when
	args[0] == Qnil.

	* fns.c (Fequal): Call internal_equal to recurse on elements of
	lists and vectors, not Fequal.

	* frame.c (Fdelete_frame): If FRAME is a dead frame, return Qnil,
	not nothing.

	* keyboard.c (echo_char): Apply XINT to c before passing it to
	push_key_description.

	* keyboard.c (recursive_edit_1, command_loop_1): Pass the proper
	number of arguments to unbind_to.
	* lread.c (Feval_buffer): Same.
	* window.c (Fscroll_other_window): Same.

	* keyboard.c (command_loop_1): Apply XINT to c before passing it
	to internal_self_insert and direct_output_for_insert.

	* keyboard.c (make_lispy_movement): Rename the variable `part'
	declared in the block handling scrollbar movement to `part_sym',
	to avoid potential conflicts with the argument named `part'.
	Apparently the semantics of expressions like this are unclear.

	* keyboard.c (Fread_key_sequence): Backslash the newlines in this
	docstring.
	* textprop.c (Fget_text_property): Same.

	* keymap.c (Fdescribe_vector): Pass the proper number of arguments
	to describe_vector.
	* syntax.c (describe_syntax_1): Same.

	* minibuf.c (Fdisplay_completion_list): Pass the proper number of
	arguments to Flength.
	* xmenu.c (list_of_items): Same.

	* window.c (Fset_window_configuration): Pass the proper number of
	arguments to Fselect_frame.

	* xfns.c (x_set_icon_type): Pass the proper number of arguments to
	x_bitmap_icon.

	* xterm.c (XTread_socket): Pass the proper number of arguments to
	construct_mouse_click.

	* config.h.in (HAVE_CONST): New macro.  If it's not #defined, #define
	const to be the empty string.

	* config.h.in: If we're not __STDC__, define volatile to be the
	empty string.

	* buffer.h: Remove code which #includes "undo.h" if lint is
	defined.  undo.h no longer exists.

	* buffer.c (buffer_slot_type_mismatch): Make symbol_name an
	unsigned char *, to match the type of a string's data.

1993-02-17  Michael I Bushnell  (mib@geech.gnu.ai.mit.edu)

	* process.c (Fstart_process): Jimb's change of December 11
	had a misplaced paren.  This only became apparent because of
	jimb's change on February 8 to Fexpand_file_name.
	* callproc.c (Fcall_process): Ditto.

1993-02-17  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* callproc.c (init_callproc): Move the initialization of
	Vprocess_environment to its own function.
	(set_process_environment): This is that.
	* emacs.c (main): Call set_process_environment earlier than
	init_callproc.

1993-02-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* buffer.c (Frename_buffer): Make prefix arg set UNIQUE.

1993-02-14  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xterm.c (x_set_window_size): Call change_frame_size instead of
	just setting the `rows' and `cols' members of the frame, and
	leaving the window tree in complete disarray.

	* dispnew.c (remake_frame_glyphs): When re-allocating the frame's
	message buffer when echo_area_glyphs is pointing at it, relocate
	echo_area_glyphs too.  Same for previous_echo_glyphs.
	* window.h (previous_echo_glyphs): Add extern declaration for this.

	* frame.c (Fframe_parameters): Report the `minibuffer' parameter of
	minibufferless frames as nil, not `none'.
	(Qnone): Remove declaration and initialization for this.  It's not
	needed anymore.
	* xfns.c (Qnone): Add them here; we still accept "none" as a valid
	value for the `minibuffer' parameter.

	* xfns.c (x_frame_params): Remember that the parameters are called
	"auto-raise" and "auto-lower", not "autoraise" and "autolower".

	* xdisp.c (message): Set echo_frame to the frame whose message buf
	we want to use, not to the message buf itself.

1993-02-13  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* textprop.c (Fadd_text_properties): Put OBJECT arg last.
	Make it optional.
	(Fset_text_properties, Fremove_text_properties): Likewise.
	(Fnext_single_property_change, Fprevious_single_property_change): 
	(Fnext_property_change, Fprevious_property_change): Likewise.
	(Ferase_text_properties): #if 0.
	(Fget_text_property): New function.

	* s/irix4-0.h (C_SWITCH_MACHINE): Don't define if GCC.

1993-02-13  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* s/usg5-4.h: #include "usg5-3.h", not "s-usg5-3.h".

1993-02-11  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xterm.c (x_io_error_quitter): New function.
	(x_error_quitter): Note that this is only used for protocol
	errors now, not I/O errors.
	(x_term_init): Set the I/O error handler to x_io_error_quitter.

1993-02-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* editfns.c (Finsert_buffer_substring): Proper error for non-ex buffer.
	(Fcompare_buffer_substrings): Likewise.

1993-02-10  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* fileio.c (Fdo_auto_save): If NO_MESSAGE is non-nil, don't tell
	users that buffers have shrunk a lot.  This is called when Emacs
	is crashing, so we don't want to run any code that isn't
	absolutely necessary.  Also, autosave buffers which don't have
	specially handled autosave file names first.

1993-02-10  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* editfns.c (Fcompare_buffer_substrings): Ignore case
	if case-fold-search is non-nil.

1993-02-08  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keymap.c (Flookup_key, Fkey_binding, Flocal_key_binding,
	Fglobal_key_binding, Fminor_mode_key_binding): Add a new optional
	argument ACCEPT_DEFAULT, to control whether this function sees
	bindings for t.
	(Fwhere_is_internal, describe_map_tree, describe_map_2,
	describe_vector): Pass the proper arguments to Flookup_key.

	* fileio.c (Fexpand_file_name): Pass DEFALT through
	Fexpand_file_name before using it.

	* fileio.c (Fexpand_file_name): Doc fix.

1993-02-07  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xdisp.c (message): Use the message buffer of the frame we're
	going to display the message on to format the message, not that of
	the selected frame.

1993-02-07  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* Makefile (emacs, temacs): Add no-op commands to these rules.

	* dispnew.c (char_ins_del_cost): Use FRAME_WIDTH, not FRAME_HEIGHT.

	* editfns.c (Fcompare_buffer_substrings): New function.

1993-02-06  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (extra_keyboard_modifiers): New Lisp var.
	(read_char): Support ctl and meta bits in extra_keyboard_modifiers.
	* xterm.c (XTread_socket): Support extra_keyboard_modifiers.

1993-01-29  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* window.c (Fscroll_left, Fscroll_right): Don't forget to apply
	XWINDOW to selected_window before passing it to window_internal_width.

	* xmenu.c (Fx_popup_menu): Don't forget to turn the frame-relative
	coordinates for the menu position into root-window-relative
	coordinates.

	* lread.c (read1): Although digits followed by a '.' are an
	integer, a single . by itself (like, say, \.) should be a symbol.

1993-01-25  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* fns.c (internal_equal): Protect the clause for comparing numbers
	of different types with a "#ifdef LISP_FLOAT_TYPE".

1993-01-25  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/hpux8.h [__GNUC__] (LD_SWITCH_SYSTEM): Remove -a.
	[__GNUC__] (ORDINARY_LINK): Defined.

	* m/sparc.h [TERMINFO]: Don't define LIBS_TERMCAP.

1993-01-25  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

        `live-frame-p' has become `frame-live-p'.
	* frame.c (Qlive_frame_p): Renamed to Qframe_live_p.
	(Flive_frame_p): Renamed to Fframe_live_p.
	(syms_of_frame): Defsubrs and initializations adjusted.
	* frame.h (CHECK_LIVE_FRAME): Use Qframe_live_p, not Qlive_frame_p.
	(Qlive_frame_p): Changed extern declaration to Qframe_live_p.

	* lread.c (read1): Treat a string of digits ending in a period as
	an integer.

	Turn `first-change-function' into `first-change-hook'.
	* buffer.c (Vfirst_change_function): Renamed to Vfirst_change_hook.
	(Qfirst_change_hook): New symbol, for passing to Vrun_hooks.
	(syms_of_buffer): Change DEFVAR; initialize Qfirst_change_hook.
	* buffer.h (Vfirst_change_function): Renamed to Vfirst_change_hook.
	(Qfirst_change_hook): Added declaration.
	* insdel.c (signal_before_change): Change references to
	Vfirst_change_function, and apply Vrun_hooks to
	Qfirst_change_hook, instead of just calling Vfirst_change_function
	directly.

	x-selection-value has been renamed to x-selection.
	x-own-selection has been renamed to x-set-selection, and the order
	of its arguments has been reversed, for consistency with other
	lisp functions like put and aset.
	* xselect.c (Fx_own_selection): Rename to Fx_set_selection, 
	reverse the order of the args, and therefore make the type
	non-optional.  Doc fix.
	(Fx_selection_value): Rename to Fx_selection; make the type
	argument non-optional, for symmetry with Fx_set_selection.  Doc
	fix.
	(syms_of_xselect): Adjusted.

	* xselect.c (Fx_own_selection, Fx_selection_value): Remove "#if
	0"'ed code which made cut buffers look like a special selection
	type.

	* xfns.c (Vx_selection_value): Removed extern declaration for
	this; it's never used.

	* data.c (Fcompiled_function_p): Renamed to Fbyte_code_function_p.
	(syms_of_data): Adjusted.

	* data.c (Fnumberp, Fnumber_or_marker_p): Use the NUMBERP macro,
	instead of writing it out.

	* fns.c (internal_equal): If the operands are both numbers,
	compare them numerically, so that (equal 1.0 1) => t.
	Compare Lisp_Compiled objects like vectors.

	Add lisp functions to raise and lower frames.
	* termhooks.h (frame_raise_lower_hook): New hook.
	* term.c (frame_raise_lower_hook): Define it.
	* frame.c (Fframe_to_front, Fframe_to_back): New functions.
	(syms_of_frame): defsubr them.
	* xterm.c (XTframe_raise_lower): New function.
	(x_term_init): Set frame_raise_lower_hook to XTframe_raise_lower.

	* frame.c: Doc fixes.

1993-01-24  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	Make the cursor style a frame parameter.
	* xterm.h (struct x_display): Rename the `text_cursor_kind' member
	to `current_cursor'; add new member `desired_cursor'.
	(FRAME_DESIRED_CURSOR): New accessor for new member.
	* xterm.c (x_display_bar_cursor): Rewritten so as not to damage
	the characters the cursor is displayed over, and to handle
	transitions between box and bar styles.
	(x_display_bar_cursor, x_display_box_cursor): Use current_cursor
	instead of text_cursor_kind.
	(Vbar_cursor): Delete external declaration.
	(x_display_cursor): Use the FRAME_DESIRED_CURSOR accessor instead
	of Vbar_cursor to decide how to draw the cursor.
	* xfns.c (Vbar_cursor): Remove definition.
	(Qbar, Qbox, Qcursor_type): New symbols. 
	(syms_of_xfns): Init and staticpro them; remove DEFVAR for
	Vbar_cursor.
	(x_set_cursor_type): New setter.
	(x_frame_parms): Add it to the list.
	(Fx_create_frame): Get default values for the cursor type.

	* frame.c (Fmouse_position): Pass the appropriate arguments to
	*mouse_position_hook; the protocol was changed, but this caller
	wasn't fixed.

	* xterm.c (XTclear_frame): Call x_scrollbar_clear.
	(x_scrollbar_clear): New function.

	* xterm.c (XTflash): Totally rewritten.  Only defined if
	HAVE_TIMEVAL and HAVE_SELECT are defined, since we use select for
	our timing.
	(timeval_subtract): New function, to help XTflash.
	(x_invert_frame): Removed.  This didn't work anyway.
	(XTring_bell): Remove "#if 0" around call to XTflash, and remove
	calls to x_invert_frame.  If both HAVE_TIMEVAL and HAVE_SELECT
	aren't defined, then just do the ordinary beep.

	* window.c (Fscroll_other_window): Prefer windows on the selected
	frame, then look for windows on other visible frames.

	* keyboard.c (Fmouse_click_p): Removed; with the 'e' spec, this
	isn't necessary anymore.
	(syms_of_keyboard): Remove defsubr for it.
	* keyboard.h (Fmouse_click_p): Remove extern declaration for it.

	* xfns.c (gray_bits): Remove this declaration; the same data is in
	<X11/bitmaps/gray>.  #include that instead.
	[not HAVE_X11] (x_set_border_pixel): Use gray_width and
	gray_height, instead of assuming that the bitmap is 16x16.
	(x_make_gc): Instead of creating a pixmap and then calling
	XPutImage to make it into a grey stipple, just call
	XCreatePixmapFromBitmapData to do it all at once.

	* xterm.c (x_text_icon): Move the request for font information
	into the "not HAVE_X11" part of the function; the X11 code doesn't
	need this.

	* xterm.c (x_wm_set_icon_pixmap): Instead of setting the
	icon_pixmap to None, just remove IconPixmapHint from the flags of
	the XWMHints structure.

	* window.c (Fprevious_frame): Use prev_frame when we get to the
	end of the current frame, not next_frame.  Doc fix.
	* frame.c (prev_frame): Remove "#if 0" from this function.  It
	turns out we do need it, to make prev_frame work right.

	* frame.c (next_frame): Check that FRAME is a live frame.

	* frame.c (Fselect_frame): Remove "#ifdef MULTI_FRAME" clause
	around the code which calls Ffocus_frame; this code is already
	inside an "#ifdef MULTI_FRAME" clause.
	(next_frame, prev_frame, Fnext_frame): For the same reasons,
	remove the "#ifdef MULTI_FRAME" clause around these functions.

	unread-command-event has been replaced by unread-command-events.
	* commands.h (unread_command_event): Change extern declaration.
	* keyboard.c (unread_command_event): Change the definition.
	(syms_of_keyboard): Change DEFVAR, and adjust the docstring.
	(command_loop_1, read_char, Finput_pending, Fdiscard_input,
	quit_throw_to_read_char, init_keyboard): Change to use
	unread_command_events, with the new semantics.
	* lread.c (read_char): Same.
	* minibuf.c (temp_echo_area_glyphs): Same.
	* xterm.c (unread_command_event): Remove external declaration for
	this; it is only used by obsolete code.

	* Makefile.in: Some makes can't handle comments in the middle of
	commands; move them to before the whole rule.

1993-01-21  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (make_lispy_event): When handling a mouse click event
	on a window, change x and y from screen coordinates to window
	coordinates even when the click isn't in the text area.

	* xterm.c (x_scrollbar_create): Remove code which asks for
	EastGravity for windows; Emacs can't correctly deal with them
	moving around unexpectedly.

	* xterm.c (XTread_socket): Minor reformatting.

	* xterm.c (x_set_window_size): Always mark the frame garbaged.

        * window.c (Vmouse_window): Variable removed; it can't be handled
	properly without race conditions, and the events give you all the
	information you need anyway.
	(syms_of_window): Remove DEFVAR.
	* callint.c (Fcall_interactively): Change the `@' spec to select
	the window of the first parameterized event in the key sequence
	which invoked the command, instead of using Vmouse_window, which
	isn't even updated anymore.  Adjust the documentation
	accordingly.

1993-01-20  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xterm.c (x_scrollbar_create): Set the scrollbars to use
	EastGravity.

	* keyboard.c (make_lispy_event): Deal with button releases with no
	stored down-going position.  Make sure we always store a Qnil in
	the right button_down_location element after using it.

1993-01-19  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* frame.c (Fdelete_frame): Clear the frame's display after calling
	the window-system-dependent frame destruction routine.  We
	no longer need to pass the display as a separate argument to
	x_destroy_window.
	* xterm.c (x_destroy_window): Put the code which clears out f's
	display here, right after we free the storage it points to.  Put
	everything, including the code which clears x_focus_frame and
	x_highlight_frame, inside the BLOCK/UNBLOCK_INPUT pair.

	* dispnew.c (Fredraw_display): Undo change of Jan 12; redraw only
	frames whose garbaged flag is set.  The change to
	FRAME_SAMPLE_VISIBILITY on Jan 14 should address the problem better.

	keyboard.c (read_char_menu_prompt): Test HAVE_X_WINDOWS, not
	HAVE_X_WINDOW.

	The CPP symbol indicating whether or not we have mouse menu
	support under X Windows is HAVE_X_MENU, not not NO_X_MENU.
	* emacs.c (main): Test HAVE_X_MENU, instead of NO_X_MENU.
	* keyboard.c (read_char_menu_prompt): Same.
	* ymakefile: Same.

	* keyboard.c (read_char, read_char_menu_prompt): Use the
	EVENT_HAS_PARAMETERS macro from keyboard.h, instead of writing it
	out.

	* keyboard.c (read_char_menu_prompt): Doc fix.

	* keyboard.c (read_char_menu_prompt): Fix test for no menus;
	comparing name to Qnil doesn't work if we are called with no maps.

	* keymap.c (Fdefine_key): Call Fkey_description to make the string
	to use in the error message.

1993-01-18  Roland McGrath  (roland@churchy.gnu.ai.mit.edu)

	* window.c (Fdisplay_buffer): Doc fix.

1993-01-16  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xterm.c (x_window_to_scrollbar): Search frames'
	condemned_scrollbars list as well; input might arrive during
	redisplay.
	(x_scrollbar_report_motion): Don't forget to BLOCK_INPUT.
	(XTjudge_scrollbars): Clear the condemned scrollbar list before
	traversing it, so we don't try to process an event on a scrollbar
	we've killed.

1993-01-15  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (Frecent_keys): Doc fix.

1993-01-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* window.c (Fwindow_at): Doc fix.

1993-01-14  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xterm.c (x_scrollbar_create): Include PointerMotionHintMask in
	the event mask for scrollbars.

	* dispnew.c (Fredraw_display): DEFUN was missing a closing paren.

	* term.c (set_vertical_scrollbar_hook, condemn_scrollbars_hook,
	redeem_scrollbar_hook, judge_scrollbars_hook): Removed dumbo
	"externs" from these.  They're supposed to be real definitions.

	* .gdbinit: Add "-geometry +0+0" to default args.
	(xscrollbar): New command.

	Make scrollbar structures into lisp objects, so that they can be
	GC'd; this allows windows and scrollbars can refer to each other
	without worrying about dangling pointers.
	* xterm.h (struct x_display): vertical_scrollbars and
	judge_timestamp members deleted.
	(struct scrollbar): Redesigned to be a template for a Lisp_Vector.
	(SCROLLBAR_VEC_SIZE, XSCROLLBAR, SCROLLBAR_PACK, SCROLLBAR_UNPACK,
	SCROLLBAR_X_WINDOW, SET_SCROLLBAR_X_WINDOW,
	VERTICAL_SCROLLBAR_INSIDE_WIDTH, VERTICAL_SCROLLBAR_TOP_RANGE,
	VERTICAL_SCROLLBAR_INSIDE_HEIGHT, VERTICAL_SCROLLBAR_MIN_HANDLE):
	New macros, to help deal with the lispy structures, and deal with
	the graphics.
	* frame.h (WINDOW_VERTICAL_SCROLLBAR): Macro deleted.
	(struct frame): New fields `scrollbars' and
	`condemned_scrollbars', for use by the scrollbar implementation.
	[MULTI_FRAME and not MULTI_FRAME] (FRAME_SCROLLBARS,
	FRAME_CONDEMNED_SCROLLBARS): Accessors for the new field.
	* window.h (struct window): Doc fix for vertical_scrollbar field.
	* frame.c (make_frame): Initialize the `scrollbars' and
	`condemned_scrollbars' fields of the new frame.
	* alloc.c (mark_object): Mark the `scrollbars' and
	`condemned_scrollbars' slots of frames.
	* xterm.c (x_window_to_scrollbar): Scrollbars are chained on
	frames' scrollbar field, not their x.display->vertical_scrollbars
	field.
	(x_scrollbar_create, x_scrollbar_set_handle, x_scrollbar_move,
	x_scrollbar_remove, XTset_vertical_scrollbar,
	XTcondemn_scrollbars, XTredeem_scrollbar, XTjudge_scrollbars,
	x_scrollbar_expose, x_scrollbar_handle_click,
	x_scrollbar_handle_motion): Substantially rewritten to correct
	typos and brainos, and to accomodate the lispy structures.

	* xterm.c (x_scrollbar_background_expose): Function deleted; we
	don't want anything in the background there after all.
	(XTread_socket): Don't call x_scrollbar_background_expose.  We
	don't care.

	* frame.h (FRAME_SAMPLE_VISIBILITY): Make sure frame is marked as
	garbaged whenever it goes from invisible to visible.
	* dispextern.h (frame_garbaged): Move extern declaration from here...
	* frame.h (frame_garbaged): ... to here.  The FRAME_SAMPLE_VISIBILITY
	macro uses it now, and this seems to be just as modular.  Make a
	new page, just for this and message_buf_print.
	(struct frame): Doc fix for the `visible' field.
	* process.c: #include "frame.h" instead of "dispextern.h"; the
	only thing we care about from it is the frame_garbaged
	declaration.
	* ymakefile: Note dependency change.

	* xfns.c (Fx_create_frame): After mapping the frame, call
	SET_FRAME_GARBAGED, not just plain FRAME_GARBAGED.

	* window.c (window_internal_width): New function, which accounts
	for scrollbars if present.
	* lisp.h (window_internal_height, window_internal_width): Add
	extern declarations for these.
	* dispnew.c (direct_output_for_insert, direct_output_forward_char,
	buffer_posn_from_coords): Use window_internal_width instead of
	writing out its definition.
	* indent.c (compute_motion): Doc fix; mention scrollbars and
	window_internal_width.
	(pos_tab_offset, Fvertical_motion): Use window_internal_width
	instead of writing it out.
	* window.c (Fpos_visible_in_window_p, Fwindow_width, Fscroll_left,
	Fscroll_right): Same.
	* xdisp.c (redisplay, try_window, try_window_id,
	display_text_line): Same.

	* xdisp.c (display_string): Add new variable `f', to be W's
	frame.  Use it to set desired_glyphs, and to get the frame's width
	to decide whether or not to draw vertical bars.

	* xdisp.c (display_text_line): If we're using vertical scrollbars,
	don't draw the vertical bars separating side-by-side windows.
	(display_string): Same thing.  Draw spaces to fill in the part of
	the mode line that is under the scrollbar in partial-width
	windows.

	* xfns.c (Qvertical_scrollbars): New symbol.  Use it as the name
	of the parameter which decides whether or not the frame has
	scrollbars, instead of Qvertical_scrollbar.
	(Fx_create_frame): Adjusted accordingly.
	(syms_of_xfns): Initialize and staticpro Qvertical_scrollbars.
	(x_set_vertical_scrollbar): Renamed to x_set_vertical_scrollbars.
	(x_frame_parms): Adjusted accordingly.

	* xterm.h (CHAR_TO_PIXEL_WIDTH, CHAR_TO_PIXEL_HEIGHT,
	PIXEL_TO_CHAR_WIDTH, PIXEL_TO_CHAR_HEIGHT): Rewritten, using:
	(CHAR_TO_PIXEL_ROW, CHAR_TO_PIXEL_COL, PIXEL_TO_CHAR_ROW,
	PIXEL_TO_CHAR_COL): New macros.
	* xfns.c [not HAVE_X11] (Fx_create_frame): Use the
	PIXEL_TO_CHAR_{HEIGHT,WIDTH} macros to figure the frame's
	character size, and the CHAR_TO_PIXEL* macros for vice versa.
	* xterm.c (XTwrite_glyphs, XTclear_end_of_line, stufflines,
	scraplines, dumprectangle, pixel_to_glyph_coords, x_draw_box,
	clear_cursor, x_display_bar_cursor, x_draw_single_glyph,
	x_set_mouse_position): Use the CHAR_TO_PIXEL_* macros.

	* xterm.c (x_wm_set_size_hint): The max_width and max_height
	members of the size_hints are expressed in pixels, not columns.

	* xterm.c (x_set_window_size): Remove ibw var; it's not used.
	Set FRAME_WIDTH (f) to cols instead of rows.  Duh.

	* xterm.c (pixel_to_glyph_coords): Properly set *bounds to the
	character cell bounding the position, even when the position is
	off the frame.

	* xfns.c (x_set_name): To request that the modelines be redrawn,
	execute the statement "update_mode_lines = 1;" instead of the
	silly statement "update_mode_lines;".

	* xfns.c (x_set_vertical_scrollbars): Don't try to set the
	X window's size if the frame's X window hasn't been created yet.

	* xfns.c (x_figure_window_size): Set the frame's
	vertical_scrollbar_extra field before trying to calculate its
	pixel dimensions.

	* xfns.c (x_window): When calling x_implicitly_set_name for the
	sake of drawing the name for the first time, remember to clear and
	set the frame's explicit_name member as well as its name member.
	(Fx_create_frame): Set the frame's explicit_name member if the
	user specified the name explicitly.

	* xdisp.c (display_text_line): Use the usable internal width of
	the window, as calculated above, as the limit on the length of the
	overlay arrow's image, rather than using the window's width field,
	less one.

	* xdisp.c (redisplay): Call condemn_scrollbars_hook and
	judge_scrollbars_hook whenever they are set, not just when the
	frame has vertical scrollbars.

	* termhooks.h (mouse_position_hook): Doc fix.
	(set_vertical_scrollbar_hook): This doesn't return anything any
	more, and doesn't take a struct scrollbar * argument any more.
	(condemn_scrollbars_hook, redeem_scrollbar_hook,
	judge_scrollbars_hook): Doc fixes.
	* term.c (mouse_position_hook): Doc fix.
	(set_vertical_scrollbar_hook): This doesn't return
	anything any more.  Doc fixes.
	* keyboard.c (kbd_buffer_get_event): Receive the scrollbar's
	window from *mouse_position_hook and pass it to
	make_lispy_movement, instead of working with a pointer to a struct
	scrollbar.
	(make_lispy_event): We don't need a window_from_scrollbar function
	anymore; we are given the window directly in *EVENT.
	Unify the code which generates
	text-area mouse clicks and scrollbar clicks; use the same code to
	distinguish clicks from drags on the scrollbar as in the text area.
	Distinguish clicks from drags by storing a copy of the lispy
	position list returned as part of the event.
	(button_down_location): Make this a lisp vector, rather than an
	array of random structures.
	(struct mouse_position): Remove this; it's been replaced by a lisp
	list.
	(make_lispy_movement): Accept the scrollbar's window as a
	parameter, rather than the scrollbar itself.
	If FRAME is zero, assume that the other arguments are garbage.
	(syms_of_keyboard): No need to staticpro each window of
	button_down_location now; just initialize and staticpro it.
	* window.c (window_from_scrollbar): Function deleted; no longer
	needed.
	* xdisp.c (redisplay_window): Just pass the window to
	set_vertical_scrollbar hook; don't pass the scrollbar object too.
	* xterm.c (XTmouse_position): Don't return a pointer to the
	scrollbar for scrollbar motion; instead, return the scrollbar's
	window.

	* xterm.c (XTmouse_position): Entirely rewritten, using
	XTranslateCoordinates.  Call x_scrollbar_report_motion to handle
	scrollbar movement events.
	(x_scrollbar_report_motion): New function, to help out
	XTmouse_position.

	* keyboard.c (apply_modifiers): Don't assume that the Qevent_kind
	property of BASE is set when we first create the new modified
	symbol.  Check that the Qevent_kind property is properly set each
	time we return any symbol.

	* termhooks.h (struct input_event): Replace the frame member with
	a Lisp_Object member by the name of frame_or_window.  Doc fixes.
	Remove the scrollbar member; instead, use frame_or_window to hold the
	window whose scrollbar was clicked.
	* keyboard.c (kbd_buffer_store_event, kbd_buffer_get_event,
	make_lispy_event): Adjust references to frame member of struct
	input_event to use frame_or_window now.
	* xterm.c (construct_mouse_click, XTread_socket): Same.

	* xterm.c (last_mouse_bar, last_mouse_bar_frame, last_mouse_part,
	last_mouse_scroll_range_start, last_mouse_scroll_range_end):
	Replaced with...
	(last_mouse_scrollbar): New variable.
	(note_mouse_movement): Clear last_mouse_scrollbar when we have
	receieved a new motion.
	(syms_of_xterm): Staticpro last_mouse_scrollbar.

	* xterm.c (note_mouse_position): Renamed to note_mouse_movement,
	because that's what it really does.
	(x_scrollbar_handle_motion): Renamed to x_scrollbar_note_movement,
	for consistency.
	(XTread_socket): Adjusted.

	* xterm.c (XTset_scrollbar): Renamed to XTset_vertical_scrollbar.
	(x_term_init): Adjusted.

	* keyboard.c (kbd_buffer_frames): Renamed to
	kbd_buffer_frame_or_window, and made to exist even when
	MULTI_FRAME isn't defined; single-frame systems might have
	scrollbars.  Use it to GCPRO the frame_or_window field in the
	event queue.
	(kbd_buffer_store_event, kbd_buffer_get_event,
	stuff_buffered_input): Set and clear the
	appropriate element of kbd_buffer_frame_or_window, whether or not
	MULTI_FRAME is #defined.
	(read_avail_input): When reading characters directly from stdin,
	set the frame_or_window field of the event appropriately,
	depending on whether or not MULTI_FRAME is #defined.
	(Fdiscard_input, init_keyboard): Zap kbd_buffer_frame_or_window,
	not kbd_buffer_frames.
	(syms_of_keyboard): Initialize and staticpro
	kbd_buffer_frame_or_window, whether or not MULTI_FRAME is
	#defined.

	* keyboard.c (head_table): Make Qscrollbar_movement have a
	Qevent_kind property of Qmouse_movement, not Qscrollbar_movement.

	* keyboard.c (read_key_sequence): If we decide to throw away a
	mouse event which has prefix symbols (`mode-line',
	`vertical-scrollbar', etcetera), remember that we may have to
	unwind two characters, not just one.

	* keyboard.c (read_key_sequence): Doc fixes.

	* keyboard.c (kbd_buffer_store_event): Fix reversed sense of test
	for focus redirection.

	* keyboard.c (read_char): Don't echo mouse movements.

	* emacs.c (shut_down_emacs): New function.
	(fatal_error_signal, Fkill_emacs): Call it, instead of writing it out.
	* xterm.c (x_connection_closed): Call shut_down_emacs instead of
	Fkill_emacs; the latter will try to perform operations on the X
	server and die a horrible death.
	* lisp.h (shut_down_emacs): Add extern declaration for it.

	* xterm.c (x_error_quitter): Move the abort call to after we print
	the error message.  No harm in that.

	* xdisp.c (echo_area_display): Move the assignment of f and the
	check for visibility out of the "#ifdef MULTI_FRAME" clause; they
	should work under any circumstances.

	* xdisp.c (redisplay_window): If we're not going to redisplay this
	window because it's a minibuffer whose contents have already been
	updated, go ahead and jump to the scrollbar refreshing code
	anyway; they still need to be updated.  Initialize opoint, so it's
	known to be valid when we jump.  Calculate the scrollbar settings
	properly for minibuffers, no matter what they are displaying at
	the time.

	* xdisp.c (redisplay_windows): Don't restore the current buffer
	and its point before refreshing the scrollbars; we need the buffer
	accurate.

1993-01-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* print.c (float_to_string): Add final 0 if text ends with decimal pt.

	* dispnew.c (Fredraw_display): Redraw all visible frames.
	Make the non-multi-frame version interactive.

1993-01-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c (Fset_default_file_modes, Fdefault_file_modes):
	Renamed from Fset_umask and Fumask; sense of arg is reversed.
	(Fwrite_region): Doc fix.

1993-01-10  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* print.c (float_to_string): Add `.0' at end if needed.

	* lread.c (Fload): If warn that .elc file is older, inhibit
	the ordinary message that would follow.

1993-01-09  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* fileio.c (Fdo_auto_save): Add CURRENT_ONLY argument, as
	described in doc string.

1993-01-08  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fns.c (Frandom): Change arg name.

	* editfns.c: Doc fixes.

1993-01-07  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* unexhp9k800.c (unexec): Don't call exit, just return.

1993-01-07  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

        * config.h.in: protect against multiple #inclusions.

	* config.h.in: Add a declaration for getenv.

	* xfns.c (Fx_get_resource): Add CLASS argument, to give class of
	ATTRIBUTE.
	[not HAVE_X11]: Change definition of Fx_get_resource macro
	accordingly.
	(x_get_arg): Add CLASS argument, to give the class of ATTRIBUTE.
	Pass it along to Fx_get_resource.
	(x_figure_window_size, x_icon): Pass new argument to x_get_arg.
	(x_default_parameter): Add XCLASS argument, to give the class of
	XPROP.  Pass it along to x_get_arg.
	(Fx_create_frame): Pass new args to x_get_arg and
	x_default_parameter.

	* xfns.c (Fx_create_frame): Use the same resource names and
	classes as xterm and Emacs 18.

1993-01-03  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xfns.c (Fx_get_resource): Use EMACS_CLASS to make class_key
	even if SUBCLASS is specified.  I don't know whether that is
	right, but that's what the doc says.
	Cosmetic changes in arg names and doc string.

1992-12-29  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* ralloc.c: [! emacs] [HAVE_CONFIG_H]: #include "config.h"

1992-12-21  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* Makefile.in (tagsfiles): New variable.
	(TAGS): Depend on $(tagsfiles); use that in cmds.
	(tags): Separate phony rule; depends on TAGS.

1992-12-21  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

        * keyboard.c: Protect all references to kbd_buffer_frames with
	#ifdef MULTI_FRAME.

	* frame.h (struct frame): New fields `can_have_scrollbars' and
	`has_vertical_scrollbars'.
	(FRAME_CAN_HAVE_SCROLLBARS, FRAME_HAS_VERTICAL_SCROLLBARS): New
	accessors, for both the MULTI_FRAME and non-MULTI_FRAME.
	(VERTICAL_SCROLLBAR_WIDTH, WINDOW_VERTICAL_SCROLLBAR,
	WINDOW_VERTICAL_SCROLLBAR_COLUMN,
	WINDOW_VERTICAL_SCROLLBAR_HEIGHT): New macros.
	* window.h (struct window): New field `vertical_scrollbar'.
	* xterm.h (struct x_display): vertical_scrollbars,
	judge_timestamp, vertical_scrollbar_extra: New fields.
	(struct scrollbar): New struct.
	(VERTICAL_SCROLLBAR_PIXEL_WIDTH, VERTICAL_SCROLLBAR_PIXEL_HEIGHT,
	VERTICAL_SCROLLBAR_LEFT_BORDER, VERTICAL_SCROLLBAR_RIGHT_BORDER,
	VERTICAL_SCROLLBAR_TOP_BORDER, VERTICAL_SCROLLBAR_BOTTOM_BORDER,
	CHAR_TO_PIXEL_WIDTH, CHAR_TO_PIXEL_HEIGHT, PIXEL_TO_CHAR_WIDTH,
	PIXEL_TO_CHAR_HEIGHT): New accessors and macros.
	* frame.c (make_frame): Initialize the `can_have_scrollbars' and
	`has_vertical_scrollbars' fields of the frame.
	* term.c (term_init): Note that TERMCAP terminals don't support
	scrollbars.
	(mouse_position_hook): Document new args.
	(set_vertical_scrollbar_hook, condemn_scrollbars_hook,
	redeem_scrollbar_hook, judge_scrollbars_hook): New hooks.
	* termhooks.h: Declare and document them.
	(enum scrollbar_part): New type.
	(struct input_event): Describe the new form of the scrollbar_click
	event type.  Change `part' from a Lisp_Object to an enum
	scrollbar_part.  Add a new field `scrollbar'.
	* keyboard.c (kbd_buffer_get_event): Pass appropriate new
	parameters to *mouse_position_hook, and make_lispy_movement.
	* xfns.c (x_set_vertical_scrollbar): New function.
	(x_figure_window_size): Use new macros to calculate frame size.
	(Fx_create_frame): Note that X Windows frames do support scroll
	bars.  Default to "yes".
	* xterm.c: #include <X11/cursorfont.h> and "window.h".
	(x_vertical_scrollbar_cursor): New variable.
	(x_term_init): Initialize it.
	(last_mouse_bar, last_mouse_bar_frame, last_mouse_part,
	last_mouse_scroll_range_start, last_mouse_scroll_range_end): New
	variables.
	(XTmouse_position): Use them to return scrollbar movement events.
	Take new arguments, for that purpose.
	(x_window_to_scrollbar, x_scrollbar_create,
	x_scrollbar_set_handle, x_scrollbar_remove, x_scrollbar_move,
	XTset_scrollbar, XTcondemn_scrollbars, XTredeem_scrollbar,
	XTjudge_scrollbars, x_scrollbar_expose,
	x_scrollbar_background_expose, x_scrollbar_handle_click,
	x_scrollbar_handle_motion): New functions to implement scrollbars.
	(x_term_init): Set the termhooks.h hooks to point to them.
	(x_set_window_size): Use new macros to calculate frame size.  Set
	vertical_scrollbar_extra field.
	(x_make_frame_visible): Use the frame accessor
	FRAME_HAS_VERTICAL_SCROLLBARS to decide if we need to map the
	frame's subwindows as well.
	(XTread_socket): Use new size-calculation macros from xterm.h when
	processing ConfigureNotify events.
	(x_wm_set_size_hint): Use PIXEL_TO_CHAR_WIDTH and
	PIXEL_TO_CHAR_HEIGHT macros.
	* ymakefile (xdisp.o): This now depends on termhooks.h.
	(xterm.o): This now depends on window.h.

	* xdisp.c: #include "termhooks.h".
	(redisplay, redisplay_window): Use set_vertical_scrollbar_hook,
	condemn_scrollbars_hook, redeem_scrollbar_hook, and
	judge_scrollbars_hook to make scrollbars redisplay properly.

	* keyboard.c (Qscrollbar_movement, Qvertical_scrollbar,
	Qabove_handle, Qhandle, Qbelow_handle): New symbols.
	(make_lispy_event): New code to build scrollbar clicks.
	(make_lispy_movement): New code to handle scrollbar movement.
	(head_table): Include Qscrollbar_movement in the event heads.
	(syms_of_keyboard): Init and staticpro Qvertical_scrollbar,
	Qabove_handle, Qhandle, and Qbelow_handle.
	* keyboard.h (Qscrollbar_movement): Declare this along with the
	other event types.
	* lisp.h (Qvertical_scrollbar): Declare this.
	* window.c (window_from_scrollbar): New function.

	* xterm.h (struct x_display): Delete v_scrollbar, v_thumbup,
	v_thumbdown, v_slider, h_scrollbar, h_thumbup,
	h_thumbdown, h_slider, v_scrollbar_width, h_scrollbar_height
	fields.
	* keyboard.c (Qvscrollbar_part, Qvslider_part, Qvthumbup_part,
	Qvthumbdown_part, Qhscrollbar_part, Qhslider_part, Qhthumbup_part,
	Qhthumbdown_part, Qscrollbar_click): Deleted; part of an obsolete
	interface.
	(head_table): Removed from here as well.
	(syms_of_keyboard): And here.
	* keyboard.h: And here.
	(POSN_SCROLLBAR_BUTTON): Removed.
	* xscrollbar.h: File removed - no longer necessary.
	* xfns.c: Don't #include it any more.
	(Qhorizontal_scroll_bar, Qvertical_scroll_bar): Deleted.
	(syms_of_xfns): Don't initialize or staticpro them.
	(gray_bits): Salvaged from xscrollbar.h.
	(x_window_to_scrollbar): Deleted.
	(x_set_horizontal_scrollbar): Deleted.
	(enum x_frame_parm, x_frame_parms): Remove references to
	x_set_horizontal_scrollbar.
	(x_set_foreground_color, x_set_background_color,
	x_set_border_pixel): Remove special code to support scrollbars.
	(Fx_create_frame): Remove old scrollbar setup code.
	(install_vertical_scrollbar, install_horizontal_scrollbar,
	adjust_scrollbars, x_resize_scrollbars): Deleted.
	* xterm.c (construct_mouse_click): This doesn't need to take care of
	scrollbar clicks anymore.
	(XTread_socket): Remove old code to support scrollbars.  Call new
	functions instead for events which occur in scrollbar windows.
	(XTupdate_end): Remove call to adjust_scrollbars; the main
	redisplay code takes care of that now.
	(enum window_type): Deleted.
	* ymakefile: Note that xfns.o no longer depends on xscrollbar.h.

	* xterm.c (x_set_mouse_position): Clip mouse position to be within
	frame.

	* xterm.c: Adjust the first line of each page to have a reasonable
	description.  This makes pages-directory more useful.

	* xterm.c (x_do_pending_expose): Declare this routine only if
	HAVE_X11 is not #defined; X11 doesn't need it.
	(XTread_socket): Protect call to x_do_pending_expose with `#ifdef
	HAVE_X11'. 

	* xfns.c (syms_of_xfns): Delete defvars for x_mouse_x and
	x_mouse_y.  That interface hasn't been live for years.
	(x_mouse_x, x_mouse_y): Delete these variables.

	* xterm.c (notice_mouse_movement): Deleted; obsolete and unused.

	* keyboard.c (Fread_key_sequence): Doc fix.

	* keyboard.c (make_lispy_event): Buttons are numbered starting
	with zero now.

	* keyboard.c (make_lispy_event): Use the proper accessors when
	manipulating the `x' and `y' fields of struct input_event.

	* keyboard.c (parse_modifiers_uncached): Remember that strncmp
	returns zero if the two substrings are equal.

	* keyboard.c (do_mouse_tracking, Ftrack_mouse): Doc fix.

	* keyboard.c (read_char): Don't put mouse movements in
	this_command_keys.

	* xfns.c (Fx_create_frame): Don't initialize the wm_hints field here.
	(x_window): Do it here, along with all the similar stuff.

1992-12-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* callint.c (Fcall_interactively): For `s', use Fread_string.

1992-12-20  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	Properly handle focus shift events, so the cursor is filled and
	hollow at the appropriate times, even in titleless windows.
	* xterm.c (x_focus_event_frame): New variable.
	(XTread_socket): When we receive a FocusIn event that's not
	NotifyPointer, record the frame in x_focus_event_frame.  When we
	receive a FocusOut event that's not NotifyPointer, clear it.  When
	we get a LeaveNotify event, don't take it seriously if we still
	have focus.

	* xterm.c (XTread_socket): Remove special code in EnterNotify case
	to handle scrollbars and fake mouse motion events.

1992-12-19  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* floatfns.c (Flog): Fix unescaped newline in string.
	* frame.c (Fnext_frame): Same.
	* textprop.c (Fprevious_single_property_change): Same.
	(syms_of_textprop): Same, for DEFVAR for
	`interval_balance_threshold'.

	Change the meaning of focus redirection to make switching windows
	work properly.  Fredirect_frame_focus has the details.
	* frame.h (focus_frame): Doc fix.
	[not MULTI_FRAME] (FRAME_FOCUS_FRAME): Make this Qnil, which
	indicates no focus redirection, instead of zero, which is
	selected_frame.
	* frame.c (make_frame): Initialize f->focus_frame to Qnil, rather
	than making it point to frame itself.
	(Fselect_frame): If changing the selected frame from FOO to BAR,
	make all redirections to FOO shift to BAR as well.  Doc fix.
	(Fredirect_frame_focus): Doc fix.  Accept nil as a valid
	redirection, not just as a default for FRAME.
	(Fframe_focus): Doc fix.
	* keyboard.c (kbd_buffer_store_event, kbd_buffer_get_event): Deal
	with focus redirections being nil.
	* xterm.c (XTframe_rehighlight): Doc fix.  Deal with focus
	redirections being nil.

	* window.c (Fset_window_configuration): Don't restore the frame's
	focus redirection if the target frame is now dead.

	* ymakefile (ralloc.o): This no longer depends on xterm.h.

	* ymakefile (all, xemacs): We build an executable called `emacs' now,
	not `xemacs'.
	* Makefile.in (distclean, xemacs, doxemacs): Same.

	* xterm.h (PIXEL_WIDTH, PIXEL_HEIGHT): Change name of parameter
	from `s' to `f'; it's a frame pointer.

1992-12-18  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (kbd_buffer_frames): New vector, to GCPRO frames in
	kbd_buffer.
	(kbd_buffer_store_event): When we add an event to kbd_buffer, make
	sure to store its frame in kbd_buffer_frames.
	(kbd_buffer_get_event): When we remove an event from kbd_buffer,
	make sure to set the corresponding element of kbd_buffer_frames to
	Qnil, to allow the frame to get GC'd.
	(Fdiscard_input, init_keyboard): Clear all elements of
	kbd_buffer_frames to nil.
	(syms_of_keyboard): Create and staticpro kbd_buffer_frames.

	* xterm.c (x_error_quitter): Just abort, so we can look at the
	core to see what happened.

1992-12-17  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* buffer.c (Frename_buffer): Set update_mode_lines.

1992-12-14  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* scroll.c (do_scrolling): When bcopying the max_ascent field from
	current_frame to temp_frame, remember that max_ascent is an array
	of shorts, not ints.

	It's a pain to remember that you can't assign to FRAME->visible.
	Let's change all references to the `visible' member of struct
	frame to use the accessor macros, and then write a setter for the
	`visible' field that does the right thing.
	* frame.h (FRAME_VISIBLE_P): Make this not an l-value.
	(FRAME_SET_VISIBLE): New macro.
	* frame.c (make_terminal_frame, Fdelete_frame): Use FRAME_SET_VISIBLE.
	(Fframe_visible_p, Fvisible_frame_list): Use FRAME_VISIBLE_P and
	FRAME_ICONIFIED_P.
	* dispnew.c (Fredraw_display): Use the FRAME_VISIBLE_P and
	FRAME_GARBAGED_P accessors.
	* xdisp.c (redisplay): Use the FRAME_VISIBLE_P accessor.
	* xfns.c (x_set_foreground_color, x_set_background_color,
	x_set_cursor_color, x_set_border_pixel, x_set_icon_type): Use the
	FRAME_VISIBLE_P accessor.
	(Fx_create_frame): Use FRAME_SET_VISIBILITY.
	* xterm.c (clear_cursor, x_display_bar_cursor,
	x_display_box_cursor): Use FRAME_SET_VISIBILITY.

1992-12-12  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile (CFLAGS): #define HAVE_CONFIG_H too.

	* Makefile.in (distclean): Don't delete machine.h or system.h;
	they don't exist anymore.

	* Makefile.in (distclean): Don't delete autosave or backup files.
	(extraclean): New target; like distclean, but delete autosave
	and backup files too.

1992-12-11  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* search.c (Fskip_chars_forward, Fskip_chars_backward): Return the
	distance traveled.
	(skip_chars): Return the distance traveled, as a Lisp_Object.

	* macros.c (Fend_kbd_macro): Don't use XFASTINT to check if arg is
	negative; XFASTINT only works on values known to be positive.
	(Fexecute_kbd_macro): Check QUIT in the repetition loop.  If the
	macro is null, no characters are actually being read, so this
	matters.

	* Makefile.in (srcdir): New variable, not fully implemented.
	(xmakefile): Turn -g and -O in CFLAGS into C_DEBUG_SWITCH and
	C_OPTIMIZE_SWITCH in C_SWITCH_SITE's definition.  Delete junk.cpp
	when done.
	* ymakefile (archlib): Variable definition deleted.  Run programs
	from ../lib-src directly, or use ${archlibdir}.
	(${etc}DOC): Run make-docfile from ${libsrc}, not ${archlib}.
	(${archlib}make-docfile, ${archlib}emacstool): Use ${libsrc}, not
	${archlib}.

	* ymakefile (lisp): Don't include version.el in this list.

	Give subprocess creation a way to find a valid current directory
	for subprocesses when the buffer's default-directory is a handled
	name.
	* fileio.c (Funhandled_file_name_directory): New function.
	(Qunhandled_file_name_directory): New file-name-handler operation.
	(syms_of_fileio): Defsubr Sunhandled_file_name_directory, and
	initialize and staticpro Qunhandled_file_name_directory.
	* callproc.c (Fcall_process): Call Funhandled_file_name_directory
	on the buffer's default directory.  Do it earlier in the function
	so there's less to GCPRO.
	* process.c (create_process): Don't check the validity of the 
	buffer's default directory here...
	(Fstart_process): Instead, do it here; if we call
	Funhandled_file_name_directory here, there's less GCPROing to do.

	* callproc.c (Fcall_process_region): Return the value returned by
	Fcall_process.

	* fileio.c (find_file_handler): Rename this to
	Ffind_file_name_handler, and make it visible to lisp.  Add a QUIT
	to the loop which scans file-name-handler-alist.  All uses
	changed.
	(syms_of_fileio): Mention this new function in the docstring for
	Vfile_name_handler_alist.  defsubr Sfind_file_name_handler.
	* lisp.h (Ffind_file_name_handler): Added extern declaration.
	* dired.c: All uses of find_file_handler changed here too.

	* fileio.c (syms_of_fileio): Add staticpros for Qexpand_file_name,
	Qdirectory_file_name, Qfile_name_directory,
	Qfile_name_nondirectory, Qfile_name_as_directory.

1992-12-07  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* window.c (Fset_window_configuration): If we're restoring the
	configuration of a dead frame, don't bother rebuilding its window
	tree, restoring its focus redirection, or temporarily resizing it
	to fit the saved window configuration.  If the frame which was
	selected when the configuration was captured is now dead, don't
	try to select it.

	* frame.c (Fdelete_frame): Delete all the windows in the frame's
	window tree, using delete_all_subwindows.
	* window.c (delete_all_subwindows): Don't make this static
	anymore.

1992-12-03  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

        Make sure that frames' visible flag only changes at acceptable
	times.  See FRAME_SAMPLE_VISIBILITY's comments for details.
	* frame.h (struct frame): New fields called async_visible and
	async_iconified.
	(FRAME_SAMPLE_VISIBILITY): New macro, with MULTI_FRAME and
	non-MULTI_FRAME definitions.
	* xdisp.c (redisplay): Call FRAME_SAMPLE_VISIBILITY to set the
	visible and iconified flags appropriately for each frame.
	(message1): Call FRAME_SAMPLE_VISIBILITY to set the visible and
	iconified flags for the minibuffer frame.
	* frame.c (make_frame): Initialize async_visible and
	async_iconified properly.
	* xfns.c (Fx_create_frame): Initialize f->async_visible too.
	* xterm.c (XTread_socket): When we get MapNotify, UnmapNotify,
	Expose, ExposeWindow, or UnmapWindow, set f->async_visible, not
	f->visible.
	(x_do_pending_expose, x_raise_frame, x_lower_frame,
	x_make_frame_invisible, x_make_frame_visible, x_iconify_frame):
	Test and set f->async_visible and f->async_iconified, not
	f->visible or f->async_iconified.

	* keyboard.c (kbd_store_ptr): Declare this to be volatile, if
	__STDC__ is #defined.
	(Fdiscard_input): Use cast to keep GCC from complaining about the
	assignment of kbd_store_ptr to kbd_fetch_ptr.

	* xdisp.c (redisplay): Use FOR_EACH_FRAME to apply
	redisplay_windows to the root window of each frame.  This makes a
	#ifdef MULTI_FRAME unneeded, but it also means we recompute
	buffer_shared from scratch even on non-MULTI_FRAME configurations.
	Don't skip elements of Vframe_list that aren't frames; go ahead
	and crash here.

	* xdisp.c (redisplay): Remove #ifdef MULTI_FRAME around the code
	which updates separate minibuffer frames specially; there's
	nothing there that won't work on a single-frame configuration.

	* dispextern.h (struct frame_glyphs): Doc fix.

1992-12-02  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* dispnew.c: Remove dyked-out copy of safe_bcopy.

	* environ.c: File removed; Changes on 1/13/1992 made it
	unnecessary.

1992-12-01  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c (wait_reading_process_input): Doc fix.

1992-11-26  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* next.h: Copy changes from 18.59:
	(NeXT): Defined.
	(BIG_ENDIAN): Define only if __BIG_ENDIAN__.
	(m68000, COMPILER_REGISTER_BUG): Defs deleted.
	(SIGN_EXTEND_CHAR, LIB_X11_LIB, NO_T_CHARS_DEFINES, UNEXEC): Defined.
	(LIBS_DEBUG, LIB_GCC, C_SWITCH_MACHINE, ORDINARY_LINK): Defined.
	(TEXT_START, TEXT_END, DATA_END, LD_SWITCH_MACHINE): Defined.
	(KERNEL_FILE): #undef it.
	(environ): Define as _environ.

1992-11-25  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* doc.c (store_function_docstring): New function, made from part
	of Fsnarf_documentation, which handles docstrings for macros
	properly.
	(Fsnarf_documentation): Call store_function_docstring.

	* data.c (indirect_function): Delete unused argument ERROR.

1992-11-23  Jim Blandy  (jimb@apple-gunkies.gnu.ai.mit.edu)

	* Makefile.in (clean): Remove prefix-args.

1992-11-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/sol2.h (LD_SWITCH_SYSTEM): Make alternate version for GCC.

1992-11-19  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* m/sparc.h: Don't include <sys/param.h> here; that screws up the
	xmakefile.  Instead, include it in getloadavg.c, which is the only
	place that uses LOAD_AVE_CVT, which is the only reason
	<sys/param.h> was here in the first place.

1992-11-15  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* dispnew.c [not MULTI_FRAME] (Fredraw_display): Pass the correct
	number of arguments to mark_window_display_accurate.

	* undo.c (Fprimitive_undo): Remove whitespace in front of #ifdef
	and #endif.

	* systty.h: Doc fix.
	
	* systty.h, process.c, buffer.h, callproc.c, sysdep.c, dired.c:
	Added VMS changes from Roland Roberts.
	* vmspaths.h: New version from Roland Roberts.

	* xdisp.c (display_string): Use w's buffer's value of
	tab-width to display the string, instead of the current buffer's,
	which could be anything.

	* s/sol2.h (LD_SWITCH_SYSTEM): Add -R option.

	* process.c (read_process_output): Save, widen, insert the process
	output, and then restore the restriction if inserting text outside
	the visible region.

1992-11-14  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* buffer.c (Ferase_buffer): Doc fix.

	* dispnew.c (safe_bcopy): Use the right terminating condition in
	the loop which uses multiple bcopy calls to transfer a block to an
	overlapping higher block.

1992-11-13  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c (Fstart_process): Establish an unwind-protect to
	remove PROC from the process list if an error occurs while
	starting it.
	(start_process_unwind): New function to help with that.
	(create_process): There's no need to explicitly call
	remove_process if the fork fails; the record_unwind_protect in
	Fstart_process will take care of it.

	* commands.h (unread_command_event): Doc fix.

	Don't ever throw away switch-frame events.
	* lread.c: #include "keyboard.h".
	(Fread_char, Fread_char_exclusive): Don't signal an
	error for or throw away switch-frame events; instead, put them off
	until after we've found a character we can respond to.
	* commands.h (unread_switch_frame): Declare this extern.
	* keyboard.c (unread_switch_frame): Don't declare this static.
	* ymakefile (lread.o): Note that this depends on keyboard.h.

	* keyboard.c (Vlast_event_frame): Doc fix.

	* process.c (wait_reading_process_input): Test the C preprocessor
	symbol "ultrix", not "__ultrix__" to see if we should ignore
	ENOMEM errors from select.

	* fileio.c (Fexpand_file_name): Don't fiddle with "/." if it's the
	entire string.

	* buffer.c (Fbury_buffer): Make this behave as in 18.59, although
	that behavior is very odd - only remove the buffer from the
	selected window if BUFFER was nil or omitted.

	* keyboard.c (read_char): Write composite events to the dribble
	file properly.

	* keyboard.c (init_keyboard): Initialize Vlast_event_frame to
	Qnil, rather than the selected frame.

	* mem-limits.h [DATA_SEG_BITS] (EXCEEDS_LISP_PTR): Remember to
	remove DATA_SEG_BITS from the pointer before testing if the
	pointer fits in VALBITS.

	* Makefile.in (doxemacs, dotemacs): Explicitly pass along the CC
	variable in these rules, just as in the `doall' rule.

	* ralloc.c (relocate_some_blocs): Handle BLOC == NIL_BLOC.
	(free_bloc): This can now be simplified.

	* ralloc.c (r_alloc_sbrk): When we allocate new space for the
	malloc heap, zero it out even if we don't have any blocs in the
	free list.

1992-11-12  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c (process_send_signal): On systems which have both
	the TIOCGETC and TCGETA ioctls, just use the former.

	* xselect.c (Fx_get_cut_buffer): Correct check for buf_num in
	range.

	* xselect.c (Fx_get_cut_buffer, Fx_set_cut_buffer): Fix error
	message format; use NUM_CUT_BUFFERS instead of literal 7.

	* keyboard.c (lispy_modifier_list): Added sanity check before
	indexing into modifier_symbols.

	* keyboard.c (add_command_key): When copying the contents of the
	old this_command_keys to new_keys, remember to multiply size by
	sizeof (Lisp_Object) to get the amount we really need to copy.

	Rename unread_command_char to unread_command_event; it has
	subtly different semantics now, and we should use
	`make-obsolete-variable' to warn people.
	* command.h (unread_command_char): Change name in extern declaration.
	* keyboard.c (unread_command_char): Rename.
	(command_loop_1, read_char, Finput_pending, Fdiscard_input,
	quit_throw_to_read_char, init_keyboard, syms_of_keyboard): Change
	references.
	* lread.c (Fread_char): Change reference.
	* minibuf.c (temp_echo_area_glyphs): Change reference to
	unread_command_char to unread_command_event.
	* xfns.c (unread_command_char): Change name in extern declaration
	to unread_command_event.

1992-11-11  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* m/pmax.h: Don't define SYSTEM_MALLOC; this was only necessary
	for Ultrix version 4.1, and the current version is 4.3.

	* s/bsd4-2.h, s/bsd4-3.h: #define SIGNALS_VIA_CHARACTERS.
	* process.c (process_send_signal): Put all the code for sending
	signals via characters in a #ifdef SIGNALS_VIA_CHARACTERS.  Decide
	whether to use the Berkeley-style or SYSV-style ioctls by seeing
	which ioctl commands are #defined.

	* minibuf.c (read_minibuf): If get_minibuffer gives the
	new minibuffer a nil default directory, find another buffer with a
	better default directory and use that one's instead.

1992-11-10  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* process.c (process_send_signal): Doc fix.

	* keyboard.c (read_key_sequence): Don't use
	save_excursion_{save,restore} to protect the caller against buffer
	switches; use Fset_buffer and Fcurrent_buffer; redisplay might
	change point, and we don't want to undo that.

	* keyboard.c (kbd_buffer_get_event): When checking a mouse
	movement for a frame switch, don't assume Vlast_event_frame
	contains a Lisp_Frame object.

1992-11-06  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/dgux.h (SYSTEM_TYPE): Use berkeley-unix.

1992-11-04  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* alloc.c: #include "frame.h" unconditionally.  frame.h does the
	right thing when MULTI_FRAME isn't defined.

	* Makefile.in: Rearrange dependencies to make sure that xmakefile
	is built before we try to use it, even using a parallel make.

	Changes for SYSV from Eric Raymond:
	* process.c [SYSV]: Don't include <termios.h>, <termio.h>, or
	<fcntl.h>.
	(process_send_signal): Don't try to send SIGTSTP
	unless SIGTSTP is defined.
	* sysdep.c (init_baud_rate) [HAVE_TERMIO, not HAVE_TCATTR]: Use
	TCGETA, not TIOCGETP.
	* systime.h [USG] (EMACS_GET_TZ_OFFSET): Assign to *(offset), not
	(offset).  Don't forget the while corresponding to the do.
	Include USG in the list of systems that have a tzname array.

	* keyboard.c (read_key_sequence): Removed the
	replay_sequence_new_buffer label; replay_sequence should be here
	instead.

	Arrange to get compile-time errors for uses of Lisp_Frame in a
	non-MULTI_FRAME configuration.
	* lisp.h [not MULTI_FRAME]: Don't declare the Lisp_Frame tag.
	* minibuf.c (read_minibuf): Protect call to Fredirect_frame_focus
	with a #ifdef MULTI_FRAME.
	* window.c (Fset_window_configuration): Protect call to
	Fselect_frame with a #ifdef MULTI_FRAME.
	[not MULTI_FRAME] (Fcurrent_window_configuration): Don't bother
	setting the window configuration's selected_frame member.
	* keyboard.c (Vlast_event_frame): Arrange for this to exist iff
	MULTI_FRAME is defined.
	[not MULTI_FRAME] (syms_of_keyboard): Don't DEFVAR Vlast_event_frame.
	[not MULTI_FRAME] (read_char): Don't try to set Vlast_event_frame.
	[not MULTI_FRAME] (kbd_buffer_store_event): Don't try to set
	Vlast_event_frame for quit characters.
	[not MULTI_FRAME] (kbd_buffer_get_event): Don't try to generate
	switch-frame events.

	* buffer.c (init_buffer): If PWD is accurate, use it instead of
	calling getwd.
	#include <sys/types.h> and <sys/stat.h>, for the call to stat.

        Indicate whether an autoload form stands for a keymap or not.
	* eval.c (Fautoload): Renamed fifth argument TYPE.  Document the
	fact that (eq TYPE 'keymap) means FUNCTION will become a keymap
	when loaded.
	(Fmacroexpand): Instead of assuming that every autoload
	form with a fifth element is a macro, actually check the fifth
	element against t and `macro', which are the only values which
	denote macroness.
	* keymap.c (get_keymap_1): Don't try to autoload OBJECT's function
	unless the autoload form indicates that it's a keymap.

1992-11-03  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* .gdbinit (mips): New command.

1992-10-31  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c (Fmake_directory_internal): Renamed from Fmake_directory.
	Pass nil as third arg to handler.
	Lisp function `make-directory' is now in files.el.

1992-10-30  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	Clean up errors due to treating Lisp_Objects like integers.
	* abbrev.c (Funexpand_abbrev): Just assign the last abbrev's value
	to val; don't use XSET.  Make sure that the value of the
	abbrev-symbol is a string.
	* alloc.c (Frope_elt): Declare arguments to be Lisp_Objects.
	* buffer.c (reset_buffer): Don't assign to b->save_length as if it
	were an int; use XFASTINT.
	* buffer.h (Fbuffer_name, Fget_file_buffer): Added external
	declarations.
	* bytecode.c (Fbyte_code): Use EQ to compare string_saved with
	bytestr.
	* casefiddle.c (operate_on_word): Declare end to be an int, not a
	Lisp_Object.
	* casetab.c (set_case_table): Declare this to be static, and
	return a Lisp_Object. Add static declaration for this
	before Fset_case_table and Fset_standard_case_table.
	(Fset_case_table, Fset_standard_case_table): Return the return
	value of set_case_table, instead of returning garbage.
	* commands.h (unread_command_char): Declare this to be a
	Lisp_Object, not an int.
	* data.c (Fset): See if current_alist_element points to itself
	using EQ, not ==.
	(float_arith_driver): Declare this extern above arith_driver.
	* dired.c (find_file_handler): Declare this extern.
	(Ffile_attributes): Use NILP, not == Qnil.
	* dispextern.h (sit_for): Declare this extern.
	* doc.c: #include keyboard.h.
	* floatfns.c (Flog): Don't forget to declare the BASE argument a
	Lisp_Object.
	* fns.c: #include keyboard.h.
	(Fdelete): Check if Fequal returns Qnil, not zero.
	* frame.c: #include buffer.h.
	* keyboard.c: #include dispextern.h.
	(recursive_edit_unwind, command_loop, Fthis_command_keys): Declare
	these to return Lisp_Objects at the very top of the file, to avoid
	having them implicitly declared as ints.
	(echo_char): Use EQ to compare C to help_char.
	(read_char): Remember to apply XFASTINT to the return value of
	Flength before using it.  Apply XINT to c when clearing its high
	bits and meta bits, and when writing it to the dribble file.
	(read_char_menu_prompt): Use EQ to compare obj with
	menu_prompt_more_char and its control-character analog.
	(read_key_sequence): Declare PROMPT to be char *, not a
	Lisp_Object.  Use the appropriate accessors on keybuf when looking
	for ASCII function key sequences.
	* keyboard.h (get_keymap_1, Fkeymapp, reorder_modifiers,
	Fmouse_click_p, read_char): Add external declarations for these.
	* keymap.c (Fdefine_key, Flookup_key, describe_map): Don't assume
	that Flength returns an integer.
	* lisp.h (Fdefault_boundp, make_float, Ffloat, Fnth, Fcopy_alist,
	Fmake_byte_code, Fverify_visited_file_modtime, Ffile_exists_p,
	Fdirectory_file_name, Ffile_name_directory,
	expand_and_dir_to_file, Ffile_accessible_directory_p, Fbyte_code,
	Fundo_boundary, truncate_undo_list): Add extern declarations for
	these.
	* lread.c (read_char): Add an extern declaration for this,
	indicating that it returns a Lisp_Object.
	* minibuf.c (read_minibuf): Use EQ to compare, not ==.
	(temp_echo_area_glyphs): Use XFASTINT to assign to
	unread_command_char.
	* print.c (print): Cast the frame's address to an integer before
	passing it to sprintf to form the frame's printed form.
	* process.c: (status_convert): Declare this to return a
	Lisp_Object at the top of the file.
	(decode_status): Don't untag XCONS (tem)->cdr before storing it in
	tem; tem is a Lisp_Object, too.
	(process_send_signal): Declare this to be static void.  Don't
	return Qnil; nobody cares.
	(sigchld_handler): Use XFASTINT to manipulate p->infd.
	* search.c (Fstore_match_data): Don't assume Flength returns a
	C integer.
	* undo.c (record_insert): Use accessors on BEG and LENGTH.
	(truncate_undo_list): Use NILP, not == Qnil.
	* window.c (Fwindow_width, Fset_window_hscroll): Use accessors on
	w->width, w->left, w->hscroll, and arguments.
	(replace_window): Use EQ, not ==.
	(Fdelete_window): p->top and p->left are not C integers.
	(Fnext_window, Fprevious_window): Use EQ, not ==.
	* window.h (make_window, window_from_coordinates,
	Fwindow_dedicated_p): Add extern declarations for these.
	* xdisp.c (redisplay): Use ! EQ to compare the old and new arrow
	positions, not !=.
	(mark_window_display_accurate): Barf if WINDOW isn't a window.
	(display_string): Test buffer_defaults.ctl_arrow using NILP,
	instead of comparing it with zero.
	* xfns.c (x_decode_color, Fx_color_display_p): x_screen_planes is
	an int, not a Lisp_Object.
	(x_set_mouse_color): Give separate error messages for the
	different cursors we try to set.
	(Fx_geometry): Declare STRING to be a Lisp_Object.
	(Fx_create_frame): No need to use XSET to assign NAME to f->name;
	they're both Lisp_Objects.
	(adjust_scrollbars): Use XINT to access w->hscroll.
	(Fx_open_connection): x_screen_count, x_release, x_screen_height,
	x_screen_height_mm, x_screen_width, x_screen_width_mm,
	x_save_under, and x_screen_planes are integers, not Lisp_Objects.
	(syms_of_xfns): x_mouse_x, x_mouse_y, and mouse_buffer_offset are
	integers, not Lisp_Objects.
	* xselect.c (own_selection): selection_type is an X Atom value,
	not a Lisp_Object.
	(x_selection_arrival): Declare this static, and add a forward
	declaration at the top of the page.
	* xterm.c (x_convert_modifiers): Declare this to return an
	unsigned int, not a Lisp_Object.  Remember that the quiescent
	value for part is Qnil, not zero, that x_mouse_x and x_mouse_y
	are ints, not Lisp_Objects, and that RESULT->x and RESULT->y are
	Lisp_Objects, not ints.
	(XTread_socket): Declare this to return int, not Lisp_Object.
	When calling construct_mouse_click on a non-scrollbar click, pass
	PART as Qnil, not zero.
	(x_calc_absolute_position): Remember that x_screen_width and
	x_screen_height are ints, not Lisp_Objects.
	* xterm.h (x_screen_count, x_release, x_screen_height,
	x_screen_height_mm, x_screen_width, x_screen_width_mm,
	x_save_under, x_screen_planes): Declare this as ints, to match
	their definitions in xterm.c.
	* ymakefile: Note the new dependencies caused by the new
	#inclusions above.

	* xdisp.c (last_arrow_position, last_arrow_string): Make these
	static.

	* process.c (pty_process): Variable deleted; it's no longer used.
	(syms_of_process): Don't initialize it.

	* buffer.h (struct buffer_local_types): This declaration needed an
	extern qualifier.

	* floatfns.c (Fexpt): Don't return the value of the XSET function
	call; that's not guaranteed to be the value assigned.

	* dired.c (Ffile_attributes): Doc fix.

	* lisp.h (DEFVARLISP, DEFVARBOOL, DEFVARINT, DEFVARPERBUFFER):
	Removed these definitions; we should be using the versions whose
	names use underscores.

	* keyboard.c (echobuf): Make this 300 characters, not 100.  This
	isn't a real fix, but it's quick.

1992-10-30  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* callint.c (preserved_fns): New var.
	(Fcall_interactively): Preserve all fns listed in preserved_fns.
	(syms_of_callint): Set preserved_fns and staticpro it.
	Don't set up Qregion_beginning or Qregion_end.

1992-10-29  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* dispnew.c (count_blanks): Leave argument r constant, and increment p.

1992-10-28  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xdisp.c (message): Re-write this in terms of message1.
	(message1): Move code to clear out echo_area_glyphs and
	previous_echo_glyphs from message to here.

	* keyboard.c (read_char): When returning an unread switch-frame
	event, jump to reread_first to return it, rather than reread; this
	makes sure the event gets echoed (if appropriate) and goes into
	this_command_keys.

	* keyboard.c (read_key_sequence): If the key sequence starts with
	a mouse click, read the key sequence using the keymaps of the
	buffer clicked on, not the current buffer.

	* keyboard.c (unread_switch_frame): Make this static, to indicate
	that nobody outside of this file uses it.

	* keymap.c: Deal with autoloaded keymaps properly.
        (get_keymap_1): Renamed to inner_get_keymap; made
	static.  New argument AUTOLOAD says to pursue autoloads if
	non-zero.
	(Fkeymapp, get_keymap, get_keyelt, Flookup_key): Ask get_keymap_1
	not to perform autoloads.
	(Fdefine_key): Ask get_keymap_1 to perform autoloads.  Since
	autoloading may GC, remember that we have to GCPRO our local
	variables now.
	(Fminor_mode_key_binding): Call get_keymap instead of calling
	get_keymap_1 with equivalent arguments.
	* keyboard.c (follow_key): Ask get_keymap_1 to perform autoloads.
	(read_key_sequence): When pursuing potential bindings in the
	function key map, ask get_keymap_1 to perform autoloading.  This
	is hardly important, but it's consistent.
	* doc.c (Fsubstitute_command_keys): Ask get_keymap_1 to
	perform autoloads.  Autoloading might GC; we need to GCPRO our
	local variables now.
	(Fdocumentation, Fdocumentation_property): Autoloading in
	Fsubstitute_command_keys might GC; we need to GCPRO our
	local variables now.

1992-10-28  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/irix3-3.h (HAVE_SETSID, IRIX): Defined.

	* s/irix4-0.h: New file.

1992-10-27  Noah Friedman  (friedman@nutrimat.gnu.ai.mit.edu)

        * sysdep.c (get_system_name): Use gethostname for USG systems if
        HAVE_GETHOSTNAME is defined.
        * s/hpux7.h, s/irix3-3.h (HAVE_GETHOSTNAME): Define it.

1992-10-27  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* callproc.c: Arrange for synchronous processes to get SIGINT the
	first time the user quits, or SIGKILL if the user quits again.
	#include "syssignal.h".
	(call_process_kill): New function.
	(call_process_cleanup): Send SIGINT to the subprocess, and then
	arrange to call call_process_kill if the user quits while we wait
	for it to terminate.
	(Fcall_process, Fcall_process_region): Doc fix.

1992-10-27  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* unexmips.c [sony, IRIS_4D]: Include getpagesize.h and fcntl.h.
	(unexec): #if 0 the error check of hdr.fhdr.f_nscns.
	Clear text_section->s_scnptr.

	* callint.c (Fcall_interactively): Preserve (region-beginning)
	and (region-end) into the command history when they appear
	in an interactive spec which is a call to `list'.

	* batcomp.com: New file.  Waiting for papers from richard@ttt.kth.se.

1992-10-23  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* emacs.c (main): Correct spelling of HAVE_X_WINDOW to
	HAVE_X_WINDOWS in conditionals around the call to syms_of_xmenu.

1992-10-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ralloc.c (relinquish):
	Adjust page_break_value by amount of memory actually given back.
	(r_alloc_sbrk): Provide hysteresis in relocating the blocs.

1992-10-22  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ralloc.c (relinquish): Sign of arg to *real_morecore was backwards.

1992-10-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ralloc.c (relinquish): Never free less than extra_bytes;
	keep extra_bytes of empty space.
	(obtain): Always get extra_bytes additional space.
	(r_alloc_init): Set extra_bytes and page_size.
	(ALIGNED, ROUNDUP, ROUND_TO_PAGE): Use page_size.

1992-10-20  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (syms_of_keyboard): Properly staticpro this_command_keys.

	* mem-limits.h (get_lim_data): Make it static.

	* ymakefile (mallocobj): Use vm-limit.o along with ralloc.o.

	* ralloc.c [emacs]: Define POINTER and SIZE.
	[!emacs]: Delete definition of EXCEEDS_LISP_PTR.

	* eval.c (grow_specpdl): Increase max_specpdl_size before Fsignal.

1992-10-19  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xfns.c (x_set_face): Dyked out this function; it has no callers,
	and refers to an obsolete version of struct face.

	* xterm.c (compose_status): New variable.
	(XTread_socket): Pass it by reference to XLookupString.

1992-10-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/esix5r4.h (BROKEN_FIONREAD): Defined.

1992-10-16  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/vms5-5.h: New file.

1992-10-16  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* xdisp.c (message): If M is zero, clear echo_area_glyphs and
	previous_echo_glyphs, so that the minibuffer shows through.
*       * editfns.c (Fmessage): With no arguments, clear any active
	message; let the minibuffer contents show through.
	* minibuf.c (temp_echo_area_glyphs): Don't clear echo_area_glyphs
	and previous_echo_glyphs; let message do that work.

	* keyboard.c (this_command_keys): Make this a vector, instead of
	an array of Lisp_Objects.
	(this_command_keys_size): Deleted.
	(echo, add_command_key, Fthis_command_keys): Adjusted
	appropriately.
	(init_keyboard): Don't allocate it here.
	(syms_of_keyboard): Allocate it here, and staticpro it.
	* keyboard.h (this_command_keys): Extern declaration changed.  Doc fix.
        * callint.c (Fcall_interactively): Change handling of 'e' spec;
	this_command_keys is now a vector.

	* keyboard.c (read_char): Call ourselves with the appropriate
	number of arguments.
	(read_char_menu_prompt): If USED_MOUSE_MENU is zero, don't try to
	store things in it.

	* window.c: Try to deal coherently with deleted windows:
*	(Flive_window_p): New function.
	(Qlive_window_p): New variable, to name it in type errors.
	(syms_of_window): Defsubr Slive_window_p, init and staticpro
	Qlive_window_p.
	* lisp.h (CHECK_LIVE_WINDOW): New predicate.
	(Qlive_window_p): Extern declaration for this.
	* window.c (decode_window): Use CHECK_LIVE_WINDOW instead of
	CHECK_WINDOW; the only thing a user should be able to do to a dead
	window is check its type.
	(Fcoordinates_in_window_p, Fnext_window, Fprevious_window,
	Fdelete_other_windows, Fselect_window, Fsplit_window,
	Fscroll_other_window): Use CHECK_LIVE_WINDOW instead of
	CHECK_WINDOW.
	* frame.c (make_frame_without_minibuffer, Fwindow_frame): Same.
	* sunfns.c (Fsun_menu_internal): Same.
	* xmenu.c (Fx_popup_menu): Same.
	* window.c (Fdelete_window): If WINDOW is a deleted window, do nothing;
	there's no harm in allowing people to delete deleted windows.
	Delete all of WINDOW's subwindows, too.
	(delete_all_subwindows): Set the buffer, vchild, and hchild of the
	windows we delete all to nil.
	* window.h (struct window): Doc fix.

	* window.c (Fwindow_minibuffer_p): Make the WINDOW argument
	optional, like all the other window-querying functions.

	* window.c (Fpos_visible_in_window_p): Use decode_window to handle
	the WINDOW argument, instead of writing out that function's code.

	* window.c (check_frame_size): Don't define this extern; that
	doesn't mean anything.

	* xterm.c: Clean up some of the caps lock handling:
	(x_shift_lock_mask): New variable.
	(x_find_modifier_mappings): Set it, based on the modifier mappings.
	(x_convert_modifiers): Use x_shift_lock_mask, instead of assuming
	that the lock bit always means to shift the character.
	(XTread_socket): When handling KeyPress events, don't pass an
	XComposeStatus structure along to XLookupString.  When handling
	MappingNotify events, call XRefreshKeyboardMapping for both
	MappingModifier and MappingKeyboard events, not just the latter.

1992-10-15  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* window.c (Fdelete_window): Choose an alternative when we delete
	any frame's selected window, not just when we delete the selected
	frame's selected window.

1992-10-15  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* vm-limit.c (check_memory_limits): Declare __morecore.
	Remove unused variable `result'.

1992-10-15  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* vm-limit.c (morecore_with_warning): Removed.
	(check_memory_limits): New fn; most code from
	morecore_with_warning, but only checks limits, doesn't do any work.
	(memory_warnings): Set __after_morecore_hook to check_memory_limits;
	don't set __morecore.

1992-10-14  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* intervals.c (traverse_intervals): New parameter `depth'.
	Increment this when passing recursively.

	* alloc.c (mark_interval_tree): Pass 0 as initial depth argument
	to traverse_intervals.

	* xterm.h: Declaration of struct face removed.

	* dispextern.h: New element of frame structure `max_ascent'.
	Removed elements `nruns' and `face_list'.
	LINE_HEIGHT and LINE_WIDTH macros removed.
	New struct face with associated typedef FACE declared, along with
	accessing macros.

	* scroll.c (do_scrolling): Don't bcopy non-existant `nruns' or
	`face_list' elements.  Do copy new `max_ascent' frame element.

	* dispnew.c (scroll_frame_lines): All references to frame elements
	`nruns' and 'face_list' removed.  Handle new element `max_ascent'.
	(free_frame_glyphs): Don't free nonexistent elements `nruns' and
	`face_list';  do free `max_ascent' element.
	(make_frame_glyphs): Don't allocate nonexistent elements `nruns'
	and `face_list';  do allocate `max_ascent' element.
	(update_frame): Replaced use of macro LINE_HEIGHT with element
	frame element `pix_height'.

1992-10-14  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (modify_event_symbol): Arrange to set the
	click_modifier bit on otherwise unmodified mouse clicks.

	* keymap.c (store_in_keymap): Don't forget to QUIT in the
	keymap-scanning loop.  Don't treat vectors as binding tables if
	they're the wrong length.

1992-10-12  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keyboard.c (kbd_buffer_get_event): Remember that
	*mouse_position_hook may set *FRAME to 0; don't generate
	switch-frame events in this case.  Fix fencepost bug in fetching
	events from keyboard buffer.

1992-10-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (ralloc.o): Delete dep mem_limits.h
	(vm-limit.o): Rename dep to mem-limits.h.

1992-10-12  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* ralloc.c: Removed #include "mem-limits.h".
	[emacs]: Moved #undef NULL and #include "getpagesize.h" here.
	[! emacs]: #include <unistd.h>, <malloc.h>, <string.h>.
	(r_alloc_init): Use NIL, not NULL.

1992-10-12  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* ralloc.c (sbrk): Removed decl.
	(real_morecore): New static variable.
	(warnlevel, warn_function, check_memory_limits): Removed.
	(obtain): Don't call check_memory_limits.
	(obtain, relinquish, r_alloc_sbrk): Use (*real_morecore) in place
	of sbrk; it returns 0 for errors, not -1.
	(r_alloc_init): Set real_morecore to old value of __morecore.
	Don't initialize lim_data or warnlevel, and don't call get_lim_data.
	(memory_warnings): Function removed.

1992-10-12  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* vm-limit.c (warnfunction): Renamed to warn_function (was used
	inconsistently).
	(morecore_with_warning, memory_warnings): Change callers (were
	inconsistent).

1992-10-12  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* mem-limits.h (start_of_data): Removed extra defn.
	(get_lim_data): Define to return void.

1992-10-12  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* mem_limits.h: File renamed to mem-limits.h.
	* vm-limit.c, ralloc.c: Changed #includes.

1992-10-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* syntax.c (find_defun_start): scan_buffer returns start of line;
	no need to advance over newline.

	* vm-limit.c (morecore_with_warning):
	Reduce warnlevel when usage drops far enough.
	* ralloc.c (check_memory_limits): Likewise.

	* vm-limit.c (memory_warnings): Renamed from malloc_init.
	Don't set lim_data or warnlevel.  Use start_of_data if start is 0.
	* ralloc.c (memory_warnings): New function; just set warning data.
	Use start_of_data if start is 0.
	* emacs.c (Fdump_emacs, main): Use memory_warnings.

	* mem_limits.h [!emacs]: Don't define POINTER, SIZE or NULL.
	(start_of_data): Define as macro, if !emacs.
	* ralloc.c [!emacs]: Don't include config.h or lisp.h;
	instead, use stddef.h.  Define POINTER, SIZE, EXCEEDS_LISP_PTR.
	* vm-limit.c [!emacs]: Don't include config.h or lisp.h;
	instead, use stddef.h.  Define POINTER, SIZE, EXCEEDS_LISP_PTR.

	* ralloc.c [!emacs] (safe_bcopy): Define as macro using memmove.
	(r_alloc_free): Clear *ptr.
	(r_alloc_init): Renamed from malloc_init.  Take no args.
	Make it static; declare at top of file.
	(r_alloc): Call r_alloc_init, if not initialized yet.
	(r_alloc_initialized): Renamed from malloc_initialized; moved to top.
	(ROUNDUP): Subtract 1, in case arg is already aligned.

	* mem_limits.h (EXCEEDS_LISP_PTR): Renamed from EXCEEDS_ELISP_PTR.
	* vm-limit.c (morecore_with_warning): Use EXCEEDS_LISP_PTR.
	* ralloc.c (check_memory_limits): Use EXCEEDS_LISP_PTR.

1992-10-10  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* keyboard.c (Vlast_event_frame): Make this variable exist even
	when MULTI_FRAME isn't #defined.  People might find it
	necessary for writing correct programs, even when the programs
	don't explicitly use multiple frames.
	(read_char, kbd_buffer_store_event, kbd_buffer_get_event): No need
	to test MULTI_FRAME before setting Vlast_event_frame.
	(syms_of_keyboard): DEFVAR Vlast_event_frame whether or not
	MULTI_FRAME is defined.

        * keyboard.c: Add switch-frame events.
	(Qswitch_frame): New event header symbol.
	(head_table): Include Qswitch_frame in the table of event heads.
	(kbd_buffer_get_event): Detect when a frame switch has occurred,
	and return a frame switch event before the enqueued event.
	(make_lispy_switch_frame): New function.
	(unread_switch_frame): New variable.
	(read_key_sequence): Don't throw away the key sequence if the user
	switches frames in the middle of the sequence.  Instead, when we
	receive a switch-frame event in the middle of a key sequence, save
	it, and stuff it into unread_switch_frame when the sequence
	is complete.
	(read_char): If unread_switch_frame is set, return that value.
	(command_loop_1): No need to check Vlast_event_frame and select
	new frames here; that's taken care of by switch-frame events now.
	(syms_of_keyboard): Initialize and staticpro unread_switch_frame.
	* keyboard.h (Qswitch_frame): Declare this extern.

	* frame.c: #include "commands.h" and "keyboard.h".
	(Fselect_frame): Make this interactive, and accept
	switch-frame events as arguments, so we can bind this function to
	switch-frame events.
	(keys_of_frame): New function; bind switch-frame to Fselect_frame.
	* emacs.c (main): Call keys_of_frame.
	* keymap.c (initial_define_lispy_key): New function, for defining
	non-ascii keys.
	* ymakefile: Note that frame.o depends on commands.h and keyboard.h.

	* callint.c (Fcall_interactively): Allow multiple 'e' specs.
	(Finteractive): Doc fix.
	* keyboard.h (this_command_keys, this_command_key_count): Added
	external declarations.

	* keymap.c (access_keymap): Treat bindings for Qt as default
	bindings, when new argument T_OK is non-zero.
	(get_keyelt, Fdefine_key, Flookup_key): Call access_keymap with
	T_OK false.
	* keyboard.c (follow_key, read_key_sequence): Call access_keymap
	with T_OK true.

	* keyboard.c (apply_modifiers): Copy the value of BASE's
	Qevent_kind property to the new symbol.

	* keyboard.c (syms_of_keyboard): Qevent_kind should be initialized
	to intern ("event-kind"), not intern ("event-type").

1992-10-10  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c (Fwrite_region): If VISIT is a file name,
	use that as file name to visit, and print it in the message.
	Use it for file locking too.

	* m-ibmps2-aix.h [__GNUC__ >= 2] (LIB_STANDARD): Don't define.

1992-10-09  Jim Blandy  (jimb@totoro.cs.oberlin.edu)

	* ymakefile (FLOATSUP): Renamed to FLOAT_SUPPORT.
	(FRAME_SUPPORT, VMS_SUPPORT): New macros.
	(lisp): Rebuild this from loadup.el, using the _SUPPORT macros.

	* ymakefile [HAVE_X_WINDOWS, not NO_X_MENU, HAVE_X11] (LIBXMENU):
	Link against -loldX, to get the association table functions.

	* xterm.c, xrdb.c: #include <stdio.h> before "xterm.h", to avoid
	warnings about redefining NULL under GCC 2.2.2.

1992-10-09  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* m/pyrmips.h: New file.

	* s/aix3-1.h (PTY_ITERATION, etc.): Defined.
	(FIRST_PTY_LETTER): Deleted.

1992-10-07  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* m/sparc.h: Include <sys/param.h>, to define the FSCALE constant.

	* ymakefile (YMF_PASS_LDFLAGS): Refer to the prefix-args program
	using "./prefix-args", not just "prefix-args"; some people don't
	have . in their paths.

1992-10-06  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* link.com: Use gcclib if compiling with GCC.

	* fileio.c (directory_file_name): Don't clobber the envvar
	when handling top-level rooted dir.

	* ymakefile (LIB_STANDARD): If ORDINARY_LINK, default this to empty.

	* m/ibmps2-aix.h [USG_SHARED_LIBRARIES]: Define ORDINARY_LINK.
	Undef LIB_STANDARD.  Modify LD_SWITCH_MACHINE.

	* unexnext.c: New file.
	* emacs.c (main) [NeXT]: Call malloc_jumpstart.

1992-10-05  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* window.c (window_loop): Pass 2nd arg to Fother_buffer.
	* frame.c (make_frame): Likewise.
	* callint.c (Fcall_interactively): Likewise.
	* buffer.c (Fkill_buffer): Likewise.
	(Fswitch_to_buffer, Fpop_to_buffer, Fbury_buffer): Likewise.

1992-10-03  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): Treat mouse clicks on non-text
	areas as if they were prefixed with the symbol denoting the
	area clicked on - `mode-line', etcetera.
	When we throw away an unbound `down-' event, reset mock_input as
	well.

	* keyboard.c (Qevent_symbol_element_mask, Qmodifier_cache): Two
	new symbols, used to implement caches on event heads.  These take
	the place of some of the caching that modify_event_symbol used to do.
	(parse_modifiers_uncached, apply_modifiers_uncached,
	lispy_modifier_list, parse_modifiers, apply_modifiers): New
	functions, which replace format_modifiers and reorder_modifiers;
	they can be useful elsewhere too.
	(reorder_modifiers, modify_event_symbol): Re-implement these in
	terms of parse_modifiers and apply_modifiers.  modify_event_symbol
	now uses a much simpler cache, and takes advantage of the caches
	maintained by parse_ and apply_modifiers.
	(follow_key): Don't modify NEXT if KEY has no bindings.
	(read_key_sequence): Drop unbound `down-' events, and turn unbound
	`drag-' events into clicks if that would make them bound.  This
	benefits from the rewriting of the modifier key handling code.
	(syms_of_keyboard): Initialize and intern
	Qevent_symbol_element_mask and Qmodifier_cache.

	* keyboard.c (echo_prompt): Terminate the echo buffer properly
	even when the string is too long to display in the minibuffer.
	(echo_truncate): Just return echoptr - echobuf, rather than
	calling strlen on echobuf.

	* alloc.c (Fmemory_limit): New function.
	(syms_of_alloc): Defsubr it.

	* window.c (SAVE_WINDOW_DATA_SIZE): Define this using sizeof,
	instead of just saying it's 7; that way, we won't get screwed if 
	we add members to struct save_window_data.

	* window.c (struct save_window_data): Save the currently selected
	frame, too.
	(Fset_window_configuration): Restore the frame's selected window
	using Fselect_window, and then restore the selected frame using
	Fselect_frame.
	(Fcurrent_window_configuration): Record the currently selected
	frame.  Update docstring to describe the information now recorded.

1992-10-02  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* process.c (wait_reading_process_input): Ultrix select seems to
	return ENOMEM when interrupted.  So, under Ultrix, treat ENOMEM
	like EINTR.

	* keyboard.c (modifier_names): The modifier is named "control",
	not "ctrl".

	* keyboard.c (modify_event_symbol): Make sure that the unmodified
	event header gets the proper properties set on it, by recursing
	and letting the same code build the properties for all event symbols.

	* keyboard.c (Qmouse_click): Fix typo which assigned `mouse-click'
	symbol to Qmouse_movement.

1992-10-02  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* undo.c (Fprimitive_undo):
	When undoing an insert, move point and then delete.

1992-10-02  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* intervals.c: `copy_intervals' no longer static.

	* intervals.h: Declare `copy_intervals'.

	* buffer.c: #include intervals.h.

	* ymakefile: New macro "INTERVALS", controlled by "USE_INTERVALS",
	which defines the interval include file "intervals.h".
	New entries for "intervals.c" and "textprop.c".

	* lisp.h: Declare Qbuffer_or_string_p.

1992-10-02  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xterm.c (x_find_modifier_meanings): If there are no
	modifiers containing a Meta_ keysym, use the Alt keysyms to
	denote meta.
	(construct_mouse_click): Set the down_modifier bit on mouse
	button press events.
	(XTread_socket): When processing keypress events, use
	x_meta_mod_mask when processing ordinary ASCII characters, not
	just when processing function keys and other non-ASCII events.
	(XTread_socket): If we receive a MappingNotify event with the
	`request' member set to `MappingModifier', then call
	x_find_modifier_meanings to refresh x_meta_mod_mask.

	* window.c (Fset_window_configuration): Clean up the way we save
	and restore the frame's size.

	* termhooks.h (struct input_event): Doc fix.
	(NUM_MOUSE_BUTTONS): New constant.
	(click_modifier): New modifier.
	(NUM_MODIFIER_COMBOS): Removed.

	* keyboard.h (EVENT_HAS_PARAMETERS): Definition changed - all events
	are not 5 elements long.
	(EVENT_HEAD): Work correctly on all sorts of events, not just
	events with parameters.
	(EVENT_WINDOW, EVENT_BUFFER_POSN, EVENT_SCROLLBAR_BUTTON,
	EVENT_WINDOW_POSN, EVENT_TIMESTAMP): These aren't useful
	anymore; this information may appear twice in an event.  These
	are replaced by the POSN_ accessors, which are meant to be
	composed with the EVENT_START and EVENT_END accessors.
	(EVENT_START, EVENT_END): Two new accessors, to get at the
	starting and ending position of an event.
	(POSN_WINDOW, POSN_BUFFER_POSN, PONS_SCROLLBAR_BUTTON,
	POSN_WINDOW_POSN, POSN_TIMESTAMP): New macros, to futher
	diasassemble the values returned by EVENT_START and EVENT_END.
	* keyboard.c (echo_char, read_char): Apply EVENT_HEAD without first 
	testing for EVENT_HAS_PARAMETERS; EVENT_HEAD works properly on
	all sorts of events now.
	(read_key_sequence): Use the new accessors to decide in which window
	an event occurred.
	* keymap.c (access_keymap, store_in_keymap,
	Fsingle_key_description): No need to check for
	EVENT_HAS_PARAMETERS before using EVENT_HEAD; the latter now
	works properly on all sorts of events.

	* keyboard.c (Qevent_unmodified): Replaced by...
	(Qevent_symbol_elements): New property.
	(syms_of_keyboard): initialize and staticpro the latter, not the
	former.
	* keyboard.h (Qevent_unmodified): Extern declaration replaced by...
	(Qevent_symbol_elements): This.
	(EVENT_HEAD_UNMODIFIED): Use the Qevent_symbol_elements
	property, rather than the Qevent_unmodified property.

	* keyboard.c (readable_events): This doesn't need to scan and
	discard mouse release events anymore; it just uses
	EVENT_QUEUES_EMPTY.
	(kbd_buffer_get_event): No need to skip past mouse release events.

	* keyboard.c (button_down_location): New variable, which
	stores the location at which each button was pressed, so we
	can build a complete drag event when the button is released.
	(make_lispy_event): When a button is pressed, record its
	location in button_down_location, and turn it into a `down'
	event.  When a button is released, compare its release
	location with its press location, and decide whether to call
	it a `click' or `drag' event.
	Change mouse movement events to be arranged like click events.
	(format_modifiers): Note that the click modifier has no
	written representation.
	(modifier_names, modifer_symbols): New variables, used to
	create the Qevent_symbol_elements property.
	(modify_event_symbol): Change the format of the modified
	symbol cache; there are too many modifier bits now to use a
	vector indexed by a modifier mask.  Use an assoc-list instead.
	Document the format of the cache.
	Put the Qevent_symbol_elements property on each new symbol,
	instead of a Qevent_unmodified property.
	(symbols_of_keyboard): Put Qevent_symbol_elements properties on
	the symbols specified in head_table, not Qevent_unmodifed properties.
	Initialize and staticpro modifier_symbols, and staticpro the
	window elements of button_down_location.

	* xmenu.c: #include "keyboard.h".
	(Fx_popup_menu): Use the event accessors defined in keyboard.h,
	instead of writing out cars and cdrs.
	* ymakefile: Note that xmenu.o depends on keyboard.h.

1992-10-02  Joseph Arceneaux  (jla@wookumz.gnu.ai.mit.edu)

	* textprop.c: Conditionalize all functions on
	"USE_TEXT_PROPERTIES".
	* intervals.c: Conditionalize all functions on
	"USE_TEXT_PROPERTIES".
	Removed #include of "screen.h".

	* alloc.c: #include "intervals.h".
	(init_intervals, make_interval,
	mark_interval, mark_interval_tree): New functions conditionally
	defined.
	(make_uninit_string): Call INITIALIZE_INTERVAL.
	(INIT_INTERVALS, UNMARK_BALANCE_INTERVALS, MARK_INTERVAL_TREE):
	New macros, conditionally defined.
	(mark_object): Call MARK_INTERVAL_TREE in case Lisp_String.
	(gc_sweep): If text properties are in use, place all unmarked
	intervals on the free list.  Call UNMARK_BALANCE_INTERVALS on
	`buffer->intervals' when unmarking `buffer'.
	(compact_strings): Include INTERVAL_PTR_SIZE in calculation for
	target of bcopy when relocating strings.
	(init_alloc_once): Call INIT_INTERVALS.
	(make_pure_string): Include INTERVAL_PTR_SIZE in calculation of
	`size'.
	Moved static declaration of `mark_object' and other functions up
	in the file.

	* fileio.c (Finsert_file_contents): Call offset_intervals if
	text was actually inserted.
	#include "intervals.h".

1992-09-30  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* data.c: Qbuffer_or_string_p added.

	* syntax.c (describe_syntax): Use insert_char to insert `match'.

	* buffer.c (reset_buffer): Do INITIALIZE_INTERVAL on the buffer's
	interval component.
	(Fkill_buffer): Likewise.

	* editfns.c (make_buffer_string): Call copy_intervals_to_string.
	(Finsert_buffer_substring): Call graft_intervals_into_buffer.
	#include "intervals.h".

	* insdel.c: #include "intervals.h"
	(prepare_to_modify_buffer): Call verify_interval_modification.
	(insert_from_string): Call offset_intervals and
	graft_intervals_into_buffer.
	(del_range): Call offset_intervals.
	(insert): Call offset_intervals.

	* emacs.c: #include "intervals.h".
	(main): Call syms_of_textprop.  This is only really present if
	Emacs is compiled with USE_TEXT_PROPERTIES defined.

	* buffer.h: New macro TEMP_SET_PT.  If intervals are used, SET_PT
	and TEMP_SET_PT are function calls.
	Similarly for BUF_SET_PT and BUF_TEMP_SET_PT.
	Added DECLARE_INTERVALS to buffer structure to conditionally
	compile an interval tree into it.

	* intervals.h: Declare temp_set_point.

1992-09-30  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* ymakefile (config.h): Doc fix.

1992-09-30  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* config.h.in: Added a slot for definition of USE_TEXT_PROPERTIES,
	controlling compilation of interval code.
	If using GNUC, support inline functions.

	* lisp.h: Conditionally define interval structure and macros.
	Add DECLARE_INTERVALS to struct Lisp_String.

1992-09-30  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* buffer.c (Fother_buffer): Add back the VISIBLE_OK argument.  It
	got removed with no comment or ChangeLog entry, and
	append-to-buffer uses it.

        * window.c (struct save_window_data): Add a member called
	focus_frame, to save and restore the screen's focus frame.
	(Fset_window_configuration): Redirect the frame's focus as
	indicated in the window configuration.
	(Fcurrent_window_configuration): Record the frame's current focus.
	* minibuf.c (read_minibuf): Don't bother to save the current
	frame's focus, and have read_minibuf_unwind restore it; saving and
	restoring the window configurations will take care of that.
	(read_minibuf_unwind): Don't worry about restoring the frame's focus.

	* window.c (Fset_window_configuration): Don't select the frame
	just because we restored its configuration.

	* window.c (Fset_window_configuration): Don't forget to set the
	frame's selected window when we can't call Fselect_window.

	* xterm.c (x_meta_mod_mask): New variable, indicating which X
	modifier bits denote meta keys.
	(x_find_modifier_meanings): New function, to set x_meta_mod_mask.
	(x_convert_modifiers): Use that.
	(x_term_init): Call x_find_modifier_meanings.

	* data.c (Fmake_local_variable): If SYM forwards to a C variable,
	swap in the value for the current buffer immediately.

	* lisp.h: Doc elaboration for Lisp_Buffer_Local_Value.

1992-09-29  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* textprop.c (Ferase_text_properties): Merge intervals when
	possible.

1992-09-29  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xselect.c (Qcut_buffer0): Symbol removed; we're using a new
	interface to the cut buffer now.
	(NUM_CUT_BUFFERS, cut_buffer_atom, cut_buffer_value,
	cut_buffer_cached, cut_buffer_just_set): New variables.
	(Fx_own_selection, Fx_selection_value): Dike out the code to
	handle CUT_BUFFER0 requests.
	(Fx_get_cut_buffer, Fx_set_cut_buffer, x_watch_cut_buffer_cache,
	x_invalidate_cut_buffer_cache): New functions.
	(syms_of_xselect): Don't bother to initialize Qcut_buffer0.
	Initialize and staticpro cut_buffer_value, and defsubr
	Sx_get_cut_buffer and Sx_set_cut_buffer.
	* xterm.c (XTread_socket): Pass PropertyNotify events from the
	root window to x_invalidate_cut_buffer_cache.
	(x_term_init): Call x_watch_cut_buffer_cache here.

	* keymap.c (access_keymap): Don't forget to QUIT while scanning
	the keymap.

	* keyboard.c (recent_keys): This needs to be staticpro'ed.  Change
	it from a C array, which is a pain in the neck to staticpro, into
	a lisp vector, which is easier.
	(read_char, Frecent_keys): Access recent_keys as a lisp vector,
	not a C array.
	(syms_of_keyboard): Set recent_keys to be a vector, and staticpro it.

	* ymakefile (xfns.o): This doesn't depend on xselect.c.

	* xterm.h (ROOT_WINDOW): Use the DefaultScreen macro, not the
	XDefaultScreen function.

	* frame.c (Fdelete_frame): Call Fselect_frame with the appropriate
	number of arguments.

	* data.c (Frem): Use the `fmod' function under SunOS, Ultrix, and
	HP/UX, not just under USG systems.

	* buffer.c (Fbury_buffer): This used to undisplay the buffer being
	buried only if the BUFFER argument was nil.  Instead, undisplay the
	buffer whenever it's displayed in the selected window, no matter
	how it was specified by BUFFER.  This is how it behaves in 18.58,
	and I can't find any ChangeLog entry in 18.58 or 19.0 saying why
	they differ.  Fix the doc string accordingly.

1992-09-28  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* frame.c (Fselect_frame, Fframe_root_window,
	Fframe_selected_window, Fnext_frame, Fmake_frame_visible,
	Fmake_frame_invisible, Ficonify_frame): Doc fixes.

	* ralloc.c: Since the users of the relocating allocation code
	handle memory exhaustion, it's better to return an error code to
	them than to call abort. 
	(obtain): If we cannot allocate more memory, don't call
	abort.  Instead, return non-zero iff the allocation is successful.
	(get_more_space): If obtain fails, return zero.
	(get_bloc): Return zero if we can't allocate the new bloc.
	(r_alloc_sbrk): Return zero if we can't allocate more memory.
	(r_alloc): If we can't allocate more memory, set *PTR to zero and
	return zero.
	(r_re_alloc): If we can't allocate more memory, leave *PTR
	unchanged, and return zero.

	* ralloc.c (warnfunction): Renamed to warn_function; users changed.

1992-09-28  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* insdel.c (del_range): Call record_delete before updating point.

	* fileio.c (Finsert_file_contents): Do record_insert, then inc MODIFF.

	* undo.c (record_delete): Record pos before the deletion.
	(Fprimitive_undo): Go back to recorded position.

1992-09-28  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* window.c (delete_all_subwindows): Save the window's buffer in
	its `height' field; we may need to know the window's old buffer
	once we have restored it from a window configuration.
	(Fset_window_configuration): When we restore a window, if its
	`height' field is a buffer, restore its `buffer' field from that.
	This allows us to leave the window's buffer unchanged if the
	buffer recorded in the configuration is dead.

	* window.c (delete_all_subwindows): Removed unused variable named
	"count".

1992-09-27  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keyboard.c (read_char): If we're returning an event from a
	macro, set Vlast_event_frame to Qmacro, instead of leaving it set
	to the frame of the previous real event.
	(read_key_sequence): If Vlast_event_frame isn't a frame, don't
	bother switching buffers.
	(syms_of_keyboard): Doc fix for Vlast_event_frame.
	(Vlast_event_frame): Doc fix.

	* termhooks.h (alt_modifier, hyper_modifier, super_modifier,
	down_modifier, drag_modifier): New modifiers, to support the new
	input system.  Re-arranged modifiers so that their bits are in
	canonical order; this makes reorder_modifiers slightly simpler.
	* keyboard.c (format_modifiers, reorder_modifiers): Handle the new
	modifier bits.

	* keymap.c (access_keymap): Remove code to notice bindings for
	Qt.

1992-09-25  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xmenu.c (single_keymap_panes): Handle vectors properly.

1992-09-25  Jim Blandy  (jimb@geech.gnu.ai.mit.edu)

	* keymap.c (Fwhere_is_internal): Don't forget to advance map to
	the next element when we find something that is neither a vector
	nor a cons.  Don't forget to QUIT in the appropriate places,
	either.

1992-09-23  Joseph Arceneaux  (jla@geech.gnu.ai.mit.edu)

	* textprop.c (Fset_text_properties): Merge adjacent intervals with
	the same properties.
	(Fnext_single_property_change, Fprevious_single_property_change):
	New subrs.

	* intervals.c (merge_interval_left, merge_interval_right): Abort
	if caller tries to merge first (or last, respectively) interval.
	Delete the interval node after merging.
	(copy_intervals): Use `split_interval_right' rather than creating
	new intervals with make_new_interval and attaching them
	explicitly.
	(verify_interval_modification): Changed error message.  GCPRO
	hooks before calling Fnreverse, and correctly Fcdr down the list.
	Also, don't cons multiple copies of the same consecutive
	modification hook.
	(temp_set_point): New function.
	(set_point): Call point-left and point-entered hooks if moving
	between text with different properties.  Use the old and new
	positions as arguments to these calls.

	* intervals.c, intervals.h: (map_intervals, make_buffer_interval,
	 make_string_interval,run_hooks): Deleted.

1992-09-23  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keymap.c (DENSE_TABLE_SIZE): Doc fix.
	(keymap_table): Function removed; this function exists only to
	support an incorrect understanding of the format of keymaps.
	(access_keymap, store_in_keymap, Fcopy_keymap,
	Faccessible_keymaps): Correctly handle vectors at any point in the
	keymap; don't assume it must be at the front.
	(describe_map): Instead of calling describe_vector on the vector
	in the cadr of the keymap (if present) and then calling
	describe_alist to do the rest, just call describe_map_2.
	(describe_alist): Renamed to describe_map_2; call describe_vector
	when we encounter a vector in the list.
	* xmenu.c (single_keymap_panes): Comment out the code which
	tries to handle a dense keymap's table; it uses keymap_table, and
	the rest of the code never uses the table contents anyway.

	* keymap.c (access_keymap, store_in_keymap): Clarify error message
	for non-ASCII characters.

	* process.c [SIGCHLD && !BSD && !UNIPLUS && !HPUX]
	(create_process): #if 0 out the code which sets the child's
	handler for SIGCHLD to sigchld; the code which gives sigchld its
	value has been diked out under these CPP symbols, so this should
	be diked out too.

	* indent.c (Fmove_to_column): Pass the right number of arguments
	to Findent_to.

1992-09-22  Jim Blandy  (jimb@kropotkin.gnu.ai.mit.edu)

	* emacs.c (emacs_priority): Doc fix.
	(main): Use nice, not setpriority; we just need a
	simple, portable call to nice here.
	* callproc.c (child_setup): Use nice, not setpriority.
	* sysdep.c (sys_suspend): Don't try to use "nice (- nice (0))" to
	set the subshell's priority to normal; nice doesn't return a
	defined value on all systems.  Instead, since emacs_priority gives
	the priority that Emacs was nastied to, we can use it to reset the
	priority in a straightforward way.
	[BSD4_1], [USG], [VMS] (setpriority): Remove dummy and
	compatibility definitions of setpriority.

	* keymap.c (access_keymap): Return the binding of Qt as the
	binding for all unbound characters.

	* fileio.c (syms_of_fileio): Don't try to defsubr Sunix_sync
	unless it's actually been defined - that is, if unix is #defined.

	* xrdb.c (x_get_resource): Cast the value being assigned to
	ret_value->addr, rather than ret_value->addr itself; only GCC
	allows you to cast lvalues.

	* eval.c (unbind_catch): Do the long-jump here.  Take a VALUE
	argument, which specifies the value to return to the catch, or the
	data to give to the condition handler.  Renamed to
	unwind_to_catch, to reflect new role.
	(Fsignal, Fthrow): Removed code to set catch tag value and do the
	long-jump; this is taken care of by unwind_to_catch.

1992-09-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* alloc.c (mark_object): Avoid car recursion on cons with nil in cdr.
	Avoid recursion on constants-vector of a compiled function.

	* oldXMenu: Symlink deleted; anything that uses it needs fixing
	in any case to work properly on systems without symlinks.

1992-09-20  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s/sol2.h: New file.

	* fileio.c: Don't include sys/dir.h.

	* s/usg5-4.h (LIBS_SYSTEM): Move non-default libraries here.
	(LIB_STANDARD, START_FILES): Deleted.
	(ORDINARY_LINK): Defined.

	* ymakefile [ORDINARY_LINK]: Default LD to $(CC)
	and make START_FILES and LIB_STANDARD empty.
	(C_SWITCH_X_MACHINE, C_SWITCH_X_SYSTEM): New macros, default empty.
	(CFLAGS): Use them.

1992-09-19  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (${etc}DOC): Use OBJECTS_SYSTEM and OBJECTS_MACHINE.

	* dired.c [VMS]: Include string.h, rms.h, rmsdef.h.
	[VMS] (Ffile_version_limit): New function.

	* sysdep.c (sys_suspend): Read EMACS_PARENT_PID envvar for parent. 

	* syntax.c (scan_lists): When searching back for comment:
	if comment-end is 2 chars, assume it does end a comment.
	Otherwise, scan back to previous comment-end to see if there's
	a comment starter between.  Also record whether the string quotes
	between the start and the end are paired and uniform.
	If so, skip to comment starter.  If not, scan from start of
	defun to find comment starter if any.
	(find_defun_start): New function.

	* alloc.c (mark_object): Save last 500 values of objptr.
	Check for clobberage of ptr, when marking a vector.

1992-09-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keymap.c (get_keyelt): Skip menu help string after menu item name.

1992-09-18  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* buffer.c (Fget_buffer_create): Doc fix.

	* lisp.h (struct handler): Remove the poll_suppress_count member
	of this structure; it is always equal to the poll_suppress_count
	of its catchtag structure.  The non-local exit code in eval.c is
	difficult enough to understand as it is; needless duplication
	doesn't help.
	* eval.c (Fcondition_case): Rearranged for clarity.  Don't worry
	about setting h.poll_suppress_count; it's guaranteed to be the
	same as c.poll_suppress_count.
	(internal_condition_case): Don't worry about
	h.poll_suppress_count.
	(Fsignal): Use h->tag->poll_suppress_count instead of
	h->poll_suppress_count.

	* eval.c (Fsignal): It's okay for the debugger to return to the
	caller if the caller was signalling a quit.

	* eval.c (unbind_catch): Restore the polling suppression count
	here, instead of in Fsignal and Fthrow.
	(Fthrow, Fsignal): Don't restore the polling suppression count here.
	
	* lisp.h (struct specbinding, struct handler): More documentation.
	* eval.c (struct catchtag): More documentation.

1992-09-17  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (LIBX): Don't use -loldX.

1992-09-17  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* minibuf.c (get_minibuffer): Enable undo in minibuffers.

1992-09-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* ymakefile (LIBXMENU): Check NO_X_MENU, not HAVE_X_MENU
	* emacs.c (main): Use X menu code if HAVE_X_WINDOWS and not NO_X_MENU.
	* keyboard.c (read_char_menu_prompt): Likewise.

	* config.h.in: Delete everything about config.h.

	* emacs.c: Eliminate HIGHPRI as compilation option.
	(emacs_priority): New C variable, also Lisp variable.
	(main): Set the priority iff emacs_priority is nonzero.

1992-09-14  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* eval.c (entering_debugger): Variable renamed
	when_entered_debugger, and is now a timestamp based on
	num_nonmacro_input_chars.
	(init_eval): Initialize when_entered_debugger, not
	entering_debugger.
	(call_debugger): Set when_entered_debugger to the current value of
	num_nonmacro_input_chars.
	(find_handler_clause): Don't call debugger unless
	num_nonmacro_input_chars is greater than when_entered_debugger;
	that way, we won't call the debugger unless the user has had a
	chance to take control.
	(Fbacktrace): Don't clear entering_debugger here.
	* keyboard.h (num_nonmacro_input_chars): Added extern declaration
	for this.

	* fns.c (Fy_or_n_p): After testing for a QUIT, clear Vquit_flag.
	Otherwise, if Fy_or_n_p is called while Vinhibit_quit is true and
	the user presses C-g, this function goes into an infinite loop.

	* dispnew.c (get_display_line): Don't abort if the frame is
	invisible; since unmap events are handled at the interrupt level,
	a screen may become invisible at any time.

1992-09-13  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c (Fverify_visited_file_modtime):
	Pass buffer itself to handler, if have handler.
	(Fwrite_region): GCPRO around Fexpand_file_name, Ffile_name_directory.
	(Fread_file_name_internal): GCPRO around file name manip.
	(Ffile_writable_p, Ffile_readable_p): Use abspath, not filename,
	(Ffile_executable_p, Ffile_exists_p): to run the handler.
	(Fset_file_modes, Ffile_directory_p, Ffile_modes): Likewise.
	(Ffile_newer_than_file_p): GCPRO around expand_and_dir_to_file.

1992-09-13  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* s/bsd4-3.h: Give the BSD4_3 and BSD symbols the same numeric
	definitions they'll get in <sys/param.h>, to avoid warnings.

	* m/hp9000s300.h: Don't include <sys/wait.h>.  This really
	shouldn't be necessary.
	(BIG_ENDIAN): Define this as "4321", to agree with
	<machines/endian.h>, and avoid warnings.

	* systime.h: Re-arrange inclusion of <sys/time.h> and <time.h> so
	that they don't both get included under BSD, and do both get
	included under AIX.

	* xdisp.c (display_mode_line): If the only other frames are
	minibuffer frames, don't name the frame after the in the selected
	window.  We can use Fnext_frame to do this test easily.

1992-09-12  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* process.c (Faccept_process_output): Initialize useconds.

	* keyboard.c (num_nonmacro_input_chars): New variable.
	(read_char): Use num_nonmacro_input_chars to decide on auto-save & gc.
	Increment it when appropriate.
	(record_auto_save): Use num_nonmacro_input_chars.

	* fileio.c (Ffile_name_directory, Ffile_name_nondirectory): 
	(Ffile_name_as_directory, Fdirectory_file_name, Fexpand_file_name): 
	Call find_file_handler.
	(syms_of_fileio): Set up Qfile_name_directory, etc.
	(Fcopy_file): Call find_file_handler for newname as well as for filename.
	(syms_of_fileio): Initialize Vfile_name_handler_alist.

1992-09-11  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* callint.c (Fcall_interactively): Remove the 'K' interactive
	code, in favor of 'e'; that's a better name.

1992-09-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

        * s/esix5r4.h: New file.

        * sysdep.c (init_sys_modes): Handle VDSUSP like V_DSUSP.
        Use CDISABLE, not CDEL.
        Turn off IEXTEN if it exists.
        * systty.h (CDISABLE): New macro; may be defined from CDEL.

	* keyboard.c (command_loop_1): Bind inhibit-quit to t when in Fsit_for.

1992-09-10  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* Makefile.in: Add comments starting with "# DIST: " explaining
	that this gets munged by the configure script.

1992-09-10  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* s-aix3-1.h (HAVE_GETHOSTNAME): Defined.

1992-09-09  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* frame.c (choose_minibuf_frame): abort if the selected frame has
	nil in its minibuffer_window slot; this shouldn't happen any more.
	* window.c (minibuffer_window): Accept an optional FRAME argument;
	if specified, return the minibuffer used by that frame.

	* keymap.c (describe_buffer_bindings): Adjust key_heading to match
	the format used by describe_map_tree.  Also, don't reprint the
	"key    binding" header above the global bindings if we've already
	printed it for the local bindings; it's clear enough that the
	columns mean the same thing as above.

1992-09-08  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * ralloc.c (r_re_alloc): Instead of allocating a new bloc at the
	end of the heap, copying the data to it, and then freeing the
	original bloc, just expand the original block.  This saves a copy
	and a call to sbrk, and also removes the large spike in memory
	allocation that would occur when resizing large buffers.  And it's
	less code.

	* keyboard.h (Vkeyboard_translate_table): Declare this extern
	here, so describe_buffer_bindings can use it.
	* keymap.c (describe_buffer_bindings): Declare buf and bufend...

1992-09-05  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* systime.h: Always #include <time.h>, not just when NEED_TIME_H
	is defined.  It gets us struct tm.  #include <sys/time.h> whenever
	HAVE_TIMEVAL is defined and NEED_TIME_H isn't.

	* systime.h: Note that the tz_dsttime field of the struct timezone
	returned by gettimeofday doesn't say whether daylight savings is
	_currently- active; rather it specifies whether it is *ever*
	active.
	(EMACS_GET_TZ_OFFSET_AND_SAVINGS): Removed `savings_flag'
	argument, and renamed to EMACS_GET_TZ_OFFSET.  Don't try to
	extract savings information.  EMACS_CURRENT_TIME_ZONE should call
	localtime to figure out whether DST is active.

	* m/hp9000s300.h: #include <sys/wait.h> before doing anything
	else, to avoid conflicts between the system's and Emacs's
	definitions of BIG_ENDIAN.

	* keymap.c (describe_buffer_bindings): Set the current buffer to
	descbuf before calling current_minor_maps; that function's value
	depends on the values of buffer-local variables.  Don't set the
	current buffer to Vstandard_output until afterwards.

	* keymap.c (describe_buffer_bindings): If
	Vkeyboard_translate_table is in effect, describe its effects.

	* frame.c (Fnext_frame): Doc fix.

	* frame.c (prev_frame): #if 0'd out; nobody uses this.

	* frame.c (next_frame): The logic which determines whether a frame
	is acceptable to return was misarranged; rewrote it.
	(prev_frame): Same thing.

1992-09-05  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* syntax.c (scan_lists): Improve smarts for backwards scan of comments.
	Don't modify comstyle inside that loop.
	If string quotes don't match up, don't take value from OFROM;
	instead, parse forward using scan_sexps_forward.
	(scan_sexps_forward): Return value via a pointer passed in.
	New element in state contains char addr of last comment-starter seen.
	(Fparse_partial_sexp): Change call to scan_sexps_forward.

1992-09-04  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xmenu.c (xmenu_show): If no panes, just return.

	* keyboard.c (last_nonmenu_event): New var.
	(syms_of_keyboard): New Lisp var.
	(read_key_sequence): Use that instead of prev_event.
	* commands.h (last_nonmenu_event): Declared.
	* callint.c (Fcall_interactively): For `K', use last_nonmenu_event.
	Make `e' alias for `K'.

1992-09-03  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * editfns.c (Fcurrent_time_string): Change docstring to
        indicate that we will probably add the timezone to the end,
        now that we have it available on many systems.

	* xrdb.c: Don't include <X11/Xos.h>.  Under R4, it stupidly
	insists on defining SIGCHLD, even if it already has a definition.
	(file_p): Use the constant 4 instead of R_OK; empirically, the
	number is more portable than the symbol if you count the #include
	hair you have to go through to get R_OK defined.  Ffile_readable_p
	does this too.

	* xterm.c (x_wm_set_size_hint): Set the base_width and base_height
	members of size_hints, if they're available (X11R4 and after);
	otherwise, approximate the right thing, by using min_width and
	min_height as the base size.

1992-09-02  Barry A. Warsaw   (warsaw@anthem.nlm.nih.gov)

	* Extended syntax.c in the following ways to support up to 2
	orthogonal comment styles per mode.  This is needed for C++.
	Bit 6 of syntax table entry for a character indicates
	it is part of the `b' comment style.  Otherwise it is
	part of the `a' style.
	* syntax.h (SYNTAX_COMMENT_STYLE): New macro.
	* syntax.c (Fmodify_syntax_entry): Set that flag for `b'.
	(describe_syntax): Print the `b' flag.
	(scan_lists, scan_sexps_forward): Handle the new flag.
	(Fparse_partial_sexp): Return new element in value.

1992-09-02  Roland McGrath  (roland@geech.gnu.ai.mit.edu)

	* fileio.c (syms_of_fileio): Doc fix for Vfile_name_handler_alist.

1992-09-02  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* keyboard.c (kbd_buffer_get_event): When performing the
	FRAME_FOCUS_FRAME redirection, don't modify the frame field of
	the event; that fatally corrupts mouse click events.  Instead,
	just perform the redirection on the value assigned to
	Vlast_event_frame.

	* callint.c (Fcall_interactively): Don't try to get the
	`enable-recursive-minibuffers' property from FUNCTION unless
	FUNCTION is actually a symbol; there are some cases where a key
	sequence is bound directly to a lambda form, and there's no reason
	to break these.

	* window.c (Fset_window_configuration): Don't signal an error
	if the frame size saved in the window configuration doesn't
	match the frame's current size; instead, temporarily resize
	the frame while installing the window configuration.  This is
	important because using the minibuffer saves and restores the
	current window configuration, and you don't want to signal an
	error just because the user resized the frame while using the
	minibuffer.

	* doc.c (Fsnarf_documentation): Signal an error if this is
	called in a dumped Emacs.

	* alloc.c (mark_object): mark a symbol's name after marking its
	value, function, and property list rather than before; this way,
	symbols' names are readable, giving us a chance to detect some
	kinds of heap corruption.

1992-09-02  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* emacs.c (__main, __do_global_dtors): New dummy functions.
	(__do_global_ctors_aux, __do_global_ctors): Fix typo in fn names.

1992-09-01  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* prefix-args.c: New file.  See comment at top of file.
	* ymakefile (YMF_PASS_LDFLAGS): Use the prefix-args program to
	affix the -Xlinker prefix to the linker arguments.
	(prefix-args): New target.
	(temacs): Depend on prefix-args.

	* xterm.c (x_catch_errors): Don't forget to initialize
	x_caught_error_message to the null string, so x_check_errors can
	tell when an error has occurred.

	* unexmips.c (mark_x): Declare this as static void at the top of
	the file and at the function definition.

	* keyboard.c (input_available_signal): Declare this to return
	SIGTYPE.

	* xrdb.c (getuid): Declare this to return short.

	* s/bsd4-3.h: Remove definition of SIGTYPE macro; Mt. Xinu says
	it's int, but Ultrix says it's void.  Since the SIGTYPE guessing
	code in the `configure' script gives the correct answer for both
	of these cases, there's no point in listing it here.

	* systime.h (EMACS_CURRENT_TIMEZONE): Change documentation to
	indicate that *OFFSET should be set to the number of minutes EAST
	of Greenwich, which is what Ed Reingold says real time gurus want.
	Changed the definition of the EMACS_GET_TZ_OFFSET_AND_SAVINGS
	macro to reflect this.  Buggily, the Fcurrent_time_zone function
	was already expecting minutes east of GMT.

	* Makefile.in (distclean): Remove backups from the `m' and `s'
	directories, too.

	* m/mips.h: Merge changes from Emacs 18.58:
	[NEWSOS5]: Changes so this file can be used with s/newsos5.h.
	(SIGN_EXTEND_CHAR): Define this using a cast to signed char.  I
	guess the MIPS compiler and its derivatives all have this type.
	(HAVE_ALLOCA, C_ALLOCA): Define the former if we're compiling with
	GCC, and the latter otherwise.
	(C_SWITCH_MACHINE): Defined, instead of C_SWITCH_SYSTEM.
	(LINKER): Defined, if BSD.
	(XUINT, XSET, XUNMARK): Add parentheses to eliminate warnings from
	GCC.  Reindent to fit in 80 columns.
	INHIBIT_BSD_TIME prevents including bsd/sys/time.h.
	* s/newsos5.h: New file for Sony NEWS-OS release 5, courtesy of
	Chris Hanson <cph@klia.ai.mit.edu>.

	* m/mips.h: Don't undefine LOAD_AVE_TYPE; the comment says that
	Emacs 19 has the crocks to handle it properly.

	* m/pmax.h: Merge changes from Emacs 18.58:
	(LIB_STANDARD, COFF, TERMINFO): Cancel out definitions from
	m/mips.h which are only appropriate for USG.
	(MAIL_USE_FLOCK, HAVE_UNION_WAIT): Do define these.
	(BROKEN_O_NONBLOCK): Defined.
	(LINKER): Don't define this.
	[OSF1]: Undef C_ALLOCA, define HAVE_ALLOCA.
	
	* s/osf1.h: New file.

	* s/bsd4-3.h: Merge changes from Emacs 18.58:
	(BSD, BSD4_3): Just define these, don't fret about numerical
	values or version numbers.

	* m/hp9000s300.h: Merge changes from Emacs 18.58, and hp300bsd.h:
	Change configuration note to say it's okay to use this file for BSD.
	Add comment saying that NOMULTIPLEJOBS must be defined for
	versions of HP/UX before 6.5.
	Don't define BIG_ENDIAN if it seems that <endian.h> has already
	done so.
        [BSD4_3] Define m68000, instead of hp9000s300; crt0.c uses these
	to decide what sort of startup code to use.
	[not BSD4_3] Under HP/UX, always define the BSD memory functions
	(bcopy, bzero, and bcmp) in terms of the SYSV string functions
	(memcpy, memset, and memcmp), not just under HP/UX 5; version 6's
	BSD compatibility library has reported bugs in `signal'.
	(NEED_BSDTTY): Move this symbol's definition inside the "not
	BSD4_3" conditional, since it's only relevant to HP/UX.
	* m/hp300bsd.h: File deleted, since m/hp9000s300.h now
	works with both HP/UX and BSD; it includes m/hp300bsd.h's
	specifications.

	* m/hp9000s300.h: Remove definition for SIGN_EXTEND_CHAR; this is
	only used by the regexp code, which has its own portable
	definition these days.

1992-08-31  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keymap.c (Fmake_sparse_keymap): New optional arg.  Callers changed.
	(Fmake_keymap): Likewise.

	* emacs.c (__do_global_ctors, __do_global_ctors_aux): New dummy fns.
	(__CTOR_LIST__, __DTOR_LIST__): New dummy variables.

	* fileio.c (Fdo_auto_save): Always call record_auto_save.

	* keyboard.c (read_char): Call read_char_menu_prompt here.
	Accept 4 new args to pass to it.  Include them in recursive call.
	Don't delay before starting echo if prev_event was a mouse event.
	Test for eof in batch mode now understands C is a Lisp_Object.
	(read_key_sequence): Don't call it here; always call read_char.
	Don't change last_event_buffer after a mouse menu input.
	(read_char_menu_prompt): Arg PROMPT deleted.
	Return nil if nothing to do.

	* xmenu.c (Fx_popup_menu): Treat coords relative to spec'd window.
	(single_keymap_panes): New function; contains guts of keymap_panes.
	If a command binding for submenu has a prompt string starting with @,
	make a separate pane for it at this level.

	* xfns.c (Fx_track_pointer): Pass new args to read_char.
	(Fx_select_region, Fx_horizontal_line): Likewise.
	* lread.c (Fread_char): Pass new args to read_char.
	(Fread_event, Fread_char_exclusive): Likewise.
	* fns.c (Fy_or_n_p): Pass new args to read_char.

1992-08-30  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): Keep track of prev_event.
	Pass new proper args to read_char_menu_prompt.
	(read_char_menu_prompt): New arg prev_event.  Use Fx_popup_menu.
	Handle any number of keymaps, not just LOCAL and GLOBAL.
	Invert meaning of arg PROMPT.  Test of menu_prompting was backwards.

	* keymap.c (keymap_table): No longer static.

	* xmenu.c (keymap_panes): New function.
	(Fx_popup_menu): Accept keymap or list of keymaps as MENU argument.
	Accept mouse button event as POSITION argument.

1992-08-29  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* cmds.c (internal_self_insert): Assume Fexpand_abbrev expanded
	something if it incremented MODIFF.

1992-08-28  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* unexmips.c (unexec): Allow sections in any order.
	Adjust addresses of rdata section as well as data section.

	* buffer.c (syms_of_buffer): Made buffer-display-table,
	buffer-field-list and buffer-undo-list allow any type of value.

1992-08-27  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fns.c (Fappend): Doc fix.

1992-08-24  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* s/usg5-4.h: Incorporate changes from 18.58:
	(LIBX10_SYSTEM): Undefine this.
	(GNULIB): Definition deleted -- done in ymakefile.
	(LIB_STANDARD): Don't use GNULIB.
	(HAVE_TCATTR): Defined.

	* xfns.c (x_icon): Don't call x_wm_set_icon_positions if the user
	hasn't specified the icon position.  Let the window manager put
	the icon where it likes.

        * xterm.c (x_make_frame_invisible): Don't forget to check the
	return value of XWithdrawWindow; it could indicate that the window
	wasn't successfully redrawn.

	* sysdep.c (init_baud_rate): Re-arranged order of conditionals -
	test TERMIOS before TERMIO; when two options might both be
	defined, test the most recent first, so that the most recent
	functions get used.

	* sysdep.c [HAVE_TERMIO] (init_baud_rate): Don't use tcgetattr
	unless HAVE_TCATTR is defined.  Only very rarely do termio systems
	have the tc{get,set}attr macros.

	* window.c (coordinates_in_window): Do not assume that all
	one-line windows are the minibuffer, or that all minibuffers are
	one line high.  Use MINI_WINDOW_P.

        * systerm.h: Renamed to systty.h, to be more consistent with
	everything else in Unix.
	* dispnew.c, emacs.c, keyboard.c, process.c, sysdep.c: #include
	directive changed.
	* ymakefile: References to systerm.h changed.

	* s/usg5-3.h: Merged changes from 18.58:
	(HAVE_SYSV_SIGPAUSE): Defined.
	(BROKEN_TIOCGETC): Defined.

1992-08-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* process.c (WCOREDUMP): Define only if not defined.
	(create_process) [HAVE_SETSID]: Use TIOCSCTTY if exists.
	
1992-08-20  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * fileio.c (Fdo_auto_save): Call Fsleep_for with the appropriate
	number of arguments.
	* fns.c (Fyes_or_no_p): Same.

	* dispnew.c (update_frame): Change the way we handle
	cursor_in_echo_area.  Firstly, ignore this if the frame we're
	updating doesn't have a minibuffer.  Secondly, don't handle the
	selected frame specially.  Thirdly, don't assume that the
	minibuffer is only one line high.  If cursor_in_echo_area < 0, put
	the cursor in the upper-left corner; if cursor_in_echo_area > 0,
	put it on the lowest non-empty line in the minibuffer window, or
	on the top line.

	* dispnew.c (direct_output_for_insert): Fail if
	cursor_in_echo_area is set; we don't want to do the typing there.
	(direct_output_for_insert): Same.

1992-08-19  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * xterm.c (x_make_frame_invisible): Use XWithdrawWindow when
	available [HAVE_X11R4]; send the UnmapNotify event when
	appropriate [HAVE_X11]; just unmap the window if that's all that's
	needed [not HAVE_X11].

	* xterm.c (x_set_text_property): Removed; it's only called from
	one place.  Who wants *another* layer of indirection?
	* xfns.c (x_set_name): Use XSetWM{Name,IconName} when available
	[HAVE_X11R4], or XSetIconName and XStoreName otherwise.

	* xterm.h (FRAME_X_WINDOW): New macro, for readability.
	* xterm.c, xfns.c, xselect.c: Use it.

	* emacs.c (Fkill_emacs): Doc fix.
	(syms_of_emacs): Doc fix for Vkill_emacs_hook.

	* xterm.c (x_death_handler): Renamed to x_connection_closed.
	(x_term_init): Use x_connection_closed as the SIGPIPE handler.

	* xterm.c (acceptable_x_error_p, x_handler_error_gracefully,
	x_error_handler): Removed; you can't catch X errors this way,
	since you can't perform X operations from within an X error
	handler, and even though we call error, we're still within an X
	error handler.
	(x_error_quitter, x_error_catcher): New functions, for panicking
	on and catching X protocol errors.
	(x_caught_error_message): Buffer for caught X errors.
	(x_catch_errors, x_check_errors, x_uncatch_errors): New functions
	for catching errors.
	(x_term_init): Set the error handler to x_error_quitter, rather
	than x_error_handler.
	* xfns.c (x_set_mouse_color): Use x_catch_errors, x_check_errors,
	and x_uncatch errors to avoid crashing if the user selects an
	odd cursor.

	* xterm.c (x_proto_requests): Removed; it's not important.
	
	* xterm.c (events): Array removed; it's not used.

	* xfns.c (select_visual): Use XVisualIDFromVisual when available
	[HAVE_X11R4].
	
	* xrdb.c (get_user_db): Use XResourceManagerString when available
	[HAVE_X11R4].

	* window.c (change_window_height): If the size of the window will
	shrink below the minimum, this code would only try to delete it if
	it had a parent.  Well, even if the window doesn't have a parent,
	you want Fdelete_window to signal an error, since you're trying to
	resize one of the undeleteable windows into nothingness.  So call
	Fdelete_window even if the window doesn't have a parent.

	* window.c (MINSIZE): Add kludge so that the minibuffer is always
	allowed to shrink to one line in height.
	(MINSIZE, CURBEG, CURSIZE): Change these so that their argument
	are always Lisp_Objects, not struct window *'s.
	(change_window_height): Changed accordingly.

1992-08-18  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * frame.h (struct frame): New member - explicit_name.
	* frame.c (make_frame): Clear it.
	* xfns.c (x_set_name): Take new argument EXPLICIT, instead of
	OLDVAL.
	(x_explicitly_set_name, x_implicitly_set_name): New functions.
	(x_frame_parms): Use x_explicitly_set_name here.
	(x_window): Use x_implicitly_set_name here.
	* xdisp.c (display_mode_line): Use x_implicitly_set_name here.

	* xterm.c (x_wm_hints): Variable deleted.  This has to be
	per-screen.  Duh.
	* xterm.h (struct x_display): New member: wm_hints.
	* xterm.c (x_wm_set_window_state, x_wm_set_icon_pixmap,
	x_wm_set_icon_position): Use F->wm_hints, rather than x_wm_hints.
	(x_term_init): Don't initialize x_wm_hints here.
	* xfns.c (Fx_create_frame): Instead, initialize f->x_wm_hints
	here.

	* xterm.c (x_set_text_property): Properly balance the BLOCK_INPUTs
	and UNBLOCK_INPUTs.  And remember that VALUE is the string we want
	to set the name to, not PROPERTY.

1992-08-17  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* frame.c (make_minibuffer_frame): Don't set this to auto-raise by
	default.  It's annoying.

	* frame.c (make_minibuffer_frame): Set the prev field of the
	minibuffer window on a minibuffer-only frame to Qnil, rather than
	having it point to itself.  This confuses code (Fprevious_window
	and change_window_height, for example), and is only an attempt to
	support a convention that can't really be used in Emacs 19 anymore.
	* window.h: Document the fact that we can no longer assume that
	the minibuffer's previous window is the root window, since a
	minibuffer window in a minibuffer-only frame has a prev field of
	nil.
	* frame.h [not MULTI_FRAME] (FRAME_ROOT_WINDOW): Define this by
	reference to the_only_frame.root_window, rather than by assuming
	that minibuf_window->prev is the root window.  While this is true
	in the non-multi-frame case, we want to discourage this assumption
	in code.
	* dispnew.c [not MULTI_FRAME] (Fredraw_display): Use
	FRAME_ROOT_WINDOW instead of minibuf_window->prev.
	* xdisp.c (redisplay, init_xdisp): Same.
	* window.c (Fset_window_configuration): Removed #if 0'd code which
	assumes that minibuf_window is on the same frame as the window
	configuration.  Removed special case for windows whose prevs
	point to themselves.

	* window.c (Fset_window_configuration): Rename the argument from
	ARG to CONFIGURATION, so it matches the docstring.  The
	make-docfile program cares.

	* window.c [MULTI_FRAME] (syms_of_window): Don't staticpro
	minibuf_window; the frame list will take care of it.

	* xterm.h (HAVE_X11R4): Since we can autodetect this, and can
	write code more likely to be future-compatible, define this when
	appropriate.
	* xterm.c (x_set_text_property): Define this appropriately for
	X11R3 and X11R4.

	* xterm.c (x_set_text_property): Make this take a Lisp_Object
	string as an argument, rather than a pointer and a length.
	* xfns.c (x_set_name): Caller changed.

	* xfns.c (x_get_arg): Accept a new type - symbol.  If we've
	retrieved a string from the xrdb database and the user wants a
	symbol, intern it.
	(Fx_create_frame): Use the symbol type here.

	* xfns.c (x_figure_window_size, x_icon, Fx_create_frame): Use
	values from enum resource_types for the last arg to x_get_arg,
	instead of passing numbers.

	* xfns.c (Fx_create_frame): When setting up the scroll bars, use
	the type parameter to x_default_parameter, rather than prefixing
	the resource name with a question mark.

	* xfns.c [not HAVE_X11] (Fx_create_frame): The resource which
	determines whether or not to use a bitmapped icon is called
	"IconType", not "BitmapIcon".  Update this.

1992-08-15  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* xterm.c: Doc fixes.

        More SYSV portability changes from Eric Raymond:

	* xterm.c [USG5]: Don't include <sys/types.h>.

	* xterm.c (x_make_frame_invisible): Instead of calling XWithdraw
	window, which isn't widely available, write out what it does,
	since that's not much.
	(x_iconify_frame): Explicitly perform both the X11R3 and X11R4
	methods for iconification; don't use XIconifyWindow, since that's
	not present in R3.
	
	* xterm.c (x_wm_set_size_hint): Don't bother setting the
	base_width and base_height members; their function is performed
	just as well by the min_width and min_height members, and if we
	use XSetNormalHints instead of XSetWMNormalHints, we can be
	compatible with R3.

	* xterm.c (x_error_handler): There is no way to invoke the default
	error handler which works on all versions of X11, so don't bother;
	call XGetErrorText and print the message ourselves.

	* xterm.c (x_term_init): Don't use MAXHOSTNAMELEN; this isn't
	defined on all systems.  Since we only use that as an initial
	guess anyway, it's not very important.

1992-08-14  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* abbrev.c (Fexpand_abbrev): If pre-expand hook changes the buffer,
	assume that means we "did an expansion".

	* cmds.c (internal_self_insert): Ignore value of Fexpand_abbrev;
	instead, check whether buf is modified when it returns.

1992-08-14  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        Applied SYSV portability changes from Eric Raymond:

	* xrdb.c [USG5]: Define SYSV, and then include <unistd.h>.
	Apparently, Xlib.h include string.h if SYSV is defined, and
	strings.h if not.
	Don't include <sys/types.h>; just declare getuid to return an
    	int.  Big deal.
	(MAXPATHLEN): If this is not defined by the system's include
    	files, give it a value of 256.
	(get_user_db): Fetch the defaults directly from the display
    	structure, rather than using XResourceManagerString; that
    	function doesn't exist in the older versions of X.

	* xterm.c (x_set_text_property): New function.
	* xfns.c (x_set_name): Use it instead of XSetWMName and
    	XSetWMIconName.

	* xfns.c (select_visual): Fetch the visual id directly from v;
    	don't call XVisualIDFromVisual, since that function is not
    	available in earlier versions of X.

	* term.c (term_get_fkeys): Some systems define `static' to be the
    	empty string, which means that you can't have constant
    	initialized arrays inside a function.  So move the `keys' array
    	outside of the function.
	* xdisp.c (decode_mode_spec): Same deal, with lots_of_dashes.
	* xfns.c (x_make_gc): Same deal, regarding cursor_bits.

	* term.c (keys): Include definitions for "K2" (the center key on
    	an IBM keypad), "F1" (F11), and "F2" (F12).  Handle "k0" and "k;"
    	specially; see the code for details.

	* term.c (clear_end_of_line): Remember that on some systems,
    	"static" gets defined to be the null string, so we can't declare
    	an array to be static and then initialize it.  Since the array in
    	question (buf) is only one element long, just make it a scalar
    	rather than an array; it can then be initialized, even if it's
    	not static.

	* systime.h [not HAVE_TIMEVAL] (EMACS_USECS, EMACS_SET_USECS):
    	Don't forget to define dummy versions of these.

	* systime.h [USE_UTIME]: time_t is a typedef, not a struct.
    	Don't prefix it with `struct'.

	* systerm.h (EMACS_SET_TTY_PGRP): When there doesn't seem to be
    	any way to do this, don't forget to give it a dummy definition.

	* sysdep.c (select): There's no need to cast the return value of
    	signal anymore, since we have the SIGTYPE macro defined.

	* sysdep.c (read_input_waiting): When scanning for quit
    	characters, use the value of quit_char, rather than assuming that
    	C-g is the quit character.  And don't forget to declare i.

	* sysdep.c [USG5]: Don't include fcntl.h.

	* s/usg5-3.h: Eric Raymond writes:
	Define HAVE_SELECT and BSTRINGS only if HAVE_X_WINDOWS is on,
	because that means we'll be linking in the shared libraries
	containing the BSD emulations.  Teach the file about the shared
	libraries necessary to link X programs, because AT&T doesn't
	supply static libraries for X.  Also, fix the incorrect assertion
	that -lg cannot be used with SVr3.  Finally, force USE_UTIMES and
	BROKEN_TIOCGWINSZ.  (Note for the future; there may be a
	utimes(2)) emulation lurking in the X shared libraries.)

	* s/usg5-4.h (USE_UTIME): Remove this definition; the C library
    	still doesn't have utimes.

	* ralloc.c (get_bloc): When initializing new_bloc->variable, cast
	NIL to (POINTER *).
	(malloc_init): Give warning if sbrk returns zero.  Wonder what
	that's supposed to mean.

	* process.c (process_send_signal): Don't send SIGTSTP if the
	system doesn't have that facility.

	* process.c: [USG5] Don't include <fcntl.h>.
	[USG] Don't bother including <termios.h>, <termio.h>, or
	<fcntl.h>; systerm.h takes care of all that.
	Remove the "mis;tak-+;;" line from the code; apparently this
	section of code does get used.

	* minibuf.c (Fread_from_minibuffer): Put this function's doc
	string into a comment; it's too long for the PCC preprocessor.
	Rah.
	(Fcompleting_read): Same deal.

	* keyboard.c (init_keyboard): Changed "#endif SIGIO" to
	"#endif /* SIGIO */"
	* mocklisp.c (Fml_substr): Same sort of thing.
	* process.c (wait_reading_process_input): Same.

	* floatfns.c (Fexpm1, Flog1p): Function removed; it's not widely
	available, and hardly vital.
	(syms_of_floatfns): Adjusted appropriately.

	* floatfns.c (Flog): Accept optional second arg, being the base
	for the logarithm.
	[USG] (Flogb): Define this in terms of Flog.

	* data.c [USG] (Frem): Call fmod, rather than drem.  Rah.

	* emacs.c [USG5]: Don't #include <fcntl.h> for these systems.

	* alloc.c (Fmake_marker): Removed the test for being called from a
	signal handler.  The original bug is probably gone, the test
	wasn't written portably, and it should probably go somewhere else
	anyway - say, funcall or eval.

        End of changes from Eric Raymond.

	* xfns.c (Fx_create_frame): Make the default for the icon-type
    	parameter nil, not t.  It seems to cause problems with some X
    	servers.

	* lisp.h (DEFVAR_PER_BUFFER): Add new argument, TYPE, to help
	check the types of buffer-local variable slots.
	* buffer.c (syms_of_buffer): Call DEFVAR_PER_BUFFER with the new
	TYPE argument.
	* abbrev.c (syms_of_abbrev): Same.
	* buffer.c (buffer_local_types): New variable.
	(buffer_slot_type_mismatch): New function.
	* buffer.h (buffer_local_types): New extern declaration.
	* data.c (store_symval_forwarding): When storing through a
	Lisp_Buffer_Objfwd, check if the slot requires a particular type,
	and report an error if the types clash.
	* lread.c (defvar_per_buffer): Support new TYPE argument, by
	setting the appropriate slot in buffer_local_types.

1992-08-13  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* window.c (window_loop): This used to keep track of the first
	window processed and wait until we came back around to it.  Sadly,
	this doesn't work if that window gets deleted.  So instead, use
	Fprevious_window to find the last window to process, and loop
	until we've done that one.

	* window.c [not MULTI_FRAME] (init_window_once): Don't forget to
	set the `mini_p' flag on the new minibuffer window to t.

	* window.c (Fwindow_at): Don't check the type of the frame
	argument.

	* window.c [not MULTI_FRAME] (window_loop): Set frame to zero,
	instead of trying to decode it.

	* frame.h [not MULTI_FRAME] (the_only_frame): Put a comment above
	this indicating that it's not GCPRO'd.  Put parens around some of
	the FRAME_* macros' definitions.
	[not MULTI_SCREEN] (Fselected_frame): New function.

	* frame.h [not MULTI_FRAME] (FRAME_ROOT_WINDOW): Define this in
	terms of minibuf_window, rather than by reference to
	the_only_frame.
	* window.c (init_window_once): Initialize minibuf_window before
	FRAME_ROOT_WINDOW, so the latter actually points to something.

	* keyboard.c (Fexecute_mouse_event): dyked-out function deleted.
	We're not going to use this mouse interface.
	(Vmouse_window, Vmouse_event, Vmouse_event_function,
	Vmouse_left_hook, Vmap_frame_hook, Vunmap_frame_hook,
	Vmouse_motion_handler): Variables deleted; they were to be used by
	Fexecute_mouse_event.
	(syms_of_keyboard): Same.
	(command_loop_1): Remove dyked-out code to support
	Fexecute_mouse_event.
	(read_char): Same.

	* keyboard.c (Vlast_event_frame): Don't define this window if
	MULTI_FRAME is not #defined.
	(syms_of_keyboard): Same.
	(kbd_buffer_store_event): Don't try to work with Vlast_event_frame
	if MULTI_FRAME is not #defined.
	(kbd_buffer_get_event): Same.

	* keyboard.c (Fdiscard_input): Removed dyked-out code from when
	unread_command_char's quiescent value was -1, not nil.

	* frame.c (make_frame): Stop passing zero to make_window; it's not
	expecting any arguments.

1992-08-12  Jim Blandy  (jimb@albert.gnu.ai.mit.edu)

        * unexsunos4.c: Deleted "$Log" header in comments at top of file;
	this was beginning to grow RCS hair, which we don't want.
	* xmenu.c: Same deal.

1992-08-11  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

        * fileio.c (Fread_filename): Don't add one here.
	* minibuf.c (Fcompleting_read): Instead, stop subtracting one
	here, so this function lives up to its doc string, which I think
	specifies an okay way to work.

	* doc.c (Vdata_directory): Removed; this is declared in callproc.c.
	(syms_of_doc): Initialization removed.

	* xfns.c (x_get_arg): Return Qunbound for an unspecified
	resource, not nil.  That way, we can tell the difference between a
	false resource and an unspecified resource.
	(x_default_error): Use DEFLT if x_get_arg returns Qunbound, not Qnil.
	(x_figure_window_size, x_icon, Fx_create_frame): Deal with
	Qunbound and Qnil properly.

	* xfns.c (Fx_create_frame): Pass the correct number of arguments
	to x_set_font.

	* xfns.c [not HAVE_X11] (Fx_create_frame): Delete section that's
	only included if we *do* have X11.  Blind patching.

        * xfns.c (x_icon): Rewritten to call x_wm_set_icon_position and
	x_wm_set_window_state instead of calling XSetWMHints directly.
	* xterm.c (x_wm_hints): New variable.
	(x_wm_set_window_state, x_wm_set_icon_pixmap,
	x_wm_set_icon_position): Use x_wm_hints.
	(x_term_init): Set the `input' field of x_wm_hints, and its flag.

	* xterm.c (x_text_icon): Call x_wm_set_icon_pixmap with a pixmap
	of zero, to clear the pixmap.
	(x_wm_set_icon_pixmap): Accept this protocol; if pixmap is zero,
	specify no pixmap for the icon.

	* xfns.c (x_default_parameter): Don't call store_frame_param here;
	it's already taken care of by x_set_frame_parameters.

	* xfns.c (Fx_create_frame): Check for the `icon-type',
	`auto-raise', and `auto-lower' parameters. Have `icon-type'
	default to t, indicating that we want the nifty gnu in our icons.
	(Qauto_lower): New symbol.

	* xfns.c (x_set_icon_type): UNBLOCK_INPUT before reporting the
	error, not after.  error doesn't return, sklitch-brain.

	* xterm.c (x_set_window_size): Call check_frame_size to make sure
	that the requested dimensions are within acceptable limits.
	Store the new size information in the frame structure.

	* xfns.c (x_set_frame_parameters): Properly recognize changes to
	the height of the frame.  Recognize changes of the frame's
	position.

	* xfns.c (x_set_frame_parameters): Iterate over ALIST while the
	current element is cons, not while it's non-nil.
	(syms_of_xfns): Call init_x_parm_symbols after interning all the
	other atoms; init_x_parm_symbols expects Qx_frame_parameter to be
	initialized.

1992-08-10  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* xfns.c (Qbackground_color, Qborder_color,  Qborder_width,
	Qcursor_color,  Qfont,  Qforeground_color,  Qgeometry,
	Qhorizontal_scroll_bar,  Qicon_left,  Qicon_top,  Qiconic_startup,
	Qinternal_border_width,  Qleft,  Qmouse_color,  Qparent_id,
	Qsuppress_icon,  Qsuppress_initial_map,  Qtop,  Qundefined_color,
	Qvertical_scroll_bar,  Qwindow_id,  Qx_frame_parameter): New
	symbols, with lisp code to rebuild syms_of_xfns.
	(syms_of_xfns): Initialize and staticpro them.
	(Qheight, Qminibuffer, Qname, Qnone, Qonly, Qwidth,
	Qunsplittable): Add extern declaration for these.
	(x_init_parm_symbols): Don't initialize Qx_frame_parameter here;
	it's done in syms_of_xfns.
	(x_default_parameter): Change the argument char *PROPNAME into a
	Lisp_Object PROP; let the caller take care of interning the atom.
	(Fx_geometry, x_figure_window_size, x_icon, Fx_create_frame): Use
	the new Q... variables, instead of interning things.

	* frame.c (Qheight, Qicon, Qmodeline, Qname, Qnone, Qonly,
	Qunsplittable, Qwidth, Qx): New symbol, with lisp code to rebuild
	syms_of_frame.
	(syms_of_xfns): Initialize and staticpro them.
	(Fframep, Fframe_visible_p, Fframe_parameters):  Use
	the new Q... variables, instead of interning things.
	(store_in_alist): Change the argument char *PROPNAME into a
	Lisp_Object PROP; let the caller take care of interning the atom.

	* frame.c (Fframe_visible_p): Doc fix.

	* frame.c (Fframe_parameters): When figuring the `minibuffer'
	parameter, if FRAME doesn't have a minibuffer, return `none', not
	nil.  If it does have a minibuffer with other windows, return the
	window.

	* frame.c (Fmodify_frame_parameters): Don't write out the loop for
	processing X frame parameters here; do it in the x specific code.
	Call the function which deals with this stuff
	x_set_frame_parameters, not x_set_frame_parameter.
	* xfns.c (x_set_frame_param): Replaced by x_set_frame_parameters.
	(x_set_frame_parameters): Process the alist of parameters here.
        Notice `width', `height', `top', and `left' parameters.
        Hold off changing the frame size and position until the end, so we
	can do both parameters at once when they are both specified.
	(x_default_parameter): Call x_set_frame_parameters, not
	x_set_frame_param.

	* frame.c (Fmake_frame_visible, Fmake_frame_invisible,
	Ficonify_frame, Fframe_parameters, Fmodify_frame_parameters,
	Fset_frame_height, Fset_frame_width, Fset_frame_size,
	Fset_frame_position): Place clauses controlled by FRAME_X_P inside
	`#ifdef HAVE_X_WINDOWS ... #endif' clauses.

	* frame.c (Fset_frame_position): Doc fix.

	* dispnew.c (Fredraw_frame): Call clear_frame_records before
	calling update_end, so that x_display_box_cursor can rely on the
	contents of f->current_glyphs.

	* xfns.c (x_figure_window_size): Indicate that this function
	returns an int, rather than just leaving it unstated.

	* xterm.c (x_wm_set_size_hint): Don't try to set the base_height
	and base_width elements of size_hints if PBaseSize is not
	#defined.  Set the minimum frame size according to the information
	returned by check_frame_size.

	* window.h (MIN_SAFE_WINDOW_HEIGHT, MIN_SAFE_WINDOW_WIDTH): Macros
	removed.
	(check_frame_size): New extern declaration.
	* window.c (MIN_SAFE_WINDOW_HEIGHT, MIN_SAFE_WINDOW_WIDTH): Macros
	defined here now.
	(check_frame_size): New function.
	* dispnew.c (change_frame_size): Call check_frame_size here,
	rather than writing out its code.  Don't declare newheight and
	newwidth to be register variables, since we take their address.

	* bytecode.c (Fbyte_code): When metering the Bcall opcodes, make
	sure the count on the symbol's `byte-code-meter' property does not
	overflow.

	* bytecode.c (syms_of_bytecode): Add a docstring for
	byte-metering-on.

1992-08-08  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* dispnew.c (in_display): Variable deleted; it's only ever used as
	an unofficial parameter to change_frame_size.
	(change_frame_size): New argument, DELAY, which when non-zero
	indicates to delay the size change until later.  This should be
	passed as one from signal handlers.
	(window_change_signal): Call change_frame_size with a DELAY of 1.
	(do_pending_window_change): Call change_frame_size with DELAY of 0.
	* frame.c [MULTI_SCREEN] (Fset_frame_height, Fset_frame_width,
	Fset_frame_size): Same.
	[not MULTI_SCREEN] (Fset_frame_height, Fset_frame_width,
	Fset_frame_size, Fset_screen_height, Fset_screen_width): Same.
	* keyboard.c (Fsuspend_emacs): Call change_frame_size with the
	proper arguments - the height and width are the second and third
	arguments, not the first and second.  Pass 0 for DELAY.
	* xfns.c (Fx_create_frame): Call change_frame_size with a DELAY of 0.
	* xterm.c (XTread_socket, x_do_pending_expose): Call
	change_frame_size with a DELAY of 1.
	
	* xterm.c (in_display): Deleted this; it's never used in xterm.c,
	and there is another variable by the same name in dispnew.c.

	* frame.c [not MULTI_SCREEN] (Fset_frame_height, Fset_frame_width,
	Fset_frame_size, Fframe_height, Fframe_width): New functions, for
	use when Emacs is not compiled with multiple screens.
	[not MULTI_SCREEN] (Fset_screen_height, Fset_screen_width):
	Functions added for backward compatibility with Emacs 18.  These
	would be just aliases, except that the version 18 functions don't
	take a FRAME argument.
	[not MULTI_SCREEN] (syms_of_frame): New function, to defsubr the
	above and add screen-height and screen-width as aliases for
	Fframe_height and Fframe_width.
	* emacs.c (main): Call syms_of_frame unconditionally.  When
	MULTI_FRAME is not defined, it still provides the Fframe_width,
	Fframe_height, Fset_frame_width, and Fset_frame_height functions.

	* frame.c (Fset_frame_width): Change the size of FRAME, not of
	selected_frame.

	* frame.c (Fset_frame_width, Fset_frame_height): Declare the
	`frame' argument to be a Lisp_Object.  It used to be undeclared.

1992-08-07  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* dispnew.c, frame.c, frame.h, keyboard.c, scroll.c, term.c,
	window.c, xdisp.c, xfns.c xterm.c (FRAME_IS_TERMCAP, FRAME_IS_X,
	FRAME_HAS_MINIBUF): Renamed these to FRAME_TERMCAP_P, FRAME_X_P,
	and FRAME_HAS_MINIBUF_P, for consistency with the rest of the
	frame macros.

	* window.h (MIN_SAFE_WINDOW_WIDTH, MIN_SAFE_WINDOW_HEIGHT): New
	macros.
	* window.c (check_min_window_sizes): New function.
	(set_window_height): Call it.
	(Fsplit_window, change_window_height): Call it, instead of writing
	out its code.
	* dispnew.c (change_frame_size): If newlength or newwidth are too
	small (according to the value of MIN_SAFE_WINDOW_{WIDTH,HEIGHT}),
	force them larger.  This isn't really right, but it's better than
	crashing.

	* editfns.c (Fcurrent_time_zone): Doc fix.

1992-08-06  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* editfns.c (Fcurrent_time_zone): Don't forget to include code to
	signal an error when EMACS_CURRENT_TIME_ZONE is not defined.

1992-08-06  Joseph Arceneaux (jla@gnu.ai.mit.edu)

        * doc.c (Vdata_directory): Declared.
	(syms_of_doc): Initialized.

	* fileio.c (Fread_filename): Add 1 to the offset position for the
	cursor when reading file names.

1992-08-05  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* systime.h (EMACS_CURRENT_TIME_ZONE): New macro.
	* editfns.c (Fcurrent_time_zone): New function.
	(syms_of_editfns): defsubr it.

	* keyboard.c (read_key_sequence): Clear the eighth bit of the
	character from the key sequence, NOT the index of the character IN
	the key sequence.  How many tries will it take to get it right?

1992-08-04  Roland McGrath (roland@churchy.gnu.ai.mit.edu)

	* eval.c (syms_of_eval): Doc fix for debug-on-quit.

1992-08-03  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* callproc.c (Fcall_process): Doc fix.  Used to claim that
	Fcall_process doesn't wait when BUFFER was nil.  It does.

1992-07-30  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* keyboard.c (read_key_sequence): Scan for function keys when t >=
	mock_input, not when t > mock_input.  We do want to scan for
	function keys when t == mock_input.

	* keyboard.c (read_key_sequence): Don't increment fkey_end when
	testing to see if keybuf[fkey_end] is a meta-character.

1992-07-27  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* Makefile.in (TAGS): Generate tags for files in ../external-lisp
	too.

1992-07-26  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* eval.c (find_handler_clause): For quit, don't check Vdebug_on_error.
	(wants_debugger): Rewrite so it cannot get an error.

	* callint.c (Fcall_interactively): Handle enable-recursive-minibuffers
	property on the command, by enabling recursive minibuffers.
	(syms_of_callint): Set Qenable_recursive_minibuffers.

1992-07-24  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* frame.c (Fmake_frame_visible, Fmake_frame_invisible,
	Ficonify_frame): Make the first argument optional, defaulting to
	selected_frame.
	(Ficonify_frame, Fmake_frame_invisible): Add interactive specs, so
	we can bind these directly to C-z.

1992-07-24  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fileio.c (Fread_file_name): Use new calling convention for
	Fcompleting_read, with history as Qfile_name_history.
	(syms_of_fileio): Set Qfile_name_history; set the var to nil.
	Do staticpro for the recently created Q* vars.	

	* minibuf.c (read_minibuf): Two additional args histvar and histpos.
	All calls changed.
	(Fcompleting_read): Last arg is now HIST--(HISTVAR . HISTPOS).
	Arg INIT can now be (INITIAL-STRING . INITIAL-POSITION).
	Pass BACKUP_N arg to read_minibuf properly as Lisp object.	
	(Fread_from_minibuffer): Likewise.
	(syms_of_minibuf): Set Qminibuffer_history and staticpro it.

	* eval.c (Ffuncall, Feval): Support subrs with 7 args.

	* fns.c (Fyes_or_no_p): Use Fread_string, not read_minibuf.
	* callint.c (Fcall_interactively): For 'S', use Fread_no_blanks_input
	rather than read_minibuf.	

1992-07-23  Richard Stallman  (rms@mole.gnu.ai.mit.edu)
	
	* minibuf.c (Vminibuffer_history_variable): New variable.
	(syms_of_minibuf): Define variable minibuffer-history-variable.	
	(read_minibuf): Push the string on specified history list.
	
1992-07-23  Roland McGrath  (roland@churchy.gnu.ai.mit.edu)

	* Makefile.in (doall, doxemacs, dotemacs): Put quotes around CC=${CC}.
	Don't include $(MAKEOVERRIDES); that is always implicit.

1992-07-22  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* keyboard.c (read_key_sequence): If we have read a
	meta-character, prefix it with meta_prefix_char before looking it
	up in the function key keymap.

	* lread.c (Fread_char_exclusive): Code this with a do-while loop,
	not a while loop with its body repeated.

	* lread.c (Fread_event): Don't make this function's definition
	conditional on X-windows.  It ought to be there no matter how
	Emacs was built.
	(syms_of_lread): Don't make its defsubr conditional either.

	* lread.c (Fread_char): Doc fix.

	* fileio.c (find_file_handler): It's called
	Vfile_name_handler_alist, not Vfile_handler_alist.
	(Fwrite_region): Declare the variable named `handler'.
	(Fverify_visited_file_modtime): Use `b->filename', not `filename'.
	(Fset_visited_file_modtime): Declare the variable named `handler'.
	* dired.c (Fdirectory_files, Ffile_name_completion): Use
	`dirname', not `filename'.
	(Qfile_attributes): New variable.
	(syms_of_dired): Initialize it.

	* xselect.c (Fx_own_selection): If we're trying to set
	cut-buffer0, and the value is too large for the X server (as
	indicated by the max_request_size member of the X Display), just
	set the buffer to the empty string, and return nil.

1992-07-21  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* search.c (fast_string_match): New function.
	* fileio.c (find_file_handler): New function.
	(Fcopy_file, Fmake_directory, Fdelete_directory, Fdelete_file):
	(Frename_file, Fadd_name_to_file, Fmake_symbolic_link):
	(Ffile_exists_p, Ffile_executable_p, Ffile_readable_p, Ffile_symlink_p)
	(Ffile_writable_p, Ffile_directory_p, Ffile_accessible_directory_p):
	(Ffile_modes, Fset_file_modes, Ffile_newer_than_file_p):
	(Fwrite_region, Fverify_visited_file_modtime):
	Use find_file_handler; call the handler and return.
	(Finsert_file_contents): Use find_file_handler;
	cannot just return after the handler, but must handle VISIT.
	(syms_of_fileio): Set up Qcopy_file, etc.	
	* dired.c (Fdirectory_files, Ffile_name_completion):
	(Ffile_name_all_completions, Ffile_attributes):
	Use find_file_handler; call the handler.
	(syms_of_dired): Set Qfile_attributes, etc.

1992-07-21  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xselect.c (Fx_own_selection): Initialize val to nil, so that if
	we don't get the selection, we don't return garbage.  When setting
	cut-buffer0, set val to the string pasted.

	* xfns.c (x_set_name): If ARG is nil, set the frame's name to the
	current x_id_name.
	* xdisp.c (display_mode_line): If we should set the frame's name,
	but there is only one frame currently active, call x_set_name with
	nil as the name; this will display samething generically
	appropriate.

1992-07-20  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)
	
	* lread.c (isfloat_string): Recognize floats without a leading
	integer part, noting that "e5" is a symbol, not a floating point
	number.
	
	* xdisp.c (message, message1): When displaying a message, don't
	make the minibuf frame visible unless the selected frame is also
	visible.  This means that frames won't pop up unless the user is
	actually interacting with Emacs.

	* xdisp.c (display_mode_line): If Emacs is currently supporting
	only one screen, don't change the title of the screen to the name
	of the current buffer; this is only annoying in this case.  We
	should probably think more carefully about how screens should be
	named.

1992-07-19  Richard Stallman  (rms@mole.gnu.ai.mit.edu)
	
	* process.c (allocate_pty): Handle PTY_OPEN.	
	Delete system-specific alternatives to PTY_NAME_SPRINTF
	and PTY_TTY_NAME_SPRINTF.	
	
1992-07-18  Richard Stallman  (rms@mole.gnu.ai.mit.edu)
	
	* callint.c (Fprefix_numeric_value): Fix typo: test raw, not val.
	
1992-07-17  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* xfns.c (x_window): x_set_name normally ignores requests to set
	the name if the requested name is the same as the current name.
	This is the one place where that assumption isn't correct; f->name
	is set, but the X server hasn't been told.  So fake it out.

	* emacs.c [sun] (main): On suns, localtime caches the value of the
	time zone rather than looking it up every time.  This means that
	the dumped Emacs doesn't check the value of the TZ environment
	variable.  Call tzset before entering the editing loop to check
	the new TZ value.

1992-07-16  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* dired.c (Fdirectory_files): Don't forget to pass the REGP
	argument to compile_pattern.
	* search.c (compile_pattern): If REGP is zero, don't call
	re_set_registers; nobody cares.

	* fileio.c (auto_save_error): Pass the correct number of arguments
	to Fsleep_for.

	* lread.c: Include <ctype.h> at the top of the file, instead of
	just before isfloat_string; read0 wants to use it too.

	* process.c (Fdelete_process, Fprocess_status, Fprocess_send_region,
	Fprocess_send_string, Fprocess_send_eof, Finterrupt_process): Doc
	fixes.
	
	* process.c (Fprocess_status): Use get_process to find the process
	denoted by the PROC argument, not Fget_process.

1992-07-15  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* xdisp.c: Doc fix.

1992-07-14  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* window.c (syms_of_window): Doc fix for pop-up-frames.

	* frame.c (Fframe_parameters): Note that if FRAME is omitted, it
	defaults to the selected frame.

	* frame.c (Fframe_height, Fframe_width): Blocked out these
	functions; they have no C callers, and can be written nicely in
	lisp.
	
	* frame.c (Fframe_pixel_size): Function removed; there aren't
	enough other functions available to make this useful.  We need
	functions describing the size of the characters of a font.

	* xterm.h, xterm.c, xselect.c, xmenu.c, xfns.c, xdisp.c, window.h,
	window.c, termopts.h, termhooks.h, termchar.h, term.c sysdep.c,
	scroll.c, screen.c, screen.h, process.c, print.c, minibuf.c,
	lisp.h keyboard.c, indent.c, fns.c, emacs.c, dispnew.c,
	dispextern.h, cm.h, alloc.c, config.h.in: Screens are now called
	frames, to avoid even more confusion with X terminology than
	Emacs's "windows" already cause.  All macros, functions, and
	variables renamed; all uses changed.
	* screen.c, screen.h: Renamed to frame.c and frame.h.  All
	#includers changed.
	* ymakefile: Adjusted appropriately.
	* buffer.c: Doc fixes.

	* xfns.c (Fx_store_cut_buffer): Reversed sense of test for non-X
	screen.

	* window.c (Frecenter): Doc fix; this function places point in the
	middle of the current window, not the current screen.

	* window.c (temp_output_buffer_show): Use WINDOW_SCREEN macro
	instead of accessing the member directly.

1992-07-13  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* print.c (print): Changed code which prints screen objects to use
	the SCREEN_LIVE_P macro instead of testing the screen structure
	directly.

	* alloc.c (undo_threshold, undo_high_threshold): Variables renamed
	to undo_limit and undo_strong_limit.
	(Fgarbage_collect): Uses changed.
	(syms_of_alloc): DEFVARs and docstrings changed.
	* undo.c (truncate_undo_list): Comment adjusted.

	* lread.c (read0): Allow floating-point numbers to begin with a
	period.  `(0 .5)' denotes a list of two numbers, not a dotted pair.

1992-07-11  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* fns.c, callproc.c: Doc fix.

1992-07-10  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* bytecode.c (Bsymbol_function, Bfset): Removed comments saying
	that these are no longer generated.  Jamie Zawinski's byte
	compiler does generate them, and he's actually collected
	statistics on how often these functions are called.

1992-07-09  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* screen.c (store_screen_param): Clarify error message.

	* xterm.c (x_make_screen_visible): Undo the change made on June
	30; that is not the right solution.  Apparently there are three
	states a window may be in: normal, iconified, and invisible.

1992-07-08  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* eval.c (Fmacroexpand): Code cleaned up; there's no need to
	handle forms like ((macro lambda ...) ...) specially.

	* fileio.c (Finsert_file_contents): Signal an error if we're asked
	to read from a named pipe.

1992-07-07  Jim Blandy  (jimb@wookumz.gnu.ai.mit.edu)

	* m/*.h (SIGN_EXTEND_CHAR): Removed these definitions.  The only
	place they were used is in regex.c, and nowadays that has its own
	definition, which works for any machine.  The definitions in the
	machine description files usually didn't work if given an unsigned
	character as an argument, anyway.

1992-07-04  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* buffer.c: Doc fix.

1992-07-02  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* minibuf.c (Fdisplay_completion_list): Declared new variables
	used in rms' previous change.

1992-07-02  Richard Stallman  (rms@mole.gnu.ai.mit.edu)

	* minibuf.c (Fdisplay_completion_list): Handle non-buffer stream.

1992-07-01  Roland McGrath  (roland@churchy.gnu.ai.mit.edu)

	* window.c (Fdisplay_buffer): Add interactive spec.

1992-06-30  Joseph Arceneaux  (jla@churchy.gnu.ai.mit.edu)

	* mem_limits.h: EXCEEDS_ELISP_PTR declared here.
	* ralloc.c: No longer declared here.
	* vm-limit.c: Nor here.  Also, include "lisp.h" before
	"mem_limits.h" and additionally include "config.h".

1992-06-30  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* xterm.c (x_make_screen_visible): Don't de-iconify the window;
	iconification is orthogonal to visibility.

	* emacs.c (syms_of_emacs): Change docstring for `kill-emacs-hook'
	to describe it as a hook, not as a single function.

1992-06-29  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* minibuf.c (Fread_no_blanks_input): Corrected maximum number of
	arguments from one to two.

	* emacs.c (Vkill_emacs_hook): Declare this here; it should have a
	docstring, so we might as well DEFVAR it.
	(syms_of_emacs): initialize it, and DEFVAR_LISP it with an
	appropriate docstring.

1992-06-28  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* lread.c (Feval_buffer): Make the DEFUN match the C argument
	list; this takes two optional arguments, not just one.

	* lisp.h (Lisp_Buffer_Local_Value): Comments neatened.

	* data.c (Fset): Fixed conditional which tests whether the cache
	is invalid.  It used to be pretty munged, and would always declare
	the cache invalid for Lisp_Buffer_Local_Value variables.  Now it
	declares the cache invalid if the buffer is wrong (obviously), of 

1992-06-27  Jim Blandy  (jimb@pogo.cs.oberlin.edu)

	* data.c (Fset): Comments reformatted for readability.

	* xterm.c (last_mouse_movement_time): New variable.
	(note_mouse_position): Set it.
	(XTmouse_position): Return its current value as the position's
	timestamp.

	* keyboard.c (Qvertical_split): Renamed to `vertical-line',
	since the window arrangement is actually referred to as a
	`horizontal split.'
	(make_lispy_event, make_lispy_movement, syms_of_keyboard): Uses
	renamed here.
	keyboard.h (Qvertical_split): Extern declaration changed here.
	window.c (Fcoordinates_in_window_p): Changed this to return
	`vertical-line' at the appropriate times, rather than
	`vertical-split'.

	* window.c (Fcoordinates_in_window_p): Put symbol names in
	opposing single quotes - `vertical-split', for example.

	* fileio.c (Fexpand_file_name): Don't signal an error if USERNAME
	in a "~USERNAME/..." filename isn't a real user; just leave the
	"~USERNAME" unchanged.

	* fileio.c (Fmake_symbolic_link): Rename argument `NEWNAME' to
	`LINKNAME', to conform with the docstring.

	* Makefile.in (CPP): Pass `-Is -Im' to CPP, to make sure that
	machine- and system-dependend files can include each other
	properly.
	* ymakefile (CFLAGS): Add those directories to the #include path
	here too.

	* Makefile.in (xmakefile): Build this via a temporary file, so
	that if preprocessing fails we don't nuke the xmakefile.

	* fileio.c: There are two versions of Fexpand_file_name defined
	here; the latter is inside a `#if 0' clause.  Change its DEFUN to
	a DEAFUN, so that its docstring doesn't make it into the DOC file
	and supercede the real docstring.

